#!/usr/bin/perl

use DynaLoader;

if($#ARGV < 0) { 
	print "Usage: input.pl tagset_type(0:KAIST or 1:ETRI) output_type(0 : file or 1 : print)date_file \n";
	exit; 
}
$tagset_type = @ARGV[0];

$outputFile = "POS_tri_result";

$ver_context = "w/c";
$ver_prob = "prob";
$max_prev = "max_prev";
$max_prev_prev = "max_prev_prev";

$line_num = 0;
$eojeol = 1;
$eojeol_context = "";
$graph_num = -1;

#added
@G_1 = ();
@G_1_max = ();
@G_1_prev = ();

%tag_set_1gram = ();
%tag_set_2gram = ();
%tag_set_3gram = ();
%word_tag_set_1gram = ();

$word_tag_unseen = 0;

$tag_not_exist = 0;
$tagtag_not_exist = 0;
$wordtag_not_exist = 0;

$kaist_tagtag_file = "";
$erit_tagtag_file = "";
$onelevel_tagtag_file = "";
$kaist_wordtag_file = "";
$erit_wordtag_file = "";
$onelevel_wordtag_file = "";

#print @ARGV[1], "\n";
#$cfg_file = "./tagger.cfg";
if( $#ARGV == 0 ) {
	$cfg_file = "./tagger.cfg";
}
else {
	$cfg_file = @ARGV[1];
}
open(CFG_FILE, "$cfg_file") or die "tagger : Can't Open tagger.cfg!\n";

#Ͽ  д´. 
while(<CFG_FILE>)
{
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;

	($type, $loc) = split(/\=/, $TheLine);

	if($type eq "KAIST_tag_lm")
	{
		$kaist_tagtag_file = $loc;
	}
	elsif($type eq "ETRI_tag_lm")
	{
		$etri_tagtag_file = $loc;
	}
    elsif($type eq "OneLevel_tag_lm")
    {
        $onelevel_tagtag_file = $loc;
    }
    elsif($type eq "KAIST_word_lm")
    {
        $kaist_wordtag_file = $loc;
    }
    elsif($type eq "ETRI_word_lm")
    {
        $etri_wordtag_file = $loc;
    }
    elsif($type eq "OneLevel_word_lm")
    {
        $onelevel_wordtag_file = $loc;
    }
	#print "$type\t$loc\n";
}


if($tagset_type eq 0)
{ 
	open(INFILE, "$kaist_wordtag_file") or die "tagger : can't open KAIST_word_lm! $kaist_wordtag_file AA\n";
}
elsif($tagset_type eq 1)
{ 
	open(INFILE, "$etri_wordtag_file") or die "tagger : can't open ETRI_word_lm!\n";
}
elsif($tagset_type eq 2)
{ 
	open(INFILE, "$onelevel_wordtag_file") or die "tagger : can't open OneLevel_word_lm!\n";
}
else{}


# Ϸ  language model о loadingѴ. 
#word_tag_unseen : unseen 1-gram  
#word_tag_set_1gram : 1-gram 

while(<INFILE>)
{
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;
	if(($TheLine eq "\\unseen-1grams:") or ($TheLine eq "\\1-grams:"))
	{ 
		last; 
	}
}

while(<INFILE>)
{
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;

	if(($TheLine eq "\\1-grams:") or ($TheLine eq ""))
	{
		last; 
	}

	$word_tag_unseen = $TheLine;
}

while(<INFILE>){
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;
	if($TheLine eq "\\1-grams:"){ last; }
}

while(<INFILE>){
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;

	if(($TheLine eq "\\2-grams:") or ($TheLine eq "")){ last; }

	$p2 = 0;
	($p1, $word_tag, $p2) = split(/\t/, $TheLine);
	$word_tag_set_1gram{$word_tag} = [$p1, $p2];
}

close(INFILE);

if($tagset_type eq 0){ 
	open(INFILE2, "$kaist_tagtag_file") or die "tagger : can't open KAIST_tag_lm $kaist_tagtag_file!\n";
	}
elsif($tagset_type eq 1){
	open(INFILE2, "$etri_tagtag_file") or die "tagger : can't open ETRI_tag_lm!\n";
	}
elsif($tagset_type eq 2){
	open(INFILE2, "$onelevel_tagtag_file") or die "tagger : can't open OneLevel_tag_lm!\n";
	}
else{}

while(<INFILE2>){
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;

	if($TheLine eq "\\1-grams:"){ last; } 
}

while(<INFILE2>){
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;

	if(($TheLine eq "\\2-grams:") or ($TheLine eq "")){ last; }

	$p2 = 0;
	($p1, $tag, $p2) = split(/\t/, $TheLine);
       	$tag_set_1gram{$tag} = [$p1, $p2];
}

while(<INFILE2>){
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;

	if($TheLine eq "\\3-grams:"){ last; }
	elsif($TheLine eq ""){ next; }

	$p2 = 0;
	@tmpArray = split(/\t/, $TheLine);
	($p1, $tag, $p2) = split(/\t/, $TheLine);
	($tag1, $tag2) = split(/ /, $tag);
	$index = $tag1."+".$tag2;

	if($#tmpArray eq 2){
		$tag_set_2gram{$index} = [$p1, $p2];
	}
	else{
		$tag_set_2gram{$index} = [$p1, 1];
	}
}
while(<INFILE2>){
	$TheLine = $_;
	chomp($TheLine);
	$TheLine =~ s/\r//g;
	if(($TheLine eq "\\3-grams:") or ($TheLine eq "")){ last; }

	$p3 = 0;
	($p1, $tag, $p2) = split(/\t/, $TheLine);
	($tag1, $tag2, $tag3) = split(/ /, $tag);
	$index = $tag1."+".$tag2."+".$tag3;
	$tag_set_3gram{$index} = [$p1, $p2];
}
close(INFILE2);

$min_prob = -20;

#print "Reading LM completed...\n";



while(<STDIN>){
	$TheLine = $_;

	if($TheLine =~ /<TERM/ ||
	   $TheLine =~ /<\/TERM/ ||
	   $TheLine =~ /<ID/ ||
	   $TheLine =~ /<\/ID/) {
		print "$TheLine\n";
		next;
	}
	chomp($TheLine);
	$TheLine =~ s/\r//g;
	$TheLine =~ s/ //g;


	# ó ϴ  , ʿ  ʱȭѴ. 
	if($TheLine eq "BOS"){

		#added
		$ver_num = 0;

		@G_1 = ();
		@G_1_max = ();
		@G_1_prev = ();

		&add_new_graph($graph_num);
		$if_end = 0;

		next;
	}
	#  . 
	if($TheLine eq "EOS")
	{
		$if_end = 1;

		# ĺ  ϳ ׷ ٸ, 
		#װ Ͽ.  ó .
		# 带 iterateϸ鼭, LM (Ϸκ loadѰ)Ͽ 
		# path Ȯ Ѵ. 
		for($i = 2; $i <= $ver_num; $i++)
		{ 
			&give_prob_to_v($i);
		}
		&give_prob_to_v(1); #$G_1[1] is </s>


		#print "give_prob completed\n";

		&make_result;
		#print "make result completed\n";

		&print_result;
	}

	# ̸  Է Ѿ. 
	if($if_end eq 1){
		next;
	}

	# ΰ, 
	if($TheLine eq ""){
		&input_to_graph;  #   м ĺ graph addѴ. 

		$line_num = 0;
		$eojeol++;

		@input = ();
		next;
	}
	#   м  set input .
	elsif( $TheLine =~ /\t/) 
	{
		$TheLine =~ s/\t//g;
		$input[$line_num] = $TheLine; 
		$line_num++;

	}
	else {
		if($TheLine =~ /^@(.+)/){
			$TheLine = $1;
		}
		elsif( $TheLine =~ /(.+)\/$/){
			$TheLine = $1;
		}
		$eojeol_context = $TheLine;
	}
}

sub give_prob_to_v
{
	my($current_vertex) = shift(@_);

	$max_prob = -10000000;

	#added. $G_1[i][6] is precedecessors
	my(@prev_v1) = split(/\s/, $G_1[$current_vertex][6]);

	#print "@prev_v1\n";

	#added
	if($current_vertex eq 1){
		$current_tag = "</s>";
		$current_word = "</s>";
	}
	else{
		$current_context = $G_1[$current_vertex][0];
		($current_word, $current_tag) = split(/\//, $current_context);
	}


# cfg Ϸ  о帰  ãƺ  
# װ Ȯ ϰ  -10 settingѴ. 
	if(exists($tag_set_1gram{$current_tag})){
		$t1_p1 = $tag_set_1gram{$current_tag}[0];
		$t1_p2 = $tag_set_1gram{$current_tag}[1];
	}
	else {
		$t1_p1 = -10;
		$t1_p2 = -10;
		$tag_not_exist++;
	}
	if(exists($word_tag_set_1gram{$current_context})){
		$w1_p1 = $word_tag_set_1gram{$current_context}[0];
		$w1_p2 = $word_tag_set_1gram{$current_context}[1];
	}
	else {
		$w1_p1 = $word_tag_unseen;
		$w1_p2 = -10;
		$wordtag_not_exist++;
	}

	$max_ver1 = $prev_v1[0];
	$eq_s = 0;

# vertex  precedessor鿡 ؼ 
	foreach $p_v1 (@prev_v1)
	{
		$hash_index = "";

		$prev1_context = $G_1[$p_v1][0]; #$G_1[i][0] is ver_context
		($prev1_word, $prev1_tag) = split(/\//, $prev1_context);

		$prev_prev = 0;
		$max_prev_prob = -10000000;

		$hash_index = $prev1_tag."+".$current_tag;
		$t2_p1 = $tag_set_2gram{$hash_index}[0];
		$t2_p2 = $tag_set_2gram{$hash_index}[1];


	#  vertex װ͵  precedessor Ͽ 
	#2-gram  ˻ϰ װ Ȯ ü ִ´. 
		if($p_v1 eq 0)
		{
			$hash_index = $prev1_tag."+".$current_tag;
			$eq_s = 1;
			if(exists($tag_set_2gram{$hash_index}))
			{
				$t2_p1_s = $tag_set_2gram{$hash_index}[0];
				$t2_p2_s = $tag_set_2gram{$hash_index}[1];
			}
			else 
			{
				$t2_p1_s = -10;
				$t2_p2_s = -10;
				$tagtag_not_exist++;
			}
			$max_prob = $t2_p1_s + $w1_p1 - $t1_p1 + 0;
			$G_1_max[$current_vertex][0] = $max_prob;
			$G_1_prev[$current_vertex][0] = 0;
			#G_1[0] is <s>
			#print "prev_prev\t$current_vertex\t$p_v1\t$prev_prev\t$max_prev_prob\n";
			last;
		}
		else{
		#  vertex װ͵  2level precedessor Ͽ 
		# 3-gram  ˻ϰ װ Ȯ ü ִ´. 
			#added. $G_1[i][6] is precedecessors
			my(@prev_v2) = split(/\s/, $G_1[$p_v1][6]);

			$max_ver2 = $prev_v2[0];
			foreach $p_v2 (@prev_v2){
				#$G_1[i][0] is ver_context
				$prev2_context = $G_1[$p_v2][0];

				($prev2_word, $prev2_tag) = split(/\//, $prev2_context);
				$hash_index = $prev2_tag."+".$prev1_tag."+".$current_tag;

				if(exists($tag_set_3gram{$hash_index})){

					$p3 = $tag_set_3gram{$hash_index}[0];
					($tag1, $tag2, $tag3) = split(/"+"/, $t);

					$index = $tag2."+".$tag3;
					$p2 = $tag_set_2gram{$index}[0];

					$t3_p1 = $tag_set_3gram{$hash_index}[0];
				}
				else {
					$hash_index1 = $prev2_tag."+".$prev1_tag;
					if(exists($tag_set_2gram{$hash_index1})){
						$alpha = $tag_set_2gram{$hash_index1}[1];
					}
					else{
						$alpha = 1;
					}

					$hash_index2 = $prev1_tag."+".$current_tag;
					if(exists($tag_set_2gram{$hash_index2})){
						$tmp_prob = $tag_set_2gram{$hash_index2}[0];
						$t3_p1 = $alpha * $tmp_prob;
					}
					else {
						$alpha2 = $tag_set_1gram{$prev1_tag}[1];
						$tmp_prob = $tag_set_1gram{$prev1_tag}[0];
						$t3_p1 = $alpha * $alpha2 * $tmp_prob;
					}

					$t3_p1 = -10;
					$t3_p2 = -10;
					$tagtag_not_exist++;
				}

				#$prev1_prob = $G->get_attribute("max_"."$p_v2" , $p_v1);
				$prev1_prob = $G_1_max[$p_v1][$p_v2];

				$prob = $prev1_prob + $t3_p1 + $w1_p1 - $t1_p1 + 0;

				if( $prob > $max_prob){
					$max_prob = $prob;
					$max_ver1 = $p_v1;
					$max_ver2 = $p_v2;
				}
				if( $prob > $max_prev_prob){
					$max_prev_prob = $prob;
					$prev_prev = $p_v2;
				}
			} #foreach $p_v2 (@prev_v2)
			#$G->set_attribute("max_"."$p_v1", $current_vertex, $max_prev_prob);
			$G_1_max[$current_vertex][$p_v1] = $max_prev_prob;

			#$G->set_attribute("prev_"."$p_v1", $current_vertex, $prev_prev);
			$G_1_prev[$current_vertex][$p_v1] = $prev_prev;
			#print "prev_prev\t$current_vertex\t$p_v1\t$prev_prev\t$max_prev_prob\n";

		} #end of [else of if($p_v1 eq "<s>")]
	} #end of  [foreach $p_v1 (@prev_v1)]

	if($eq_s eq 0){
		#$G->set_attribute($max_prev, $current_vertex, $max_ver1);
		$G_1[$current_vertex][4] = $max_ver1;
	}
	else{
		#$G->set_attribute($max_prev, $current_vertex, $max_ver1);
		#$G->set_attribute($max_prev_prev, $current_vertex, $max_ver2);
		$G_1[$current_vertex][4] = $max_ver1;
		$G_1[$current_vertex][5] = $max_ver2;
	}

	#if($current_vertex != "<s>"){
	if($current_vertex != 0){
		#$G->set_attribute($ver_prob, $current_vertex, $max_prob);
		$G_1[$current_vertex][1] = $max_prob;
	}
}

# input_to_graph
#  main while loop Է ޾   ¼ м ĺ
# Graph insertϴ sub-function
#   Ǵ Graph ü  G_1̴. 
sub input_to_graph
{

	if($line_num > 0){
	
		@to_s = split(/\s/, $G_1[1][6]);

		# end-of-sentence(G_1[1])  precedessor װ͵ childeren( G_1[1])  . 
		foreach $t (@to_s){
			#$G = $G->delete_path($t, "</s>");
			$G_1[1][6] = "";
			$G_1[$t][7] = "";
		}

	}

	#Ѿ  ¼ м ĺ Ͽ. 
	foreach $line (@input)
	{
		my($tline) = $line;
		$ver_start = $ver_num + 1;

		
		my(@input_ver) = split(/\+/, $tline);

		$prev_v = $ver_start;
		
		#  ¼  ĺ Ͽ. 
		foreach $t_iv (@input_ver){
			#$G = $G->add_vertex($ver_num);
			$ver_num++;

			#$G->set_attribute($ver_context, $ver_num, $t_iv);
			#$G->set_attribute($ver_prob, $ver_num, -10000);
			#$G->set_attribute("eojeol_s", $ver_start, 0);
			$G_1[$ver_num][0] = $t_iv;
			$G_1[$ver_num][1] = 0;
			$G_1[$ver_num][2] = 0;
			$G_1[$ver_num][3] = "";
			$G_1[$ver_num][4] = 0;
			$G_1[$ver_num][5] = 0;
			$G_1[$ver_num][6] = "";
			$G_1[$ver_num][7] = "";


			#  vertex ؼ   缭 ũ Ѵ. 
			if( $prev_v eq $ver_num){
				;
			}
			else 
			{
				#$G = $G->add_path($prev_v, $ver_num);

				if($G_1[$prev_v][7] eq ""){
					$G_1[$prev_v][7] = "$ver_num";
				}
				else {
					$G_1[$prev_v][7] = $G_1[$prev_v][7]." $ver_num";
				}

				if($G_1[$ver_num][6] eq ""){
					$G_1[$ver_num][6] = "$prev_v";
				}
				else {
					$G_1[$ver_num][6] = $G_1[$ver_num][6]." $prev_v";
				}
			}

			$prev_v = $ver_num;
			#$ver_num++;
		}
		$ver_end = $ver_num;


		#  Էϱ   ( </s> vertex) precedessor 鿡   node Ѵ. 
		foreach $v (@to_s){
			#$G = $G->add_path($v, $ver_start);
			if($G_1[$v][7] eq ""){
				$G_1[$v][7] = "$ver_start";
			}
			else {
				$G_1[$v][7] = $G_1[$v][7]." $ver_start";
			}

			if($G_1[$ver_start][6] eq ""){
				$G_1[$ver_start][6] = "$v";
			}
			else {
				$G_1[$ver_start][6] = $G_1[$ver_start][6]." $v";
			}
		}

		#print "prece\t$ver_start\t$G_1[$ver_start][6]\n";

		#$G = $G->add_path($ver_end, "</s>");
		#$G->set_attribute("eojeol_s", $ver_start, 1);
		#$G->set_attribute("eojeol_c", $ver_start, $eojeol_context);

		$G_1[$ver_end][7] = "1";

		if($G_1[1][6] eq ""){
			$G_1[1][6] = "$ver_end";
		}
		else {
			$G_1[1][6] = $G_1[1][6]." $ver_end";
		}

		$G_1[$ver_start][2] = 1;
		$G_1[$ver_start][3] = $eojeol_context;
	}
}
# Graph ִ 峻  ¼ ĺ path, 
# maximum possibilityΰ ϴ Լ
# õ ĺ path ̿ path  ȴ. 
sub make_result
{

	#$max_ver = $G->get_attribute($max_prev, "</s>");
	$max_ver = $G_1[1][4]; #$G_1[i][4] is max_prev

	#$current_ver = "</s>";
	$current_ver = 1;

	#$tmp_max_ver = $G->get_attribute($max_prev, $current_ver);
	$tmp_max_ver = $G_1[1][4];

	#$tmp_max_ver_prev = $G->get_attribute("prev_"."$tmp_max_ver", $current_ver);
	$tmp_max_ver_prev = $G_1_prev[1][$tmp_max_ver];

	while(1)
	{
		#@t_prev = $G->predecessors($current_ver);
		my(@t_prev) = split(/\s/, $G_1[$current_ver][6]);

		#foreach $t_ver (@t_prev){
		#	if($t_ver != $tmp_max_ver){
		#		$G->delete_vertex($t_ver);
		#	}
		#}

		foreach $t_ver (@t_prev){
			if($t_ver eq $tmp_max_ver){
				$G_1[$current_ver][6] = "$t_ver";
			}
		}

		#print "cur_ver\t$current_ver\n";
		#print "prev_ver\t$tmp_max_ver_prev\n";

		$current_ver = $tmp_max_ver;

		if($current_ver eq 0){ 
			last;
		}

		$tmp_max_ver = $tmp_max_ver_prev;

		#$tmp_max_ver_prev = $G->get_attribute("prev_"."$tmp_max_ver", $current_ver);
		$tmp_max_ver_prev = $G_1_prev[$current_ver][$tmp_max_ver];
	}
}

# make_resultԼ  Graph ,  ¼Һм 
# ϴ Լ. 
sub print_result
{

	#$max_ver = $G->get_attribute($max_prev, "</s>");
	$max_ver = $G_1[1][4]; #$G_1[i][4] is max_prev

	$result = "";
	#@result = ();

	$current_ver = 1;
	while(1)
	{
		#my(@tmp_ver) = $G->predecessors($current_ver);
		my(@tmp_ver) = split(/\s/, $G_1[$current_ver][6]);
		

		if($#tmp_ver != 0){
			print "oops...odd\t$current_ver\t$G_1[$current_ver][6]\n";
			last;
		}

		$current_ver = $tmp_ver[0];

		if($current_ver eq 0){ last; }

		#$current_context=$G->get_attribute($ver_context, $current_ver);
		$current_context=$G_1[$current_ver][0];

		#$current_prob = $G->get_attribute($ver_prob, $current_ver);
		$current_prob = $G_1[$current_ver][1];

		#$e_s = $G->get_attribute("eojeol_s", $current_ver);
		$e_s = $G_1[$current_ver][2];

		if(not (($current_ver eq 0) or ($current_ver eq 1))){
			if( $e_s eq 1){
				#$t_s=$G->get_attribute("eojeol_c",$current_ver);
				$t_s = $G_1[$current_ver][3];

				$result="\n".$t_s."\t".$current_context.$result;
				#$result=$t_s."\t".$current_context.$result;
				#$result = $result."\n";
				#unshift(@result,("\n".$t_s."\t".$current_context));
			}
			else { 
				$result =  "\+$current_context".$result;
				#unshift(@result, ($current_context));
			}
		}
	}
	print "$result\n";
	#print "end of print_result\n";
	#print "@result\n";
}

#Graph ü ʱȭϴ Լ, 
#vertex_num = 0̸  
#1̸   Ÿ  Ѵ. 

sub add_new_graph
{
	my($current_G) = shift(@_);

	#added	for <s>
	
	$G_1[0][0] = "<s>/<s>"; 
	$G_1[0][1] = 0;
	$G_1[0][2] = 0;
	$G_1[0][3] = "";
	$G_1[0][4] = 0;
	$G_1[0][5] = 0;
	$G_1[0][6] = "";    
	$G_1[0][7] = "1";	

	#added for </s>
	$G_1[1][0] = "</s>/</s>";
	$G_1[1][1] = 0;
	$G_1[1][2] = 0;
	$G_1[1][3] = "";
	$G_1[1][4] = 0;
	$G_1[1][5] = 0;
	$G_1[1][6] = "0";
	$G_1[1][7] = "";
	$ver_num = 1;

}
