#!/usr/local/bin/perl
use Getopt::Std;

$BLANK = "BNK/bnk";

if ($#ARGV != 0) { 
	print "ExtCollocation corpus_file\n"; 
	print exit; 
}

#   
$corpus_name = $ARGV[0];

open(IN, $corpus_name) || die "Can't open $corpus_name";
while(<IN>) {
    if ($_ =~ /^</) { next; }
    if ($_ =~ /^;/) { next; }

	#   ± 
	#chomp;
	$_ =~ s/nq\[//g;
	$_ =~ s/\]nq//g;

	if ($_ =~ /.\/sf/ or $_ =~ /^[ ]*$/) {
			&ExtCollo(@sentence, @tagged_sentence);
			@sentence = ();
			@tagged_sentence = ();
			next;
	}

    #  쿡..
    ($num, $wp, $tagged_wp) = split(' ', $_);
    if ($#sentence < 0) {
        push(@sentence, $wp);
        push(@tagged_sentence, split(/\+/, $tagged_wp));
    }
    else {
        push(@sentence, $wp);
        #push(@tagged_sentence, $BLANK);
        push(@tagged_sentence, split(/\+/, $tagged_wp));
    }
}

sub ExtCollo {
    my($sentence) = shift(@_);
    my($tagged_sentence) = @{@_[1]};
    my($wp_cnt, $idx);

	for($i=0; $i<$#tagged_sentence+1; $i++) {
		for($j=$i+1; $j<$#tagged_sentence+1; $j++) {
			print $tagged_sentence[$i], " ", $tagged_sentence[$j], "\n";
		}
	}
}

