#!/usr/local/bin/perl
use Getopt::Std;

$BLANK = "BNK/bnk";

do getopts('an:');
if ($opt_a) { $mode = 'a'; }
if ($opt_n) { $ngram = $opt_n; }
else { $ngram = 1; } 
if ($#ARGV != 0 or ($opt_a and $opt_n)) { 
	print "MakeStat [-a] [-n gram_num] corpus_file\n"; 
	print "	-a: /npp ..  P(W|T)   ش.\n"; 
	print "	-n #: P(Ti|Tj)   ش.\n";
	print "  ɼ Ѳ   .\n";	
	print exit; 
}

#   
$corpus_name = $ARGV[0];

open(IN, $corpus_name) || die "Can't open $corpus_name";
while(<IN>) {
    if ($_ =~ /^</) { next; }
    if ($_ =~ /^;/) { next; }

	#   ± 
	#chomp;
	$_ =~ s/nq\[//g;
	$_ =~ s/\]nq//g;

	if ($_ =~ /.\/sf/ or $_ =~ /^[ ]*$/) {
			push(@tagged_sentence, "EOS/eos");  
			&MakeStat(@sentence, @tagged_sentence);
			@sentence = ();
			@tagged_sentence = ();
			next;
	}

    #  쿡..
    ($num, $wp, $tagged_wp) = split(' ', $_);
    if ($#sentence < 0) {
        push(@sentence, $wp);
        push(@tagged_sentence, split(/\+/, $tagged_wp));
    }
    else {
        push(@sentence, $wp);
        push(@tagged_sentence, $BLANK);
        push(@tagged_sentence, split(/\+/, $tagged_wp));
    }
}

#   ´.
if ($mode eq 'a') {
	@allkeys = sort(keys(%p_wt_hash));
	foreach $key (@allkeys) {
		($morph, $tag) = split(/\//, $key);
		if ($p_t_hash{$tag} != 0) { 
		print $key," ",log($p_wt_hash{$key}/$p_t_hash{$tag}),"\n"; 	
		}
	}
} 
else {
	@allkeys = sort(keys(%ngram_tag_cnt));
	foreach $key (@allkeys) {
		($pre_tag, $cur_tag) = split(/-/, $key);
		if ($p_t_hash{$pre_tag} != 0) { 
		print $key," ",log($ngram_tag_cnt{$key}/$p_t_hash{$pre_tag}),"\n"; 	
		}
	}
}
@allkeys = sort(keys(%p_t_hash));
foreach $key (@allkeys) {
	print $key," ",$p_t_hash{$key},"\n"; 	
}

sub MakeStat {
    my($sentence) = shift(@_);
    my($tagged_sentence) = @{@_[1]};
    my($wp_cnt, $idx);

#print "TAGGED = ", join('|',@tagged_sentence), "\n";

	for($i=0; $i<$#tagged_sentence+1; $i++) {
		($morph, $tag) = split(/\//, $tagged_sentence[$i]);

		if ($mode eq 'a') {
			$p_wt_hash{$tagged_sentence[$i]}++;
			$p_t_hash{$tag}++;
			next;
		}

		# n-gram 
		$pre = "";
		for ($j=$i-$ngram+1; $j<$i; $j++) {
			if ($j<0) { $pre .= "eos"; }
			else {
				($tmp, $pretag) = split(/\//, $tagged_sentence[$j]);
				$pre .= $pretag; 
			}
			if ($j == $i-1) { $pre .= '-'; } 
			else { $pre .= "|"; }
		}
		if ($pre eq "") { $ngram_tag_cnt{$tag}++; }
		else { $ngram_tag_cnt{$pre.$tag}++; 
			$p_t_hash{substr($pre, 0, length($pre)-1)}++; 
		}
	}
}

