#!/usr/bin/perl
use Getopt::Std;

$BLANK = "BNK/bnk";

do getopts('an:');
if ($opt_a) { $mode = 'a'; }
if ($opt_n) { $ngram = $opt_n; }
else { $ngram = 1; } 
if ($#ARGV != 0 or ($opt_a and $opt_n)) { 
	print "MakeWPStat [-n gram_num] corpus_file\n"; 
	print " ± n Gram ̾ش.\n";
	print "	-n #: P(Ti|Tj)   ش.\n";
	print exit; 
}

#   
$corpus_name = $ARGV[0];

open(IN, $corpus_name) || die "Can't open $corpus_name";
while(<IN>) {
    if ($_ =~ /^</) { next; }
    if ($_ =~ /^;/) { next; }

	#   ± 
	#chomp;

	if ($_ =~ /.\/sf/ or $_ =~ /^[ ]*$/) {
			push(@tagged_sentence, "SF");  
			&MakeStat(@sentence, @tagged_sentence);
			@sentence = ();
			@tagged_sentence = ();
			next;
	}

    #  쿡..
	@splitted = split(' ', $_);
	$wp = $splitted[1];
	$wptag = $splitted[$#splitted];
	if ($#sentence < 0) { push (@tagged_sentence, "SF"); }
	push(@sentence, $wp);
	if ($wptag eq "f") { push(@tagged_sentence, ".."); }
	{ push(@tagged_sentence, $wptag); }
}

#   ´.
@allkeys = sort(keys(%ngram_tag_cnt));
foreach $key (@allkeys) {
	($pre_tag, $cur_tag) = split(/-/, $key);
	if ($p_t_hash{$pre_tag} == 0) {
		print "0  մϴ. $tag, $pre_tag\n";
	} else {
		print $key," ",log($ngram_tag_cnt{$key}/$p_t_hash{$pre_tag}),"\n"; 	
	}
}

@allkeys = sort(keys(%p_t_hash));
foreach $key (@allkeys) {
	print $key," ",$p_t_hash{$key},"\n"; 	
}


sub MakeStat {
    my($sentence) = shift(@_);
    my($tagged_sentence) = @{@_[1]};
    my($wp_cnt, $idx);

#print "SENT = [$#sentence] ", join('|',@sentence), "\n";
#print "TAGGED = [$#tagged_sentence] ", join('|',@tagged_sentence), "\n";

	for($i=0; $i<$#tagged_sentence+1; $i++) {
		$tag = $tagged_sentence[$i];

		# n-gram 
		$pre = "";
		for ($j=$i-$ngram+1; $j<$i; $j++) {
			if ($j<0) { $pre .= "SF"; }
			else {
				$pre .= $tagged_sentence[$j];
			}
			if ($j == $i-1) { $pre .= '-'; } 
			else { $pre .= "|"; }
		}
		if ($pre eq "") { $ngram_tag_cnt{$tag}++; }
		else { $ngram_tag_cnt{$pre.$tag}++; 
			$p_t_hash{substr($pre, 0, length($pre)-1)}++; 
		}
	}
}

