#include <stdio.h>
#include <string.h>
#include "global.h"
#include "tags.h"
#include "cnt.h"
#include "malib.h"
#include "trie.h"
#include "wjhcode.h"
#include "simti.h"

/* 
 * option  flag 
 */
int longest=0;
int unk_anal=0;
int unk_expand=0;
int indexing=0;
int top_down=0;
/*
 * option flag   
 */

int IWG;
int UNK;
int UNK_SET;
int NUM_TAG;

MDIC *sys_dict;
MDIC *user_dict;
SIMTI *sf;

char *index_tag;		/* for indexing */

/*------------------------------ 
ξ Ǵ ǰ Ʈ
------------------------------*/
set_index_tag()
{
	index_tag=tset[tsetnum("index")];
}

/*---------------------------------------------------------------------- 
is_index(tnum)
	ξ Ǵ ǰ ˻ 
	ణ tool  Ƿ
	matools.c    ִ.
----------------------------------------------------------------------*/
int is_index(int tag)
{
	int i;

	for(i=0;index_tag[i];i++)
		if(index_tag[i]==tag)
			return YES;
	return NO;
}

#define TAG_TYPE_ALL         0
#define TAG_TYPE_VERBS       1
#define TAG_TYPE_NOUNS       2
#define TAG_TYPE_NPS         3
#define TAG_TYPE_ADJS        4
#define TAG_TYPE_NBNP        8
#define TAG_TYPE_JOSA        9
#define TAG_TYPE_YONGS       10
#define TAG_TYPE_EOMIES      11
#define TAG_TYPE_JP      	 12

unsigned char tag_types[20][100];
int set_tag_types()
{
		int i;
        strcpy(tag_types[TAG_TYPE_VERBS],tset[tsetnum("pv")]);
        strcat(tag_types[TAG_TYPE_VERBS],tset[tsetnum("xsm")]);
        i=strlen(tag_types[TAG_TYPE_VERBS]);
        tag_types[TAG_TYPE_VERBS][i++]=tagnum("px");
        tag_types[TAG_TYPE_VERBS][i++]=0;

        strcpy(tag_types[TAG_TYPE_NOUNS],tset[tsetnum("n")]);
        strcpy(tag_types[TAG_TYPE_NPS],tset[tsetnum("np")]);
        strcpy(tag_types[TAG_TYPE_ADJS],tset[tsetnum("pa")]);
        strcpy(tag_types[TAG_TYPE_EOMIES],tset[tsetnum("e")]);

        strcpy(tag_types[TAG_TYPE_YONGS],tset[tsetnum("p")]);
        strcat(tag_types[TAG_TYPE_YONGS],tset[tsetnum("xsv")]);
        strcat(tag_types[TAG_TYPE_YONGS],tset[tsetnum("xsm")]);
        i=strlen(tag_types[TAG_TYPE_YONGS]);
        tag_types[TAG_TYPE_YONGS][i++]=tagnum("ep");
        tag_types[TAG_TYPE_YONGS][i++]=tagnum("jp");
        tag_types[TAG_TYPE_YONGS][i++]=0;
		
		i=0;
        tag_types[TAG_TYPE_JP][i++]=tagnum("jp");
        tag_types[TAG_TYPE_JP][i++]=0;

		i=0;// 
        tag_types[TAG_TYPE_NBNP][i++]=tagnum("nbn");
        tag_types[TAG_TYPE_NBNP][i++]=tagnum("npd");
        tag_types[TAG_TYPE_NBNP][i++]=tagnum("npp");
        tag_types[TAG_TYPE_NBNP][i++]=0;

		i=0;
        tag_types[TAG_TYPE_JOSA][i++]=tagnum("jxc");
        tag_types[TAG_TYPE_JOSA][i++]=tagnum("jco");
        tag_types[TAG_TYPE_JOSA][i++]=tagnum("jca");
        tag_types[TAG_TYPE_JOSA][i++]=tagnum("jcm");
        tag_types[TAG_TYPE_JOSA][i++]=tagnum("jcs");
        tag_types[TAG_TYPE_JOSA][i++]=tagnum("jcc");
        tag_types[TAG_TYPE_JOSA][i++]=0;
}

char cfg_file[1024];
char tag_file[1024];
char cnt_file[1024];
char sdict_file[1024];
char udict_file[1024];
char ana_file[1024];

void rem_space(char *buf)
{
	char temp[1024];
	char *p;
	int s;
	s = 0;
	for (p=buf;p!=NULL&&*p!='\0';p++)
		if (*p!=' '&&*p!='
'&&*p!='\t'&&*p!='\n') {
			temp[s++]=*p;
		}
	temp[s]='\0';
	strcpy(buf,temp);
}
void
read_param(FILE *cfg)
{
	char buf[1024];

	/* default file name assginment */
	strcpy(tag_file,"/home/wjlee/new_hm/data/tags_1.stf");
	strcpy(cnt_file,"/home/wjlee/new_hm/data/cnt_1.scf");
	strcpy(sdict_file,"/home/wjlee/new_hm/data/dict/morph");
	strcpy(udict_file,"/home/wjlee/new_hm/data/userdict/user");
	strcpy(ana_file,"/home/wjlee/study/ma990818/analyzed");

	if (cfg==NULL) return;
	/* reading the configuration file - ma.cfg */
	while (fgets(buf,1024,cfg)!=NULL) {
		rem_space(buf);
		if (!strncmp(buf,"sysdict=",8)) 
			strcpy(sdict_file,buf+8);
		else if (!strncmp(buf,"userdict=",9)) 
			strcpy(udict_file,buf+9);
		else if (!strncmp(buf,"cnt=",4)) 
			strcpy(cnt_file,buf+4);
		else if (!strncmp(buf,"tagset=",7))
			strcpy(tag_file,buf+7);
		else if (!strncmp(buf,"analyzed=",9))
			strcpy(ana_file,buf+9);
	}

	fclose(cfg);
}
/*----------------------------------------------------------------------
initinalize
----------------------------------------------------------------------*/
init_morph()
{
/* Added by cwseo form here */
	FILE *cfg;

	cfg=fopen(cfg_file,"r");

	read_param(cfg);

	if (cfg != NULL) {

    	tagread(tag_file);
    	cntread(cnt_file);
    	if(indexing)
		set_index_tag();
        	set_tag_types();

	    IWG=tagnum("iwg");
		if(unk_anal)
			UNK=tagnum("unk");
		if(unk_expand)
			UNK_SET=tsetnum("unk_set");
	   	NUM_TAG=tagnum("nnc");
    	sys_dict=mdic_open(sdict_file,'r');
   		user_dict=mdic_open(udict_file,'r');
    
	    /* rule */
   		sf=simti_init();
		init_rule();

		return;
	}
/* to here ========================== */
    tagread("/home/wjlee/new_hm/data/tags_1.stf");
    cntread("/home/wjlee/new_hm/data/cnt_1.scf");
    if(indexing)
	set_index_tag();
        set_tag_types();

    IWG=tagnum("iwg");
	if(unk_anal)
		UNK=tagnum("unk");
	if(unk_expand)
		UNK_SET=tsetnum("unk_set");
    NUM_TAG=tagnum("nnc");
    sys_dict=mdic_open("/home/wjlee/new_hm/data/dict/morph",'r');
    user_dict=mdic_open("/home/wjlee/new_hm/data/userdict/user",'r');
    
    /* rule */
    sf=simti_init();
	init_rule();
}

close_morph()
{
    mdic_close(sys_dict);
    if(user_dict !=NULL)
    mdic_close(user_dict);
    simti_close(sf);
}

/* segpos
   input string  : 
   0(iwg), 1(), 2(), 3(iwg), 4(), 5()

segment 
   input string  : 
   0(iwg), 1(), 2(), 3(iwg), 4(), 5()
   dict lookup result : x-nopath, .-path, else-dict_ok
   x
   	   .      	 x
   	   	  x
		  	 x
		                 .      
				        x
*/
#define MAX_MORPHEME_LINK	30

#define SP_STATE_N	0	
#define SP_STATE_D	1	
#define SP_STATE_R	2	
#define SP_STATE_M	3	
#define SP_STATE_F	4	

typedef struct SegPos {		// segment position
    int key;				// one character
    int state;
    int next_pos; 			// next position link
    int sidx;
    int uidx;
    int nidx;
    int morph_count;
    int morpheme[MAX_MORPHEME_LINK];	// see MORPHEME
} SegPos;

#define MAX_SEGMENT 200  /*   ϸ .. ϴ.*/
SegPos	seg_pos[MAX_SEGMENT];
int	seg_pos_end=0;

typedef struct MORPHEME {	// ¼ м chart 
    int tag;				// tag of morphme
    int phone;
    int next_pos;			// next segment position
    int next_tag_type;			// ǰ 
    int state;				// processing state
    int cnt_count;	
    int connection[MAX_MORPHEME_LINK];	// connected morpheme
    char str[MAX_SEGMENT];
} MORPHEME;


/*----------------------------------------------------------------------
lattice style chart
----------------------------------------------------------------------*/

print_segment_pos()
{
	int i;
	fprintf(stderr,"seg_pos_end=%d\n",seg_pos_end);
	for(i=1;i<seg_pos_end;i++)
	{
		fprintf(stderr,"seg_pos[%d].key=%d link=%d\n",
			i,seg_pos[i].key,seg_pos[i].next_pos);
	}
}

MORPHEME mchart[1000];
int	mchart_end=0;

int new_chart(int tag, int phone, int next_pos, int next_tag_type)	// check
{
	mchart[mchart_end].tag=tag;
	mchart[mchart_end].phone=phone;
	mchart[mchart_end].next_pos=next_pos;
	mchart[mchart_end].next_tag_type=next_tag_type;
	mchart[mchart_end].state=INCOMPLETE;	//  м ʿ
	mchart[mchart_end].cnt_count=0;
	return mchart_end++;
}

exist_chart(int morpheme[],int count, int mtag, int phone, int next, int btag, char *str)
{
	int i;
	for(i=0;i<count;i++)
	{
		if( mchart[morpheme[i]].tag==mtag &&
			mchart[morpheme[i]].phone==phone &&
			mchart[morpheme[i]].next_pos==next &&
			mchart[morpheme[i]].next_tag_type==btag &&
			strcmp(mchart[morpheme[i]].str,str)==0)
				return 1;
	}
	return 0;
}
int next_pos(int x)
{
    return seg_pos[x].next_pos;
}

/*----------------------------------------------------------------------*/

int new_segment_pos(int key)	// check
{
	seg_pos[seg_pos_end].key=key;
	seg_pos[seg_pos_end].state=SP_STATE_N;
	seg_pos[seg_pos_end].morph_count=0;
	seg_pos[seg_pos_end].next_pos=0;
	return seg_pos_end++;
}

int seg_pos_link(int old_sp,int new_sp)		// check
{
    seg_pos[old_sp].next_pos=new_sp;
    return old_sp;
}

init_segment(char *str)		// checked
{
	int new_sp,old_sp;
	int i=0;
	char rev[MAX_SEGMENT];

    simti_clean(sf);

	seg_pos_end=0;
	old_sp=new_segment_pos(0);
	seg_pos[old_sp].state=SP_STATE_M;
	while(*str)
	{
		new_sp=new_segment_pos(*str);
		seg_pos_link(old_sp,new_sp);
		old_sp=new_sp;
		rev_str(str,rev);

		simti_insert(sf,rev,new_sp);
		str++;
	}
	/* ܾ  Ÿ ġμ  */
	seg_pos_link(old_sp,0);
}

init_chart()	//check
{
	mchart_end=0;
	seg_pos[0].morpheme[seg_pos[0].morph_count++]=mchart_end;
	mchart[mchart_end].tag = IWG;
	mchart[mchart_end].phone=0;
	mchart[mchart_end].next_pos = 1;
	mchart[mchart_end].next_tag_type=0;
	mchart[mchart_end].state=SUCCESS;	//   ǹ̷μ
	mchart[mchart_end].cnt_count=0;
	mchart[mchart_end].str[0]=0;
	mchart_end++;
}

int phone_type_check(int ptype, int phone)
{
	if(ptype==0)
		return 1;
	return ptype==phone;
}

int tag_type_check(int ttype, int tag)
{
	int i;
	if(ttype==0)
		return 1;
	for(i=0;tag_types[ttype][i];i++)
		if(tag_types[ttype][i]==tag)
			return 1;
	return 0;
}

int alt_segment(char *str)
{
	int old_sp=0;
	int new_sp=0;
	int match;
	int len;
	int to;
	char *p;
	char rev[MAX_SEGMENT];

	len=strlen(str);
	rev_str(str,rev);
	match=simti_search(sf,rev);
	rev[match]=0;
	to=simti_fetch(sf,rev);

	p=str;
	while(*p)
	{
		if(len<=match)
			break;
		new_sp=new_segment_pos(*p);
		if(old_sp)
			seg_pos_link(old_sp,new_sp);
		old_sp=new_sp;
		rev_str(p,rev);
		simti_insert(sf,rev,new_sp);
		p++; len--;
	}
	if(old_sp)
		seg_pos_link(old_sp,to);
	rev_str(str,rev);
	return simti_fetch(sf,rev);
}

phone_change(int from, char *front, char *back, int ftag, int btag, int phone)
{
	INFO ibuff[20];
	int isize;
	int i,x,y;
	int next;
	int nc_idx;

	// 1. պκ  ˻
	isize=mdic_fetch(sys_dict,front,ibuff);
	for(i=0;i<isize;i++)
	{
		//2. պκ ǰ 
		x=tag_type_check(ftag,ibuff[i].mtag);
		//3. պκ  
		y=phone_type_check(phone,ibuff[i].phone);

		if(x&&y)
		{
			next=alt_segment(back);
							//޺κ ǰ 
			/* next ٸ ٸ  ϴµ... */
			if(!exist_chart(seg_pos[from].morpheme,seg_pos[from].morph_count,ibuff[i].mtag,ibuff[i].phone,next,btag,front))
			{
				int x;
			nc_idx= new_chart(ibuff[i].mtag,ibuff[i].phone,next,btag);
			strcpy(mchart[nc_idx].str,front);
			/*
			for(x=0;x<seg_pos[from].morph_count;x++)
				if(seg_pos[from].morpheme[x]==nc_idx)
					break;
			if(x==seg_pos[from].morph_count)
			*/

			seg_pos[from].morpheme[seg_pos[from].morph_count++]=nc_idx;
			}
		}
	}
}

/*
prule(int from, char *prev, char *mstring)
{
    char front[256];
    char back[256];
	int ftag, btag;
	int phone;

	if(from!=1)
		return;
	coco_str(KS,TRI,"Ƹ",front);
	coco_str(KS,TRI,"",back);
	ftag=TAG_TYPE_ADJS;
	btag=TAG_TYPE_EOMIES;
	phone=irrnum("irrb");
	phone_change(from,front,back,ftag,btag,phone);
}
*/

#include "exp3.c"
#define CNTLevel 0

//char CTBL[100][100];
int Con_Check(int chart1, int chart2) // check
{
    int t1,t2;
    t1=mchart[chart1].tag;
    t2=mchart[chart2].tag;
    return (ctable[t1][t2/8] & (1 << (t2%8))) 
	&& tag_type_check(mchart[chart1].next_tag_type,t2);
//    return (CTBL[t1][t2] > CNTLevel);

}

/* ڸ ãƳ  丶Ÿ */
unsigned char num_automata[13][7]={
/*      ACC, +, -, ., ,, n, etc.     */
        { 0, 0, 0, 0, 0, 0, 0}, /* 0 */
        { 0, 9, 9, 0, 0, 2, 0}, /* 1 */
        { 1, 0, 0,11, 5, 3, 0}, /* 2 */
        { 1, 0, 0,11, 5, 4, 0}, /* 3 */
        { 1, 0, 0,11, 5,10, 0}, /* 4 */
        { 0, 0, 0, 0, 0, 6, 0}, /* 5 */
        { 0, 0, 0, 0, 0, 7, 0}, /* 6 */
        { 0, 0, 0, 0, 0, 8, 0}, /* 7 */
        { 1, 0, 0, 0, 5, 0, 0}, /* 8 */
        { 0, 0, 0, 0, 0,10, 0}, /* 9 */
        { 1, 0, 0,11, 0,10, 0}, /* 10 */
        { 1, 0, 0, 0, 0,12, 0}, /* 11 */
        { 1, 0, 0, 0, 0,12, 0}  /* 12 */
};

int ndic_node_look(int c, int nidx)
{
        int inp;
	switch(c)
	{
		case '+' : inp=1; break;
		case '-' : inp=2; break;
		case '.' : inp=3; break;
		case ',' : inp=4; break;
		default  : 
			if(isdigit(c))
				inp=5; 
			else
				inp=6;
	}
	return num_automata[nidx][inp];
}

char mstring[MAX_SEGMENT];
char mstring2[MAX_SEGMENT];
int seg_path[MAX_SEGMENT];

int anal_chart(int chart_id, int ttype)
{
    int from, to;
    int i,j,x,y;
    int mp;
    int c;
    int nc_idx;
    TNODE *tnode;
    INFO *inode;
    IDX info;
    int isize;
    IDX sidx=1;
    IDX uidx=1;
    IDX nidx=1;

    from=mchart[chart_id].next_pos;
    switch(seg_pos[from].state)			// N,D,R,M,F
    {
	default :
	    return 0;
	case SP_STATE_N :
	    i=0;
	    for(to=from;to;to=next_pos(to))	//  ˻
	    {
		c=seg_pos[to].key;
		if(sidx)
		    sidx=mdic_node_look(sys_dict,c,sidx);
		if(user_dict != NULL && uidx)
		    uidx=mdic_node_look(user_dict,c,uidx);
		if(nidx)
		    nidx=ndic_node_look(c,nidx);
		seg_pos[to].sidx=sidx;
		seg_pos[to].uidx=uidx;
		seg_pos[to].nidx=nidx;
		mstring[i]=c;
		seg_path[i++]=to;
	    }
	    nidx=0;
	    mstring[i]=0;
	    strcpy(mstring2,mstring);

	    for(;i>0;i--)			//    
	    {
		mstring[i]=0;
		to=seg_path[i-1];
		if(seg_pos[to].sidx)
		{
		    tnode = mdic_node(sys_dict,seg_pos[to].sidx);
		    info=tnode->info_idx;
		    isize=tnode->info_size;
		    for(j=0;j<isize;j++)
		    {
				inode=mdic_info(sys_dict,info+j);
				nc_idx= new_chart(inode->mtag, inode->phone, next_pos(to),0);
				strcpy(mchart[nc_idx].str,mstring);
				seg_pos[from].morpheme[seg_pos[from].morph_count++]=nc_idx;
		    }
		}
		if(user_dict != NULL && seg_pos[to].uidx)
		{
		    tnode = mdic_node(user_dict,seg_pos[to].uidx);
		    info=tnode->info_idx;
		    isize=tnode->info_size;
		    for(j=0;j<isize;j++)
		    {
				inode=mdic_info(user_dict,info+j);
				nc_idx= new_chart(inode->mtag, inode->phone,next_pos(to),0);
				strcpy(mchart[nc_idx].str,mstring);
				seg_pos[from].morpheme[seg_pos[from].morph_count++]=nc_idx;
		    }
		}
		if(nidx==0 && seg_pos[to].nidx)
		{
		    if(num_automata[seg_pos[to].nidx][0])
		    {
				nc_idx= new_chart(NUM_TAG, 0, next_pos(to),0);
				strcpy(mchart[nc_idx].str,mstring);
				seg_pos[from].morpheme[seg_pos[from].morph_count++]=nc_idx;
				nidx=seg_pos[to].nidx;
		    }
		    else
				nidx=0;
		}
	    }
	    seg_pos[from].state=SP_STATE_D;
	case SP_STATE_D :		
		prule(from, mchart[chart_id].str, mstring2);

	    seg_pos[from].state=SP_STATE_R;
	case SP_STATE_R :
			/* ̵Ͼ óϴ  ⼭  ȴ.
			 *  ȣ ִٸ ⿡ ۵ȴ.
			 * M(ϴ) --> D()+M(ϴ)
			 */
	    x=0;
	    for(i=0;i<seg_pos[from].morph_count;i++)
	    {
			mp=seg_pos[from].morpheme[i];

			/* ϴ' ȣ  ؼ...
			 * ̺κ Ϻ   ٰŴ.
			 */
			if(tag_type_check(ttype,mchart[mp].tag) == 0)
				continue; 

			/* ̺κ 'ٺ'   '' ߺ  Ǵ 
			 * ´.
			 * ٺ+
			 *     ++
			 */
			if(mchart[mp].state==INCOMPLETE)
			{
				y=anal_chart(mp,mchart[mp].next_tag_type);
				x+=y;
				if(y)
					mchart[mp].state=SUCCESS;
				else
					mchart[mp].state=FAIL;
			}
			else
				x+=mchart[mp].cnt_count;
		}
		if(x==0)
		{
			// ' 
			if(!ttype) // κ ǰ縸   ߿ ٽؾ Ѵ.
				seg_pos[from].state=SP_STATE_F;
			return 0;
		}
		if(!ttype) // κ ǰ縸   ߿ ٽؾ Ѵ.
			seg_pos[from].state=SP_STATE_M;
	case SP_STATE_M :
	    for(i=0;i<seg_pos[from].morph_count;i++)
	    {
			mp=seg_pos[from].morpheme[i];
			//	    chart mp  success ˻ؾߵ
			if(mchart[mp].state==SUCCESS && Con_Check(chart_id,mp))
			{
				mchart[chart_id].connection[mchart[chart_id].cnt_count++]=mp;
				if(longest)
					break;
			}
	    }
    }
    return mchart[chart_id].cnt_count;
}

/*
   
   /unk+/jcc	--	簡 ִ  ؾѴ.
   /unk+/jcs	--
   /unk
*/
int anal_chart_unk()
{
	int i,j;
	int nc_idx;

	for(i=1;i;i=next_pos(i))
	{
	    mstring[i-1]=seg_pos[i].key;
	    if(is_tri_co(seg_pos[i].key))
		continue;

		mstring[i]=0;
		if(unk_expand)
		{
			for(j=0;tset[UNK_SET][j];j++)
			{
				nc_idx = new_chart(tset[UNK_SET][j],0,next_pos(i),0);
				strcpy(mchart[nc_idx].str,mstring);
				seg_pos[1].morpheme[seg_pos[1].morph_count++]=nc_idx;
				seg_pos[1].state=SP_STATE_R;
			}
		}
		else
		{
			nc_idx = new_chart(UNK,0,next_pos(i),0);
			strcpy(mchart[nc_idx].str,mstring);
			seg_pos[1].morpheme[seg_pos[1].morph_count++]=nc_idx;
			seg_pos[1].state=SP_STATE_R;
		}
	}
	mchart[0].cnt_count=0;

	return anal_chart(0,0);
}

morph_anal(char *word)
{

	int MaR;

    init_segment(word);
    init_chart();

    MaR= anal_chart(0,0);

    if(MaR)
	return MaR;
    else if(unk_anal)
	return anal_chart_unk();
    else
	return 0;		
}

print_morpheme(int chart_id)
{
    int i;
	char tmpstr[1024];
    fprintf(stderr,"chart_id=%d, ",chart_id);
    fprintf(stderr,"%s/%s.%s mstate=%d, ", coco_str(TRI,KS,mchart[chart_id].str, tmpstr),
		tagname[mchart[chart_id].tag],
		irrname[mchart[chart_id].phone],
		mchart[chart_id].state);
    fprintf(stderr,"conexion=");
    for(i=0;i< mchart[chart_id].cnt_count;i++)
		fprintf(stderr,"%d, ",mchart[chart_id].connection[i]);
    fprintf(stderr,"\n");
}
/*----------------------------------------------------------------------
print result
----------------------------------------------------------------------*/
int slash_plus(char *str)
{
	while(*str)
	{
		if(*str=='+' || *str =='/')
			return 1;
		str++;
	}
	return 0;
}
char pbuff[MAX_SEGMENT];
char outstr[MAX_SEGMENT];
int print_chart(int chart_id, int pb_end)	// check
{
    int i,j,k;

    /*
    if(mchart[chart_id].state!=SUCCESS)
	return 0;
	*/
//print_morpheme(chart_id);

    if(chart_id == 0)
    {
		pbuff[0]='\t';
		pb_end=1;

		for(i=0;i<mchart[chart_id].cnt_count;i++)
			print_chart(mchart[chart_id].connection[i],pb_end);
    }
    else
    {
		if(indexing)
		{
			if(is_index(mchart[chart_id].tag))
			{
				pbuff[pb_end++]='[';
				strcpy(pbuff+pb_end,mchart[chart_id].str);
				while(pbuff[pb_end]) pb_end++;
					pbuff[pb_end++]=']';
			}
		}
		else
		{
			if(slash_plus(mchart[chart_id].str))
			{
				int i,j;
				char *str;
				str=mchart[chart_id].str;
				j=pb_end;
				for(i=0;str[i];i++,j++)
				{
					if(str[i]=='+' || str[i]=='/')
						pbuff[j++]='\\';
					pbuff[j]=str[i];
				}
				pbuff[j]=0;
			}
			else
				strcpy(pbuff+pb_end,mchart[chart_id].str);
			while(pbuff[pb_end]) pb_end++;
			pbuff[pb_end++]='/';

			//for debug chart
//			sprintf(pbuff+pb_end,"%d:",chart_id);
//			pb_end+=strlen(pbuff+pb_end);


			strcpy(pbuff+pb_end,tagname[mchart[chart_id].tag]);
			while(pbuff[pb_end]) pb_end++;
		}

		for(i=0;i<mchart[chart_id].cnt_count;i++)
		{
			if(mchart[chart_id].connection[i]==0)
			{
				pbuff[pb_end]=0;
				/*
					fprintf(stderr,"%s\n",pbuff);
				*/
				if(pb_end)
				{
					coco_str(TRI,KS,pbuff,outstr);
					puts(outstr);
				}
			}
			else
			{
				if(indexing)
					print_chart(mchart[chart_id].connection[i],pb_end);
				else
				{
					pbuff[pb_end]='+';
					print_chart(mchart[chart_id].connection[i],pb_end+1);
				}
			}
		}
    }
}

print_result(int r)
{
    if(r)
		print_chart(0,0);
}
