#include <string.h>
#include <ctype.h>
#include "detect.h"

/*
 * ---------------------------------------------------------------------------
 * int han_type(code, result) --
 *     char *code,   (* Է Ʈ,  ιƮ ִ *)
 *          *result; (* ȯ Ʈ, ּ ιƮ ̻ ޸𸮰 ־ *)
 *
 *     code  Ʈ KSC5601̺ ,   ϴ
 *     ˾Ƴ. result Ȯ ؼ δ ̴.
 *    
 *     ϵǴ   . -4Ϸ  Ȯ ɼ ִ.
 *
 *          -4 = unknown type
 *          -3 = 2Ʈ 鹮,
 *          -2 = ,
 *          -1 = 2Ʈ ¥ Ư,
 *
 *	    0 = one byte ascii char
 *
 *           1 = ڼѱ,
 *           2 = ѱ,
 *
 *    Ȯ: 2Ʈ  -> 1Ʈ 
 *             -> ѱ
 *            2Ʈ  -> 1Ʈ 
 *            2Ʈ ȣ -> 1Ʈ ȣ
 *            ...
 *
 * ---------------------------------------------------------------------------
 */

int han_type(char *str, char *result)
/*    char *str,		 ó ιƮ ȿϴ. */
/*       *result;	 Ȯȿ  ó ȯ Ʈ */
			/* ̸ ޸𸮰 Ҵ Ǿ ־ Ѵ. */
{
    int x, y;

    x = (int)(unsigned char)str[0];
    y = (int)(unsigned char)str[1];

    if (str[0] == '\241' && str[1] == '\241')
        return -3; /* 2Ʈ   */
    else if (x == 0xa4 && (0xa1 <= y && y <= 0xfe))
        return 1; /* ڼ ѱ */
    else if ((0xa1 <= x && x <= 0xac) &&
             (0xa1 <= y && y <= 0xfe))
        return -1; /* 2Ʈ¥ Ư  */
    else if ((0xb0 <= x && x <= 0xc8) &&
             (0xa1 <= y && y <= 0xfe))
        return 2; /* ѱ */
    else if ((0xca <= x && x <= 0xfd) &&
             (0xa1 <= y && y <= 0xfe))
		return -2;
    else if (x<128 ) /* one byte char */
    	return 0;
    else
        return -4; /* unknown type */
}
