#include <stdio.h>
#include <string.h>
/*
TAG_TYPE_YONGS : TAG_TYPE_YONGS
TAG_TYPE_EOMIES : TAG_TYPE_EOMIES

IRR_TYPE_S : IRR_TYPE_S
ȉɂ : IRR_TYPE_D
Ӊɂ : IRR_TYPE_B
݉ɂ : IRR_TYPE_H
ɂ : IRR_TYPE_REU
ɂ : IRR_TYPE_REO
*/
#define TAG_TYPE_NBNP 8
#define TAG_TYPE_JOSA 9
#define TAG_TYPE_YONGS 10
#define TAG_TYPE_EOMIES 11
#define TAG_TYPE_JP 12


int IRR_TYPE_B;
int IRR_TYPE_S;
int IRR_TYPE_D;
int IRR_TYPE_H;
int IRR_TYPE_REU;
int IRR_TYPE_REO;

#define MAX_BUF_SIZE 2048
char* replace(char *str,int cur,char *s)
{
	static char buf[MAX_BUF_SIZE];
	strcpy(buf,str);
	buf[cur]=s[0];
	return buf;
}

char* insert(char *str,int cur,char *s)
{
	static char buf[MAX_BUF_SIZE];
	strncpy(buf,str,cur);
	strcpy(buf+cur,s);
	strcat(buf,str+cur);
	return buf;
}

#define MAXPSET 2048
char *pset[MAXPSET][2] = {
	{"",""},
	{"׋",""},
	{"׋",""},

	{"ы׈",""},
	{"׋׈",""},
	{"׋׈",""},
/*  Ň : ɇ, , ӄ,   */
	{"rule_l",""},
	{"rule_",""},
	{"rule_r",""},
//	ɇ
/* ɒɇ*/
	{"l11",""},
	{"11"," ӄ"},
	{"r11",""},
/* ɒɇ2 */
	{"l11-1",""},
	{"11-1",""},
	{"r11-1",""},
/* ɇ*/
	{"l12",""},
	{"12",""},
	{"r12",""},
/*  ɇ */
	{"l13",""},
	{"13",""},
	{"r13",""},
/*  ɇ */
	{"l14",""},
	{"14",""},
	{"r14",""},
/*  ɂ */
	{"l21",""},
	{"21",""},
	{"r21",""},
/*  ɂ */
	{"l22",""},
	{"22",""},
	{"r22",""},
/*  ɂ */
	{"l23",""},
	{"23",""},
	{"r23",""},
/*  ɂ 2 */
	{"l24",""},
	{"24",""},
	{"r24",""},
/*  ɂ 3 */
	{"l25",""},
	{"25",""},
	{"r25",""},
/*  ɂ */
	{"l26",""},
	{"26",""},
	{"r26",""},
/*  ɂ 2 */
	{"l27",""},
	{"27",""},
	{"r27",""},
/*  ɂ 3 */
	{"l28",""},
	{"28",""},
	{"r28",""},
/*  ɂ */
	{"l29",""},
	{"29",""},
	{"r29",""},
/*  ɂ */
	{"l30",""},
	{"30",""},
	{"r30",""},
/*  ɂ */
	{"l31",""},
	{"31",""},
	{"r31",""},
/*  ɂ */
	{"l32",""},
	{"32",""},
	{"r32",""},
/*  ɂ 2 */
	{"l33",""},
	{"33",""},
	{"r33",""},
/* / */
	{"l51",""},
	{"51",""},
	{"r51",""},
/*   */
	{"l52",""},
	{"52",""},
	{"r52",""},
/*   */
/*   ŇŅ negative rule/don't care condition
 * Սю ɔō  ю ɔō  ׋׍ Ǎ ɇŅ.
 *  Սю ''ō  ю Ս Ņ */
	{"l53",""},
	{"53",""},
	{"r53",""},
/*  '' ɇ */
/* l54 '//'ɇ  ׍ */
	{"l54","ɣ"},
	{"54"," ӄ"},
	{"r54",""},

	{NULL,NULL}
};
int pset_end=0;

init_rule()
{
	int i;
	for(i=0;pset[i][0]!=NULL;i++) ;

	pset_end=i;
	qsort(pset,i,sizeof(char *)*2,strp_cmp);
    IRR_TYPE_B=irrnum("irrb");
    IRR_TYPE_S=irrnum("irrs");
    IRR_TYPE_D=irrnum("irrd");
    IRR_TYPE_H=irrnum("irrh");
    IRR_TYPE_REU=irrnum("irrlu");
    IRR_TYPE_REO=irrnum("irrle");
}

int
pcheck(char c,char *str)
{
	char **x;
	char *p;
	int i;

	x=bsearch(&str,pset,pset_end,sizeof(char *)*2,strp_cmp);

	if (x==NULL) 
		return 0;

	p=*(x+1);
	if (p[0]==0) return 1;
	for (i=0;p[i];p++)
		if (p[i]==c)
			return i+1;
	return 0;
}

int scheck(char c,char *str)
{
	char *p;
	int i;

	p=str;
	if (p[0]==0) return 1;
	for (i=0;p[i];p++)
		if (p[i]==c)
			return i+1;
	return 0;
}

int 
prule(int from,char *prev,char *str)
{
	int i;
	rule_NP(from,prev,str);
	for(i=0;i<strlen(str);i++) {
		rule_rem(from,prev,str,i);
		rule_irr_word(from,prev,str,i);
		rule_irr_word2(from,prev,str,i);
		rule_shorten(from,prev,str,i);
		rule_eomi_u(from,prev,str,i);
		rule_johwa(from,prev,str,i);
		rule_i(from,prev,str,i);
		rule_gut(from,prev,str,i);
	}
}

int rule_gut(int from,char *prev,char *str,int cur)
{
	char buf[MAX_BUF_SIZE];
	char buf2[MAX_BUF_SIZE];
	char *new_str;

	if (cur>1&& strncmp(str+cur-2,"",2)==0 &&
			pcheck(str[cur],"rule_")) {

		if (str[cur]=='') {
			if (strncmp(str+cur,"ӄ",3)==0) {
				new_str=insert(str,cur,"Ս");
				strncpy(buf,new_str,cur+1);
				buf[cur+1]=0;
				strcpy(buf2,new_str+cur+1);
				phone_change(from,buf,buf2,TAG_TYPE_NBNP,TAG_TYPE_JP,0);
			}
		} else {
			if (strncmp(str+cur,"ɇ",3)==0) {
				new_str=replace(str,cur,"");
				new_str=insert(new_str,cur+1,"");
				strncpy(buf,new_str,cur+1);
				buf[cur+1]=0;
				strcpy(buf2,new_str+cur+1);
				phone_change(from,buf,buf2,TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);

			} else if (str[cur]==''||str[cur]=='') {
				if (str[cur+1]) {
					new_str=insert(str,cur,"Ս");
					strncpy(buf,new_str,cur+1);
					buf[cur+1]=0;
					strcpy(buf2,new_str+cur+1);
					phone_change(from,buf,buf2,TAG_TYPE_NBNP,TAG_TYPE_JP,0);
				}

				new_str=insert(str,cur,"Ս");
				strncpy(buf,new_str,cur+1);
				buf[cur+1]=0;
				strcpy(buf2,new_str+cur+1);
				phone_change(from,buf,buf2,TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
			} else {
				new_str=insert(str,cur,"Ս");
				strncpy(buf,new_str,cur+1);
				buf[cur+1]=0;
				strcpy(buf2,new_str+cur+1);
				phone_change(from,buf,buf2,TAG_TYPE_NBNP,TAG_TYPE_JP,0);
			}
		}
	} 
}
int rule_NP(int from,char *prev,char *str)
{
	char buf[MAX_BUF_SIZE];

	if (strncmp(str,"",4)==0) {
		phone_change(from,"",str+2,TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strncmp(str,"",4)==0) {
		phone_change(from,"",str+2,TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strncmp(str,"",4)==0) {
		phone_change(from,"",str+2,TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strcmp(str,"")==0) {
		phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strcmp(str,"")==0) {
		phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strcmp(str,"")==0) {
		phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strncmp(str,"",4)==0) {
		strcpy(buf,"");
		strcat(buf,str+2);
		phone_change(from,"",buf,TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strncmp(str,"",4)==0) {
		strcpy(buf,"");
		strcat(buf,str+2);
		phone_change(from,"",buf,TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strncmp(str,"",4)==0) {
		strcpy(buf,"");
		strcat(buf,str+2);
		phone_change(from,"",buf,TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	} else if (strncmp(str,"",2)==0) {
		if (str[2]==''&&str[3]==0) {
			phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
		} else if (str[2]==''&&str[3]==0) {
			phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
		}
	} else if (strncmp(str,"",2)==0) {
		if (str[2]==''&&str[3]==0) {
			phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
		} else if (str[2]==''&&str[3]==0) {
			phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
		}
	} else if (strncmp(str,"",4)==0) {
		if (str[4]==''&&str[5]==0) {
			phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
		} else if (str[4]==''&&str[5]==0) {
			phone_change(from,"","",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
		}
	} else if (strcmp(str,"ł")==0) {
		phone_change(from,"","ł",TAG_TYPE_NBNP,TAG_TYPE_JOSA,0);
	}
}

int rule_i(int from, char *prev, char *str,int cur)
{
	char buf[MAX_BUF_SIZE];
	char buf2[MAX_BUF_SIZE];
	char *new_str;

	if ((prev!=NULL&&prev[0]&&cur==0)
			&&pcheck(prev[strlen(prev)-1],"׋")) {

		if (strncmp(str,"",2)==0) {
			new_str=replace(str,cur+1,"");
			new_str=insert(new_str,cur+1,"");
			strncpy(buf,new_str,cur+2);
			buf[cur+2]=0;
			strcpy(buf2,&(new_str[cur+2]));
			phone_change(from,buf,buf2,TAG_TYPE_JP,TAG_TYPE_EOMIES,0);
		} else {
//--> begin ׍  20000406
//			if ((str[0]==''&&!(str[1] & 0x80))||
//					str[0]==''||str[0]==''||strncmp(str,"Ŕ",4)==0||
//					strncmp(str,"",3)==0||strncmp(str,"",3)==0||
//					strncmp(str,"",3)==0||strncmp(str,"",5)==0) 
//				return;
			if (pcheck(str[0],"׋")||
					strncmp(str,"",3)==0||strncmp(str,"",3)==0||
					strncmp(str,"",3)==0||strncmp(str+2,"",3)==0) 
				return;
//--> end ׍  20000406
			phone_change(from,"",str,TAG_TYPE_JP,TAG_TYPE_EOMIES,0);
			strcpy(buf,"");
			strcat(buf,str);
			rule_eomi_u(from,prev,buf,cur+2);
		}
	}
}

/* 1. ɇŋ  
 * ɒɇ, ɇ, ɇ ŋ 
 * */
int rule_rem(int from,char *prev,char *str,int cur)
{
	char buf[MAX_BUF_SIZE];
	char buf2[MAX_BUF_SIZE];
	char *new_str;
// ɒɇ .
//
	if ((cur>0&&pcheck(str[cur-1],"l11"))
		&&(pcheck(str[cur],"11") || strncmp(str+cur,"",2)==0)
		&&pcheck(str[cur+1],"r11")) {

		char buf3[MAX_BUF_SIZE];
		new_str=insert(str,cur,"");
		strcpy(buf3,new_str);

		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
		rule_eomi_u(from,prev,buf3,cur+1);
	}

	/*  ɇ 
	 * '','' ɔӔ ׍ō  '' ɇŅ.
	 *
	 *   ֍.
	 *  -> +  Ņ.
	 */

	if ((cur>0&&pcheck(str[cur-1],"l12"))
		&&pcheck(str[cur],"12")
		&&pcheck(str[cur+1],"r12")
		||(cur==1&&str[cur]!='')
//		Ŏ 
//		&&(cur==1&&str[cur]!='')
//		&&(cur>2&&!pcheck(str[cur-2],"׋׈")
//		&&!pcheck(str[cur-3],"׋׈"))) {
		) {
		char buf3[MAX_BUF_SIZE];

		new_str = replace(str,cur,"");
		new_str = insert(new_str,cur,"");
		strcpy (buf3,new_str);
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}

	/* ""ɇ 
	 * */
	if ((cur>0&&pcheck(str[cur-1],"l13"))
		&&pcheck(str[cur],"13") 
		&&pcheck(str[cur+1],"r13")) {
		new_str = insert(str,cur+1,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}

	if ((cur>0&&pcheck(str[cur-1],"l14"))
		&&pcheck(str[cur],"14")
		&&pcheck(str[cur+1],"r14")) {
		new_str=insert(str,cur+1,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}
}

/* 2. ɂ  
 * ''ɂ
 * ''ɂ
 * ''ɂ
 * ''ɂ
 * ''ɂ
 * ''ɂ
 * ''ɂ
 * ''ɂ
 * */

int 
rule_irr_word(int from,char *prev,char *str,int cur)
{
	char buf[MAX_BUF_SIZE];
	char buf2[MAX_BUF_SIZE];
	char *new_str;
	/* ''ɂ
	 * + ק, ף,׻ Ɇ, ɍ ȍ .
	 */
	if ((cur>0&&pcheck(str[cur-1],"l21"))
		&&pcheck(str[cur],"21")
		&&pcheck(str[cur+1],"r21")) {
		new_str = replace(str,cur-1,"");
		strncpy(buf,new_str,cur);
		buf[cur]=0;
		strcpy(buf2,&(new_str[cur]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_D);
	}

	/* ''ɂ
	 * ? ק, ף,׻ Ɇ, Ս ɇ
	 */
	if ((cur>0&&pcheck(str[cur-1],"l22"))
		&&pcheck(str[cur],"22")
		&&pcheck(str[cur+1],"r22")) {
		new_str=insert(str,cur,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_S);
	}

	/*  ɂ.  */
	if ((cur>0&&pcheck(str[cur-1],"l23"))
		&&pcheck(str[cur],"23")
		&&pcheck(str[cur+1],"r23")) {
		new_str=replace(str,cur,"");
		new_str=insert(new_str,cur-1,"");
		strncpy(buf,new_str,cur);
		buf[cur]=0;
		strcpy(buf2,&(new_str[cur]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_B);
	}

	/*  ɂ */
	if ((cur>0&&pcheck(str[cur-1],"l24"))
		&&pcheck(str[cur],"24")
		&&pcheck(str[cur+1],"r24")) {
		new_str=replace(str,cur,"");
		new_str=insert(new_str,cur-1,"");
		strncpy(buf,new_str,cur);
		buf[cur]=0;
		strcpy(buf2,&(new_str[cur]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_B);
	}

	if ((cur>0&&pcheck(str[cur-1],"l25"))
		&&pcheck(str[cur],"25")
		&&pcheck(str[cur+1],"r25")) {
		new_str=replace(str,cur,"");
		new_str=insert(new_str,cur-1,"");
		strncpy(buf,new_str,cur);
		buf[cur]=0;
		strcpy(buf2,&(new_str[cur]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_B);
	}

	/*  ɂ  */
	if ((cur>0&&pcheck(str[cur-1],"l26"))
		&&pcheck(str[cur],"26")
		&&pcheck(str[cur+1],"r26")) {
		new_str=insert(str,cur+1,"ݍ");
		strncpy(buf,new_str,cur+2);
		buf[cur+2]=0;
		strcpy(buf2,&(new_str[cur+2]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_H);
	}

	if ((cur>0&&pcheck(str[cur-1],"l27"))
		&&pcheck(str[cur],"27")
		&&pcheck(str[cur+1],"r27")) {
		if (str[cur]=='') {
			new_str=replace(str,cur,"");
		} else {
			new_str=replace(str,cur,"");
		}
		new_str=insert(new_str,cur+1,"ݍ");
		strncpy(buf,new_str,cur+2);
		buf[cur+2]=0;
		strcpy(buf2,&(new_str[cur+2]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_H);
//		Ŏ 
		if (str[cur]=='') {
			new_str = replace(str,cur,"");
		} else {
			new_str = replace(str,cur,"");
		}
		new_str=insert(new_str,cur+1,"ݍ");
		strncpy(buf,new_str,cur+2);
		buf[cur+2]=0;
//	ыŉ   : 2000.7.14 
//	/ -> +/+  Ň  Ŏ 
//	 ~/~ Ŕ ׅה ֍. (exptest ю)
// 		strcpy(buf,&(new_str[cur+2])); <- Ս 
		strcpy(buf2,&(new_str[cur+2])); // ݂;
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_H);
	}
//	ɂ 2000.10.11
//	"օ"   l27 Ņ 'օ'  
//	"օ" Ŕ Ŕō ɓ. ( Ŏ Ӌ)
	if ((cur>0&&pcheck(str[cur-1],"l28"))
		&&pcheck(str[cur],"28")
		&&pcheck(str[cur+1],"r28")) {
		new_str=replace(str,cur,"");
		new_str=insert(new_str,cur+1,"ݍ");
		strncpy(buf,new_str,cur+2);
		buf[cur+2]=0;
		strcpy(buf2,&(new_str[cur+2]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_H);
	}


	/*  ɂ
	 * +ק : 'ɇ'  Ŕ
	 * */

	if ((cur>0&&pcheck(str[cur-1],"l29"))
		&&pcheck(str[cur],"29")
		&&pcheck(str[cur+1],"r29")) {
		new_str = replace(str,cur,"");
		if (new_str[cur+1]=='') 
			new_str[cur+1]='';
		new_str = insert(new_str,cur+1,"");
		new_str[cur-1]=tocho(new_str[cur-1]);

		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_REU);
	}
	/*  ɂ
	 *  ->  + 
	 * */

	if ((cur>0&&pcheck(str[cur-1],"l30"))
		&&pcheck(str[cur],"30")
		&&pcheck(str[cur+1],"r30")&&(cur-2>=0&&str[cur-2]=='')) {
		new_str=replace(str,cur,"");
		strncpy(buf,new_str,cur);
		buf[cur]=0;
		strcpy(buf2,&(new_str[cur]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,IRR_TYPE_REO);
	}
}

int
rule_irr_word2(int from,char *prev,char *str,int cur)
{
	char buf[MAX_BUF_SIZE];
	char buf2[MAX_BUF_SIZE];
	char *new_str;
	if ((cur>0&&pcheck(str[cur-1],"l31"))
		&&pcheck(str[cur],"31")
		&&pcheck(str[cur+1],"r31")) {
		new_str=replace(str,cur,"");
		new_str=insert(new_str,cur+1,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}

	if ((cur>0&&pcheck(str[cur-1],"l32"))
		&&pcheck(str[cur],"32")
		&&pcheck(str[cur+1],"r32")&&str[cur+2]=='') {
		new_str=replace(str,cur+2,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}

	if ((cur>0&&pcheck(str[cur-1],"l33"))
		&&pcheck(str[cur],"33")
		&&pcheck(str[cur+1],"r33")) {
		new_str=replace(str,cur,"");
		new_str=insert(new_str,cur+1,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}
}

/* 3. / 
 * / 
 * 
 *  
 *  
 * */
int
rule_shorten(int from,char *prev,char *str,int cur)
{
	char buf[MAX_BUF_SIZE];
	char buf2[MAX_BUF_SIZE];
	char *new_str;
	if ((cur>0&&pcheck(str[cur-1],"l51"))
		&&pcheck(str[cur],"51")
		&&pcheck(str[cur+1],"r51")) {
		if (str[cur]=='') {
			new_str=replace(str,cur,"");
		} else {
			new_str=replace(str,cur,"");
		}
		new_str=insert(new_str,cur+1,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}

	/*  
	 * */

	if ((cur>0&&pcheck(str[cur-1],"l52"))
		&&pcheck(str[cur],"52")
		&&pcheck(str[cur+1],"r52")) {
		new_str=replace(str,cur,"");
		new_str=insert(new_str,cur+1,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}

	/*  
	 *  +  -> 
	 * */
	// "֋ӄ." ׎  (cur)׉  Ņ.

	if (cur>0)
	{
	// by yuntan Սю ''   : 2000.11.16
	if (((cur>1 || (str[cur-1]!=''))&&pcheck(str[cur-1],"l53"))
		&&pcheck(str[cur],"53")
		&&pcheck(str[cur+1],"r53")) {

		new_str=replace(str,cur,"");
		new_str=insert(new_str,cur+1,"");
		strncpy(buf,new_str,cur+1);
		buf[cur+1]=0;
		strcpy(buf2,&(new_str[cur+1]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}
	}
}

int rule_eomi_u(int from,char *prev,char *str,int cur)
{
	char buf[MAX_BUF_SIZE];
	char buf2[MAX_BUF_SIZE];
	char *new_str;
	if ((cur>0 && pcheck(str[cur-1],"l54"))
		&&pcheck(str[cur],"54")
		&&pcheck(str[cur+1],"r54")) {
		new_str=insert(str,cur,"");
		strncpy(buf,new_str,cur);
		buf[cur]=0;
		strcpy(buf2,&(new_str[cur]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}
	if ((cur>0 && pcheck(str[cur-1],"l54"))
		&&strncmp(str+cur,"ӄ",3)==0) {
		new_str=insert(str,cur,"");
		strncpy(buf,new_str,cur);
		buf[cur]=0;
		strcpy(buf2,&(new_str[cur]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}
	if ((cur>0 && pcheck(str[cur-1],"l54"))
		&&strncmp(str+cur,"Ņ",3)==0) {
		new_str=insert(str,cur,"");
		strncpy(buf,new_str,cur);
		buf[cur]=0;
		strcpy(buf2,&(new_str[cur]));
		phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
	}
}

int rule_johwa(int from,char *prev,char *str,int cur)
{
	int i;
	char buf[MAX_BUF_SIZE];
	char buf2[MAX_BUF_SIZE];
	char *new_str;
	if (cur>0&&pcheck(str[cur-1],"׋׈")) {
		if (str[cur+1]==''&&str[cur+2]=='') {
			new_str=replace(str,cur+2,"");
			strncpy(buf,new_str,cur+1);
			buf[cur+1]=0;
			strcpy(buf2,&(new_str[cur+1]));
			phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
		}
		else if (str[cur]==''&&str[cur+1]=='') {
			new_str=replace(str,cur+1,"");
			strncpy(buf,new_str,cur);
			buf[cur]=0;
			strcpy(buf2,&(new_str[cur]));
			phone_change(from,buf,buf2,TAG_TYPE_YONGS,TAG_TYPE_EOMIES,0);
		}
	}
}
