#include <stdio.h>
#include <ctype.h>
#include "malib.h"
#include "../share/wjhcode.h"
#include "../share/global.h"
#include "../share/trie.h"
#include "detect.c"
#include "../transliteration/HMM.h"

char ARG[MAX_LINE];
char line[MAX_LINE];
char word[MAX_WORD];
char mout[MAX_WORD];
char mout1[MAX_WORD];
char cand[MAX_LINE][1024]; 
char final[100000][4096];

int hanja[100];
char each[100][4];
int num, cand_ind, final_ind;

int anal_dic=0;
int useTrans=0;

char *pre_out(char *str);
char *pre_out2(char *str);
char *process_chi_eng(char *str);
void analyze (char *str);
void process_paren(char str[]);
char *replaceString(char *str, char *a, char *b);

/*
extern void INIT_HMM();
extern void ek_trans_hmm_as_string(char*, char*);
extern void END_HMM();
*/

void main(int argc, char* argv[])

{
	int i,r,c,m,k,f_arg = 0,j=0;
	char *rword;
	char *pa, *p, *g, *final2;
	TDBM *tf;

	m=argc;	
//	strcpy(cfg_file,"ma_kE.cfg");

	while (m>=2) {
		c=argc-m+1;

		if (!strcmp(argv[c],"--help")) {
			fprintf(stderr,"Usage : %s [-[ilntueU]] [@<cfgfile>]\n",argv[0]);
			fprintf(stderr,"Option - l : ġ\n");
			fprintf(stderr,"       - u : м о   ó (unk ± )\n");
			fprintf(stderr,"       - U : м о   ǰ ĺ \n");
//			fprintf(stderr,"       - Y : м о   ȶϰ óϱ \n");
			fprintf(stderr,"       - i : ε̿  \n");
			fprintf(stderr,"       - t : top-down  \n");
			/* begin - added by yuntan 20000607 : м ɼ ߰ */
			fprintf(stderr,"       - n : м  \n");
			/* end - added by yuntan 20000607 */
			/* begin - added by heahn 200206 : etri tag set ̿ */
			fprintf(stderr,"       - e : etri tag set ̿\n");
			/* end - added by heahn 200206 */
			fprintf(stderr,"	- r : Transliteration  \n");
			return;
			
/*  # -w option Ͽ ma ϸ  ܾ     ִ. 
    # ex) ma -w б  */
   		} else if (!strncmp(argv[c],"-w",2)) {
			if (m>=3) {
				strcpy(ARG,argv[c+1]); /* # ARG Ѵܾ . ex) б */
				f_arg = 1;
				m--;
			}
		} else if (argv[c][0]=='-') {
			for (i=1;argv[c][i];i++) {
				if (argv[c][i]=='l') {
					if (longest == 0) longest=1;
					else fprintf(stderr,"Conflict option \'-l\'\n");
				} else if(argv[c][i]=='u') {
					if (unk_anal == 0) unk_anal=1;
					else fprintf(stderr,"Conflict option \'-u\'\n");
				} else if (argv[c][i]=='U') {
					if (unk_expand==0) unk_anal = unk_expand = 1;
					else fprintf(stderr,"Conflict option \'-u\'\n");
				} else if (argv[c][i]=='i') {
					if (indexing == 0 ) indexing=1;
					else fprintf(stderr,"Conflict option \'-i\'\n");
				} else if (argv[c][i]=='t') {
					if (top_down == 0 ) top_down=1;
					else fprintf(stderr,"Conflict option \'-t\'\n");
			/* begin - added by yuntan 20000607 : м ɼ ߰ */
				} else if (argv[c][i]=='n') {
					if (anal_dic == 0 ) anal_dic=1;
					else fprintf(stderr,"Conflict option \'-n\'\n");
			/* end - added by yuntan 20000607 */
			/* begin - added by yuntan 20000929 : ̵Ͼ ġ ɼ ߰ * /
				} else if (argv[c][i]=='Y') {
					if (unk_anal == 0 ) unk_anal=2;
					else fprintf(stderr,"Conflict option \'-Y\'\n");
			/* end - added by yuntan 20000929 */
			/* begin - added by heahn 200206: etri tag set ̿ */
				} else if (argv[c][i]=='e') {
					if (etri_tagset == 0 ) etri_tagset=1;
					else fprintf(stderr,"Conflict option \'-e\'\n");
				} else if( argv[c][i] == 'r' ) {
					// Transliteration  
					useTrans = 1;
				}
			/* end - added by heahn 200206 */
			}
		} else if (argv[c][0]=='@') 
			strcpy(cfg_file,argv[c]+1);
		

       //     printf ("cgf_file: %s\n",cfg_file);

		/*
					 fprintf(stderr,"anal_dic=%d\n",anal_dic);
					 */
					 
		m--;
	}
	if (!strlen(cfg_file)){
	       	if(etri_tagset==0){
			strcpy(cfg_file,"./ma.cfg");
		}else{
			strcpy(cfg_file,"./ma.cfg");
		}
	}

	if( useTrans == 1 ) {
		//  ǥ  ʱȭѴ.
		INIT_HMM();
	}
	
	init_morph();

// edited by cwseo 

/* # ana_file : м  ش */
	tf=tdbm_open(ana_file,'r');
	
	
	// f_arg==1 -wɼ(Ѿ м)  set. 
	if (f_arg == 1)
	{
		strcpy(word,ARG);
		// Ѵܾ  ¼Һм  ̸ ص  (ana_file)  
		// װ  ϰ, ƴ 쿡 ¼ м Ѵ. 
		if(!anal_dic && tf != NULL && tdbm_fetch(tf,word,mout)>0)
		{
			printf("@%s\n",word);
			for(p=front_token(mout1,mout,'^');p != NULL;p=front_token(mout1,p,'^'))
				printf("\t%s\n",mout1);
		}
		else
		{
			pa=strstr(word, "(");
		   	printf(" %s\n",word);
		    g=word;
		    if (pa && word[0]!='(')
				process_paren(word);
            else 
				analyze(g);
	        for (k=0; k<final_ind; k++)
			{
				final2=replaceString(final[k],"/xsva","/mag+/pvg"); // 
				final2=replaceString(final2,"/xsv","/mag+/pv"); // 
				final2=replaceString(final2,"/xsm","/mag+/pv"); // 
		
				printf("%s\n", final2); // 
			}
		}
		puts("");

	}
	else 
	{

		while(fgets(line,1024,stdin) != NULL)
		{
			if (strstr(line,"<TERM")!=NULL || strstr(line,"</TERM")!=NULL ||strstr(line,"<ID")!=NULL ||	strstr(line,"</ID")!=NULL)
			{
				puts(line);
				continue;
			}

			
			/* # rword :  ο   شѴ. */	    
			for(rword = front_word(word,line); rword != NULL; rword = front_word(word,rword)) 
			{
				final_ind=0;
				// BOS = begin of sentence.
				if(strstr(word,"BOS") !=NULL) 
					puts("BOS");
				// EOS = end of sentence
				else if (strstr(word,"EOS") != NULL)
					puts("EOS");
				else
				{
					if (strlen(word)>80) word[80]='\0';
					if(!anal_dic && tf != NULL && tdbm_fetch(tf,word,mout)>0)
					{
						// м  
						printf("%s\n",word);
						for(p=front_token(mout1,mout,'^');p != NULL;p=front_token(mout1,p,'^'))
							printf("\t%s\n",mout1);
					}
					else
					{
						pa=strstr(word, "(");
						printf(" %s\n",word);
						g=word;
						
						// ӿ ȣ ԵǾ   process_paren, ׷   analyze ȣ
						//ȣ ԵǾ ־ ùڰ '('  process_paren ȣ
						if (pa && word[0]!='(') 
							process_paren(word);
						else 
							analyze(g);					

						// ¼ м    3  ã Ѵ. 
						for (k=0; k<final_ind; k++){
							final2=replaceString(final[k],"/xsva","/mag+/pvg");
							final2=replaceString(final2,"/xsv","/mag+/pv"); 
							final2=replaceString(final2,"/xsm","/mag+/pv"); 
							printf("%s\n", final2); // 
						}
					}
				}
				puts("");

			} // end of for
		} // end of while 
	} // end of if-else

	close_morph();

	if( useTrans == 1 ) {
		//  ǥ  Ѵ.
		END_HMM();
	}

	if(tf != NULL)
		tdbm_close(tf);
}



 /**
  *  ӿ ȣ Ե  ¼ м ϴ Լ, 
  * return value , м  final 迭 Ѵ.
  * @param str[]  м 
 */

void process_paren(char str[])
{
	char *pos, *rw, *g, *t;
	char tok[100], sp[100][100], w[MAX_WORD];
	int ind, i, j, k, l;

	ind=i=0;
	pos=strtok(str, "(");
	strcpy(tok, pos);

	while (pos!=NULL)
	{
		strcpy(sp[ind], pos);
		ind++;
		pos=strtok(NULL, "(");
	}
	for (j=1; j<ind; j++)
	{
		strcat(tok, " (");
		strcat(tok, sp[j]);
	}
	ind=j=0;


	for(rw = front_word(w,tok); rw != NULL; rw = front_word(w,rw))
	{
		l=0;
		g=w;
		analyze(w);

		if (j==0)
			for (i=0; i<cand_ind; i++)
				{	strcpy(final[i],cand[i]);
				}	
		else
		{
			for (i=1; i<cand_ind+1; i++)
				for (k=0; k<final_ind; k++)
					strcpy(final[final_ind*i+k], final[k]);
			for (i=0; i<cand_ind; i++)
			{
				for (k=0; k<final_ind; k++)
				{
					ind=l*final_ind+k;
					strcat(final[ind], "+");
					t=strtok(cand[i], "\t");
					strcat(final[ind], t);
				}
				l++;
			}
		
		}
		j++;
	}
	final_ind=ind+1;
}



/**
  *   ¼ м ϴ Լ, 
  * @param str[]  м 
  * return value , м  final 迭 Ѵ.
 */
void analyze (char *str)
{
    
	char  *gg, *output, *temp;
    char obj[20240], in[1000][100], word2[MAX_WORD], eoj[MAX_LINE]; 
	int r;
	cand_ind=0;
	
//	printf("str=%s\n",str);
	

	gg=process_chi_eng(str);
    strcpy(eoj, gg);

	// ڿ encoding ٲٴ Լ ,
    coco_str(KS,TRI,eoj,word2);


    r=morph_anal(word2);
    output=print_result2(r);
   // printf("output=%s\n\n end output\n",output);
	strncpy(obj, output, sizeof(obj));
//	gg=strtok(output, "\n");
	gg=strtok(obj, "\n");
	while (gg!=NULL) {
		strcpy(in[cand_ind], gg);
		temp=in[cand_ind];
		gg=strtok(NULL, "\n");
    	output=pre_out(temp);
		strcpy(cand[cand_ind], output);
		cand_ind++;
	}
	if (final_ind==0)
	{
		for (r=0; r<cand_ind; r++)
			strcpy(final[r],cand[r]);
		final_ind=cand_ind;
	}

}
void print_cand()
{
     
     int i;
     
     printf("cand array...\n");
     for(i=0 ; i<cand_ind ;i++)
     {
           printf("cand[%d]->%s\n",i,cand[i]);
     }
}

void print_final()
{
     
     int i;
     
     printf("final array...\n");
     for(i=0 ; i<final_ind ;i++)
     {
           printf("final[%d]->%s\n",i,final[i]);
     }
}





//
/**
  *  м ռ ڿ   "HHHHH" "AAAAA" ġȯϴ óԼ
  * @param str[]  ġȯ  Ǵ 
  * return result ġȯ  ִ ڿ
 */
/*
char *process_chi_eng(char *str)
{
	
	int i, j, h;
	char *result;
	char temp[100];
	char *gar;
	int flag, flag1;

	i=j=0;
	flag=flag1=0;
	temp[0]=0;
	
	while (i<strlen(str))
	{
		h=han_type(str+i, gar);
		if (h==0) {
			strcpy(each[j], str+i);
			each[j][1]=0;
			j++;
			i++;
		}
		else { 
			strcpy(each[j], str+i);
			each[j][2]=0;
			j++;
			i=i+2;
		}
	}
	num=j;
	for (i=0;i<j; i++)
	{
		hanja[i]=han_type(each[i], gar);
		if (hanja[i]==-2) {
			if (flag!=1) {
				strcat(temp, "HHHHH");
				flag=1;
				flag1=0;
			}
		}
		else if (hanja[i]==0) {
			if (isalpha(each[i][0])) {
				hanja[i]=3;
				if (flag1!=1) {
					strcat(temp, "AAAAA");
					flag1=1;
					flag=0;
				}
			}
			else {
				strcat(temp, each[i]);
				flag=0;
				flag1=0;
			}
		}
		else {
			strcat(temp, each[i]);
			flag=0;
			flag1=0;
		}
	}
	result=temp;

	printf( "\n ((%s)) \n", result );
	return result;

}
*/

/**
  *  м ռ ڿ   "HHHHH"  ǥ ѱ۷ ġȯϴ óԼ
  * @param str[]  ġȯ  Ǵ 
  * return result ġȯ  ִ ڿ
 */
char *process_chi_eng(char *str)
{
	
	int i, j, h;
	char *result;
	char temp[100];
	char *gar;
	int flag, flag1;
	char each[100][4];
	int num;
	int hanja[100];
	char eng_word[255];
	char transResult[255];

	eng_word[0] = 0;
	i=j=0;
	flag=flag1=0;
	temp[0]=0;
	
	while (i<strlen(str))
	{
		h=han_type(str+i, gar);
		if (h==0) {
			strcpy(each[j], str+i);
			each[j][1]=0;
			j++;
			i++;
		}
		else { 
			strcpy(each[j], str+i);
			each[j][2]=0;
			j++;
			i=i+2;
		}
	}
	num=j;
	for (i=0;i<j; i++)
	{
		hanja[i]=han_type(each[i], gar);
		if (hanja[i]==-2) {
			if (flag!=1) {
				strcat(temp, "HHHHH");
				flag=1;
				flag1=0;
			}
		}
		else if (hanja[i]==0) {
			if (isalpha(each[i][0])) {
				hanja[i]=3;
				if (flag1!=1) {
					if( useTrans == 0 ) {
						// Transliteration Ⱦ ܾ AAAAA ġȯѴ.
						strcat(temp, "AAAAA");
					}
					flag1=1;
					flag=0;
				}
				strcat( eng_word, each[i] );
			}
			else {
				
				strcat(temp, each[i]);
				
				flag=0;
				flag1=0;
			}
		}
		else {
			// Transliteration ɼ ''̰,  ̸ܾ
			if( useTrans == 1 && eng_word[0] != 0 ) {				
				strcat( eng_word, "\n" );
				//printf( "eng_word: %s\n", eng_word );
				ek_trans_hmm_as_string( eng_word, transResult );
				strcat( temp, transResult  );
				eng_word[0] = 0;
			}	
			strcat(temp, each[i]);
			flag=0;
			flag1=0;
		}
	}
	result=temp;

//	printf( "\n ((%s)) \n", result );
	return result;

}


/**
  *  м    κ("HHHHH")  ڿ ٽ ġȯϴ óԼ
  * @param str[]  ġȯ  Ǵ 
  * return result ġȯ  ִ ڿ
 */
char *pre_out(char *str)
{
	char *tok, *be, *result;
	int i, j, l;
	int flag;
	char line1[300], line2[300];

	be=strstr(str, "HHHHH");
	if (!be) {
		result=pre_out2(str);
		return result;
	}
	else {
		strcpy(line1, str);
		flag=0;
		j=0;
		line2[0]=0;
		
		tok=strtok(line1, "HHHHH");
		while (tok!=NULL) {
			strcat(line2, tok);
			for (i=j;i<num;i++) {
				if (hanja[i]==-2) {
					strcat(line2, each[i]);
					flag=1;
				}
				else if (flag==1) {
					j=i+1;
					flag=0;
					break;
				}
				if (i==j) j=i+1;
			}
			tok=strtok(NULL, "HHHHH");
		}
		be=line2;
		result=pre_out2(be);
		
		return result;
	}
}

/**
  *  м    κ("AAAAA")   ٽ ġȯϴ óԼ
  * @param str[]  ġȯ  Ǵ 
  * return be ġȯ  ִ ڿ
 */
char *pre_out2(char *str)
{
	char *tok, *be, *result;
	int i, j, l;
	int flag;
	char line1[300], line2[300];
   // printf("str1->%s\n",str);
//	printf( "\n\n <%s> \n\n", str);

	be=strstr(str, "AAAAA");
	
	if (!be) {
		return str;
	}
	else
	{
		strcpy(line1, str);
       // printf("str,line1->%s\n",str);
		flag=0;
		j=0;
		line2[0]=0;

		tok=strtok(line1, "AAAAA");
		while (tok!=NULL) {
			strcat(line2, tok);
			for (i=j;i<num;i++) {
				if (hanja[i]==3) {
					strcat(line2, each[i]);
					flag=1;
				}
				else if (flag==1) {
					j=i+1;
					flag=0;
					break;
				}
				if (i==j) j=i+1;
			}
			tok=strtok(NULL, "AAAAA");
	//		printf("line1->%s\n",line1);
		}
		be=line2;

	//	printf( "\n [%s] \n", be );

		return be;
	}
}



/**
  * ڿ strȿ ڿ a ڿ b ٲپִ Լ 
  * @param str  ˻ ڿ ġȯ ̵Ǵ ڿ
  * @param a	ġȯ ˻ . 
  * @param b    ڿ a ü ڿ 
  * return new_str ġȯ  ִ ڿ
 */
char* replaceString(char* str, char* a, char* b){
	int i;
	char* start;
	char new_str[100];
	
	start=strstr(str,a);
	if(start ==NULL){
		return str;
	}
	i=strlen(str)-strlen(start);
	strncpy(new_str,str,i);
	new_str[i]='\0';
	strcat(new_str,b);	
	strcat(new_str,start+strlen(a));	
	return new_str;
}
			


