/*---------------------------------------------------------------------- 
	File Name	: dcache.h
	compiler	: gcc
	Edited by	: Lee, WoonJae
	Last Change	: 1995.8.24.
			  1999.7.27 -- trie.c  и
	  ڰ Ƿ     ϴ.
	
	  ޸𸮿 ÷ ϱ  Լ̴.
	̶ ޸𸮴 ڵ ҴǾ ִ.
	 disk cache ڵ ȴ.
	ex)
		out=dcache_open("out.txt",O_RDWR|O_CREAT,sizeof(SOMETYPE));
		*(SOMETYPE *)dc_add_w(out,idx2++)=sometype_data;
		dcache_close(out);
	ex2)
		SOMETYPE *t;
		t=(SOMETYPE *)dc_add_w(out,idx2++)
		t->a = 1;
		t->b = 2;

-----------------------------------------------------------------------*/
#ifndef __dcache_h
#define __dcache_h 1


/* ּ   ⺻ Ÿ Ÿ 
	DC_PAGE : 3 byte
	DC_OFFSET : 1 byte
	DC_IDX 	: 4 byte
		DC_IDX = DC_PAGE:DC_OFFSET
	page offset disk access ̱  cache page
	(disk to memory buffer) Ͽ ʿϴ.
*/
typedef unsigned long DC_IDX;
typedef	unsigned long DC_PAGE;
typedef unsigned char DC_OFFSET;

/* DISK CACHE  ü 
	ũ ִ  ġ ޸𸮿 ִ ó ϰ Ѵ.
	ũ      .
*/

typedef struct DCTYPE {			/* disk to cache page map */
	DC_PAGE		dpage;
	DC_PAGE		cpage; 
} DCTYPE;

typedef struct CDTYPE{			/* cache to disk map */
	DC_PAGE 	dpage;
	DC_PAGE		prev_cpage;	/* lru pointer */
	DC_PAGE		next_cpage;	/* lru pointer */
	long		dirty;		/* for writing */
} CDTYPE;


typedef struct DCACHE {
    	int		fid;		/* file handle */
	int		flag;		/* file flag O_RDWR.... */
	int		fend;
	char		*fname;
	DC_PAGE 	cache_end;	/* number of cache pages used */
	DC_PAGE		lru_head;	/* ֱٿ   Ų. */
	DC_PAGE		lru_tail;	/*     */
	char 		*cache_buffer;	/* cache memory */
	DCTYPE		*dc_table;	/* dpage:cpage table */
	CDTYPE		*cd_table;	/* cpage->dpage & lru table */
	DC_IDX		unitsize;	/* 1, 4, 8, 12, 16 ... */
	long 		chit;		/* for checking the usage */
	long 		cfail;
} DCACHE;

#define DC_PAGESIZE	256	/* 256 units, it's fixed */
#define DC_MAX_PAGE	128	/* number of cache pages in memory, changable */
				/* total memory = 128*256*unitsize */
#define dc_pagesize(dc) (dc->unitsize*DC_PAGESIZE)

extern DCACHE * dcache_open(char *fname, int flag, DC_IDX unitsize);
extern void dcache_close(DCACHE *dc);
extern void dcache_truncate(DCACHE *dc, DC_IDX size);	/* file size fixing */
extern char *dc_add_r(DCACHE *dc, DC_IDX idx);	/* get addr for read only */
extern char *dc_add_w(DCACHE *dc, DC_IDX idx);	/* get addr for write */
/* dc_add_w dc_add_r ϴ  ſ ߿ϴ.
    𸣸 dc_add_w ϸ α׷  ʰ
   ſ   ִ. */

#endif

