/*---------------------------------------------------------------------- 
   global.h
----------------------------------------------------------------------*/
#ifndef __global_h
#define __global_h 1

/* VC++ ΰ  ޶ */
#ifdef _MSC_VER
#define __isspace(c) iswspace(c)
#define DIRDELIM '\\'
#else
#define __isspace(c) isspace(c)
#define DIRDELIM '/'
#endif

/* debug malloc mode̸ trace Ѵ. */

#define MAX_MALLOC_STACK 1024
extern void *_wp;
extern void _wp_in(void *_wp);
extern void _wp_out(void *_wp);

#ifdef DEBUG_MALLOC
#define malloc(size) (_wp=(void*)malloc(size),\
	_wp_in(_wp),\
	fprintf(stderr,"malloc(%s,%d):%d,%d\n",__FILE__,__LINE__,_wp,size),\
	_wp)
#define free(ptr) (_wp_out((void *)(ptr)),\
	fprintf(stderr,"free(%s,%d):%d\n",__FILE__,__LINE__,ptr),\
	free(ptr))
#endif

/* ⺻ ǹ */
#define MAX_LINE_LEN 1024
#define MAX_WORD_LEN 256

#define OK 1
#define YES 1
#define NO 0

#define MAX_WORD 256
#define MAX_LINE 1024

extern char *front_word(char *word, char *str);
extern char *front_token(char *word, char *str, char c);
extern char *front_token1(char *word, char *str, char c);
extern char *front_token2(char *word, char *str, char c);
extern char *front_morph(char *word, char *str);
extern char *front_wt(char *word, char *str);
extern char *rev_str(char *str,char *rev);


/*---------------------------------------------------------------------- 
	nonamed list --- unsigned char *list
----------------------------------------------------------------------*/
extern int is_in_list(unsigned char *list, unsigned char item);
extern int in_list(unsigned char *list, unsigned char item);
extern void out_list(unsigned char *list, unsigned char item);

extern int Sis_in_list(unsigned short *list, unsigned short item);
extern int Sin_list(unsigned short *list, unsigned short item);
extern void Sout_list(unsigned short *list, unsigned short item);

extern int strp_cmp(char **str1, char **str2);
extern int ustr_cmp(unsigned char *str1, unsigned char *str2);


/*---------------------------------------------------------------------- 
	named set --- set_type *set
----------------------------------------------------------------------*/
#define MAX_SET 512
typedef struct set_type {
	unsigned char *name[MAX_SET];
	unsigned char *data[MAX_SET];
	int count;
} set_type;

extern int initset(set_type *set);
extern int freeset(set_type *set);
extern int inset(set_type *set, char *name, char *data);
extern int setnum(set_type *set, char *name);
extern char *setdata(set_type *set, int num);

/*---------------------------------------------------------------------- 
	character set functions
----------------------------------------------------------------------*/
extern void set_AND_SUB(unsigned char *A, unsigned char *B, 
	unsigned char *C, unsigned char *nA, unsigned char *nB);
extern void set_OR(unsigned char *A, unsigned char *B, unsigned char *C);
extern void set_AND(unsigned char *A, unsigned char *B, unsigned char *C);
extern void set_SUB(unsigned char *A, unsigned char *B, unsigned char *C);

extern int shortcmp(unsigned short *p, unsigned short *q);
extern int shortlen(unsigned short *p);
extern unsigned short * shortcpy(unsigned short *p, unsigned short *q);
extern unsigned short * shortcat(unsigned short *p, unsigned short *q);

#endif
