#ifndef __SIMTI_H__
#define __SIMTI_H__ 1

#define ST_VER "simti v0.0, 1997, (C) KAIST CS Lab,\nwjlee, hspaik, yuntan, mywork\n"
#define ST_NF_DEFAULT 	300000
#define ST_MAX_WORD 	256
#define DEFAULT_FMODE 	0644

typedef unsigned long INDEX;

typedef struct ST_NODE {
	unsigned char K;	/* key */
	unsigned char CS;	/* cihld size - 0:no child */
	unsigned short I;	/* information */
	unsigned long child;	/* child idx */
} ST_NODE;


typedef struct ST_FREE {
	unsigned long size;	/* this free size : always not 0 */
	unsigned long next;	/* 0:no next, other : next pointer*/
} ST_FREE;

typedef union ST_NF {
	ST_NODE node;
	ST_FREE free;
} ST_NF;

typedef struct HEADI {
	char		version[ST_MAX_WORD-3*8];
	ST_FREE	 	s_free;
	ST_NODE  	s_node;
	unsigned long 	n_size;
	unsigned long 	f_size;
} HEADI;

typedef struct SIMTI {
	char flag;
	char change;
	long		search_end; /* global array and variables
        		_search(), _firstkey(), _nextkey()   */
	unsigned char	search_word[ST_MAX_WORD]; 
	INDEX		search_idx[ST_MAX_WORD];
	char * filename;
	HEADI * head;
	ST_NF * nf;
} SIMTI;


/*----------------------------------------------------------------------
	external functions & variables
----------------------------------------------------------------------*/

SIMTI	*simti_init();				/* if NULL, Wrong */
SIMTI *simti_clean(SIMTI *stp);

SIMTI	*simti_read(char *fname, char flag);	/* if NULL, Wrong */
int	simti_write(SIMTI *stp, char *fname);	/* -1 : error */
int	simti_close(SIMTI *stp);		/* -1 : error */
void 	simti_stat(SIMTI * stp);

INDEX	simti_alloc(SIMTI *stp, unsigned long size);
	/*	sizeŭ node ȮϿ
		idx return	
		0: no free node */ 

int	simti_free(SIMTI *stp, INDEX idx, unsigned long size);
	/*	idxκ sizeŭ node freeŲ.
		 sibling  free,allocѴ 	
		-1: out of range, or  size<=0 	*/

int	simti_insert(SIMTI *stp, unsigned char *word, unsigned short I);
	/* 	-1 : fail
		0  : duplicated
		1  : success 	*/

int	simti_replace(SIMTI *stp, unsigned char *word, unsigned short I);
	/* 	-1 : fail
		1  : success 	*/

int	simti_delete(SIMTI *stp, unsigned char *word);
	/* 	-1 : fail
		0  : Not exist
		1  : success 	*/

int	simti_firstkey(SIMTI *stp, unsigned char *word);
	/* 	0  : Not found
		0< : ã ڿ 	
		first child  ó  ִ  
		word  	*/

int	simti_nextkey(SIMTI *stp, unsigned char *word);
	/* 	0  : Not found
		0< : ã ڿ 	
		child,sibling,parent   ܾ ã´	*/

int	simti_search(SIMTI *stp, unsigned char *word);
	/* 	0  : Not found
		0< : ã ڿ 	*/

int	simti_lookup(SIMTI *stp, unsigned char *word, unsigned short *I_buffer);
	/* 	0  : Not found
		0< : ã ڿ 	
		simti_search()̿
		ã  ŭ I_buffer 	*/

unsigned short	simti_fetch(SIMTI *stp, unsigned char *word);
	/* 	0  : Not exist
		o/w: information I(tag )	*/

SIMTI	*simti_packing(SIMTI *stp); 	/* if NULL, Wrong */


#endif
