/***********************************************************************
	cnt.c : connection table ش.
	
***********************************************************************/
#include <stdio.h>

#include <sys/types.h> 	/* for open() */
#include <sys/stat.h>
#include <fcntl.h>

#include "tags.h"
#include "cnt.h"
#include "../share/global.h"

/* data to read */
char cnt_title[256];
char cnt_version[256];
char cnt_copyright[256];
char cnt_author[256];
char cnt_date[256];
char cnt_editor[256];
char ct_version[256];

/*----------------------------------------------------------------------
        connection table
        bit-operation needed
                a = t2/8;
                b = t2%8;
                ctable[t1][a] |= (1 << b);
----------------------------------------------------------------------*/
int cnt_start_tag;
unsigned char ctable[MAXTAG][32];
/*-------------------------------------------------------------------------
    initcnt() function
        initiate connetion table
-------------------------------------------------------------------------*/
initcnt()
{
	int i,j;
	/* init connection table */
	for(i=0;i<MAXTAG;i++)
	for(j=0;j<32;j++)
		ctable[i][j] = 0;
}

/*-------------------------------------------------------------------------
    set_connection() function
        yset,xset: rule ¿, tag set Ķͷ ޴´.
        ΰ tag set ޾Ƽ connection ctable ־ش.
         ctable  ־ִ κ̴.
                
-------------------------------------------------------------------------*/
set_connection(unsigned char *yset, unsigned char *xset)
{
	unsigned char t1,t2;
	unsigned char a,b;
	unsigned char *x, *y;
	for(y=yset;*y;y++)
	{
		t1 = *y;
		for(x=xset;*x;x++)
		{
			t2 = *x;
			a = t2/8;
			b = t2%8;
			ctable[t1][a] |= (1 << b);
/*
if(t1==tagnum("px"))
fprintf(stderr,"%s,",tagname[t2]);
fprintf(stderr,"(%d,%d)",t1,t2);
*/
		}
/*
fprintf(stderr,"\n");
*/
	}
}

char cntstack[256];
unsigned char xset[256];
unsigned char yset[256];
unsigned char tmpset1[256];
unsigned char tmpset2[256];
unsigned char tname[256];

/*-------------------------------------------------------------------------
    mkcnt() fucntion
        cntstr: connection rule file(cnts.txt) CONNECTION 
                 Ѱ rule Ѵ. (ex)(jcj)*(s-su-sy-sl,iwg)  ¸  
        rule 鼭, ¿ tag set ˾Ƴ,
        * ¿ tag set connection set_connection()
        Լ callϿ ش.
-------------------------------------------------------------------------*/
mkcnt(char *cntstr)
{
	int i,j,tn;
	unsigned char *A,*B,*C;
	char *str;
	unsigned char cntsp=254;
	cntstack[255]=0;
	A=yset,B=tmpset1,C=tmpset2;
	xset[0]=yset[0]=tmpset1[0]=tmpset2[0]=0;

	for(str=cntstr;*str;str++)
	{
		switch(*str)
		{
			case '(' : 	if(cntstack[cntsp+1]==0)
						A=yset;
					else if(cntstack[cntsp+1]=='*')
						A=xset;
					else
					{
			fprintf(stderr,"invalid op position %s\n",cntstr);
						exit(0);

					}
					cntstack[cntsp--]=*str;
					cntstack[cntsp--]=',';
					break;
			case ')' : 
			case '-' : 
			case ',' : if(isalpha(cntstack[cntsp+1]) ||
					cntstack[cntsp+1] == '_')
				{
					for(i=0,cntsp++;;i++,cntsp++)
					{
						if(cntstack[cntsp] == ',' ||
							cntstack[cntsp]=='-')
							break;
						tname[i]=cntstack[cntsp];
					}
					tname[i]=0;
					
					//stack Ųٷ  tag name ڹٲ.
					for(i=0,j=strlen(tname)-1;i<j;i++,j--)
					{
						char t;
						t=tname[i];
						tname[i]=tname[j];
						tname[j]=t;
					}	
					//tag name tag set   
					if((tn=tsetnum(tname)) != -1)
					{
						strcpy(B,tset[tn]);
					}
					//tag name tag ϰ 
					else if((tn=tagnum(tname)) != -1)
					{
						B[0]=tn;
						B[1]=0;
					}
					else
					{
			fprintf(stderr,"tag/tagset not defined %s\n",tname);
						exit(0);
					}
					if(cntstack[cntsp] == ',')
					{
						set_OR(A,B,C); 
					}
					else
						set_SUB(A,B,C); 
					strcpy(A,C);
					if(*str == ')')
					{
/*
						if(cntstack[cntsp+1] == '(')
*/
							cntsp++;
					}
					else
						cntstack[cntsp--]=*str;
				}
				else
				{
			fprintf(stderr,"invalid op position %s\n",cntstr);
					exit(0);
				}
					break;
			case '*' : if(cntstack[cntsp+1] == 0)
					cntstack[cntsp--]=*str;
				else
				{
			fprintf(stderr,"invalid op position %s\n",cntstr);
					exit(0);
				}
					break;
			default : if(isalnum(*str) || *str == '_')
				{
				 	cntstack[cntsp--]=*str;
				}
				else
				{
					fprintf(stderr,"unknown op '%c'\n",*str);
				}
		}
/*
		fprintf(stderr,"cntsp %d %c\n",cntsp+1,cntstack[cntsp+1]);
*/
	}
	cntsp++;
	if(cntsp != 254 || cntstack[cntsp] != '*')
	{
		fprintf(stderr,"connetion string not ended %s\n",cntstr);
		fprintf(stderr,"cntsp %d %c\n",cntsp,cntstack[cntsp]);
		exit(0);
	}
	else if(strlen(xset) == 0 || strlen(yset) == 0)
	{
		fprintf(stderr,"connetion xset/yset = NULL : %s\n",cntstr);
		exit(0);
	}
	set_connection(yset, xset);
}
/*-------------------------------------------------------------------------
    cntread() function
        cnt.scf  о,
        connection rule ϳ ctable ִ´.
        (̹ cnt.txt о, connection rule óϱ⽱ cnt.scf
            Ϸ   ¶ ״ б⸸ ϸ ȴ. )
-------------------------------------------------------------------------*/
int cntread(char *infname)
{
	int i,j;
	int cntfile;

	if((cntfile = open(infname,O_RDONLY)) == -1)
	{
		fprintf(stderr,"Error : can not open [%s]\n",infname);
		exit(0);
	}
	/* -------------------------------
		reading 
	------------------------------- */
	read(cntfile,cnt_title,256);
	read(cntfile,cnt_version,256);
	read(cntfile,cnt_copyright,256);
	read(cntfile,cnt_author,256);
	read(cntfile,cnt_date,256);
	read(cntfile,cnt_editor,256);
	read(cntfile,ct_version,256);
	read(cntfile,&cnt_start_tag,sizeof(int));
	read(cntfile,&tagsend,sizeof(int));
	for(i=1;i<tagsend;i++)
	{
		read(cntfile,&ctable[i],32);
	}

	close(cntfile);
}

