/***********************************************************************
	cntwrite.c
	connection table  Ѵ.
	tags.txt  tags.c/tagread() ȣ⿡ оδ. 
	cnts.txt  о connection table  cnts.scfϷ ش.
***********************************************************************/

#include <stdio.h>

#include <sys/types.h> 	/* for open() */
#include <sys/stat.h>
#include <fcntl.h>

//#include "sdmlike.h"
#include "../share/tags.h"
#include "../share/cnt.h"

/* state * /
#define SOF	0
#define SDML	1
#define HEAD	2
#define TITLE	3
#define VERSION	4
#define COPY	5
#define AUTHOR	6
#define DATE	7
#define EDITOR	8
#define BODY	9
/* state transition * /
char state_trans[10][10] = {
/*		  S  S  H  T  V  C  A  D  E  B */
/*SOF* /		{-1, 1, 0, 0, 0, 0, 0, 0, 0, 0},
/*SDML* /	{ 0,-1, 1, 0, 0, 0, 0, 0, 0, 1},
/*HEAD* /	{ 0, 0,-1, 1, 1, 1, 1, 1, 1, 0},
/*TITLE* /	{ 0, 0, 0,-1, 2, 2, 2, 2, 2, 0},
/*VERSION* /	{ 0, 0, 0, 2,-1, 2, 2, 2, 2, 0},
/*COPYRIGHT* /	{ 0, 0, 0, 2, 2,-1, 2, 2, 2, 0},
/*AUTHOR* /	{ 0, 0, 0, 2, 2, 2,-1, 2, 2, 0},
/*DATE* /	{ 0, 0, 0, 2, 2, 2, 2,-1, 2, 0},
/*EDITOR* /	{ 0, 0, 0, 2, 2, 2, 2, 2,-1, 0},
/*BODY* /	{ 0, 0, 0, 0, 0, 0, 0, 0, 0,-1}
};
char state[10];
char state_idx;

/* body state * /
#define BODYSTART 	0
#define USE_TAG 	1
#define START_TAG 	2
#define CONNECTION 	3
/* */

//int cntbody_state=BODYSTART;


char infname[256];
char outfname[256];
char tagfname[256];
int main(int argc, char *argv[])
{
	FILE *infp;
	int cntfile;
	int re;			/* re for yylex() return value */
	int i=0,j;		/* i,j : general index */
	int st, newstate;
	int doctype=0;


	if(argc < 4)
	{
		fprintf(stderr,"%s <tagfile> <infile> <outfile>\n",argv[0]);
		fprintf(stderr,"\t<tagfile> : tagset file\n");
		fprintf(stderr,"\t<infile> : text source file\n");
		fprintf(stderr,"\t<outfile> : cnt outfile\n");
		exit(0);
	}

	/* tag read */
	tagread(argv[1]);
	initcnt();

	/* conectioin open */
	strcpy(infname,argv[2]);
	strcpy(outfname,argv[3]);
	infp = fopen(infname,"r");
	if(infp == NULL)
	{
		fprintf(stderr,"infile open error : %s\n",infname);
		exit(0);
	}
	if((cntfile = open(outfname,O_CREAT|O_RDWR,0644)) == -1)
	{
		fprintf(stderr,"Error : can not open [%s] for tag out\n",outfname);
		exit(0);
	}

	cnt_title[0]=0;
	cnt_version[0]=0;
	cnt_copyright[0]=0;
	cnt_author[0]=0;
	cnt_date[0]=0;
	cnt_editor[0]=0;
//⿡  ó κ ־  -  
	/* -------------------------------
		start processing
	------------------------------- * /
	while( (re=yylex()) != 0)
	{
		if(re == '\n')
			continue;
		switch(re)
		{
			case _head: 
			case _body:
				if(doctype=0)
				{
					fprintf(stderr,"error doctype not def'd\n");
					exit(0);
				}
			case _sdml:
			case _title:
			case _version:
			case _copyright:
			case _author:
			case _date:
			case _editor:
				newstate=(re-_sdml)/2 + 1;
				st = state_trans[state[state_idx]][newstate];
				if(st==0)
				{
					yyerror("sdml-tag position error");
					exit(0);
				}
				else if(st==-1)
				{
					yyerror("sdml-tag recursion");
					exit(0);
				}
				else if(st==1)	/* 1 ok, continue * /
					state[++state_idx]=newstate;
				else	/* 2 ok, continue * /
					state[state_idx]=newstate;
/*------------------------------------*/
/* Ⱑ ̺  ߿ κ */
{
	int linenum=0;
	char line[1024],cur[1024],data[1024];
	char *tmp;
	int tn=-99;

	while(fgets(line,1024,infp)!=NULL)
	{
		linenum++;
		tmp=front_word(cur,line);
		if (!tmp||*cur=='/')
			continue;
		else if (!strcmp(cur,"USE_TAG"))
		{
			tmp=front_word(data,tmp);
			if (!tmp||*data=='/')
			{
				fprintf(stderr,"Error : USE_TAG - in the line %d\n",linenum);
				exit(1); 
			}
			/*	version check 
			else if (strcmp(data,tag_version))
			{
				fprintf(stderr,"use_tag version mismatch -- tag:%s, cnt:%s\n",tag_version, string_buf);
				exit(0);
			}
			*/
		}
		else if(!strcmp(cur,"START_TAG"))
		{
			tmp=front_word(data,tmp);
			if (!tmp||*data=='/')
			{
				fprintf(stderr,"Error : tag name is needed - in the line %d\n",linenum);
				exit(1); 
			}
			tn = tagnum(data);
			if(tn == -1)
			{
				fprintf(stderr,"Error : tag name not exist %s- in the line %d\n",data,linenum);
				exit(0);
			}
			else cnt_start_tag = tn;
		}
		else if(!strcmp(cur,"CONNECTION"))
		{
			if (tn==-99)
			{
				fprintf(stderr,"Error : START_TAG is not defined - in the line %d\n",linenum);
				exit(0);
			}
			tmp=front_word(data,tmp);
			if (!tmp||*data=='/')
			{
				fprintf(stderr,"Error : connection information is needed - in the line %d\n",linenum);
				exit(0);
			}
			mkcnt(data);
		}
		else
		{
			fprintf(stderr,"Error : unknown Keyword - in the line %d\n",linenum);
			exit(0);
		}
	}
}
/*------------------------------------* /
			case _esdml:
			case _ehead:
			case _etitle:
			case _eversion:
			case _ecopyright:
			case _eauthor:
			case _edate:
			case _eeditor:
			case _ebody: 
				newstate=(re-_sdml)/2 + 1;
				if(state_idx>0&&newstate==state[state_idx])
					state_idx--;
				else
				{
					yyerror("sdml-tag no match");
					exit(0);
				}
				break;
			case _str:
/*--------------------------------------------------------------------------* /
switch(state[state_idx])
{
	case SOF	: break;
	case TITLE	: strcat(cnt_title,string_buf);break;
	case VERSION	: strcat(cnt_version,string_buf);break;
	case COPY	: strcat(cnt_copyright,string_buf);break;
	case AUTHOR	: strcat(cnt_author,string_buf);break;
	case DATE	: strcat(cnt_date,string_buf);break;
	case EDITOR	: strcat(cnt_editor,string_buf);break;
	case SDML	: if(strcmp("CNT",string_buf) == 0)
				doctype++;
			  else
			  {
				yyerror("doctype error"); exit(0);
			  }
			  break;
	case BODY	: break;
	default		: yyerror("not a sring position"); exit(0);
}
break;
/*--------------------------------------------------------------------------* /
			case _name:
/*
				if(state[state_idx] != BODY)
* /
				{
					yyerror("not allowed literal");
					exit(0);
				}
				break;
			default: 	
				yyerror("string error");
				exit(0);
		}
	}

	/* -------------------------------
		writing 
	------------------------------- */
	write(cntfile,cnt_title,256);
	write(cntfile,cnt_version,256);
	write(cntfile,cnt_copyright,256);
	write(cntfile,cnt_author,256);
	write(cntfile,cnt_date,256);
	write(cntfile,cnt_editor,256);
	write(cntfile,tag_version,256);
	write(cntfile,&cnt_start_tag,sizeof(int));
	write(cntfile,&tagsend,sizeof(int));
	for(i=1;i<tagsend;i++)
	{
		write(cntfile,&ctable[i],32);
	}
/*
	fprintf(stdout,"T %s\n",cnt_title);
	fprintf(stdout,"V %s\n",cnt_version);
	fprintf(stdout,"C %s\n",cnt_copyright);
	fprintf(stdout,"A %s\n",cnt_author);
	fprintf(stdout,"D %s\n",cnt_date);
	fprintf(stdout,"E %s\n",cnt_editor);
	fprintf(stdout,"V %s\n",tag_version);
	fprintf(stdout,"ST%d\n",cnt_start_tag);
	fprintf(stdout,"TE%d\n",tagsend);
	for(i=1;i<tagsend;i++)
	{
		for(j=1;j<32;j++)
			fprintf(stdout,"\\x%02x ",ctable[i][j]);
		fprintf(stdout,"\n");
	}
*/

	/* -------------------------------
		closing
	------------------------------- */
	fclose(infp);
	close(cntfile);
}
