/***********************************************************************
	tagwrite.c	v1.1

	-- revised by yuntan :
	= lex   óϵ .
	=   ʴ´. ( ʿ)
	= tag  ڿ tagset  ;   ó ʴ´ (ʿ)

	tagset о̴ α׷
	standard tag form Ѵ.
***********************************************************************/

#include <stdio.h>

#include <sys/types.h> 	/* for open() */
#include <sys/stat.h>
#include <fcntl.h>

//#include "sdmlike.h"
#include "../share/tags.h"

/* state */
#define SOF	0
#define SDML	1
#define HEAD	2
#define TITLE	3
#define VERSION	4
#define COPY	5
#define AUTHOR	6
#define DATE	7
#define EDITOR	8
#define BODY	9

/* tagwrite   */
int instag(char *str)
{
        int i;
        for(i=tagsend;i>1;i--)
                if(strcmp(str,tagname[i-1]) > 0)
                        break;
                else
                        strcpy(tagname[i],tagname[i-1]);
        tagsend++;
        strcpy(tagname[i],str);
        return i;
}
int insirr(char *str)
{
        int i;
        for(i=irrsend;i>1;i--)
                if(strcmp(str,irrname[i-1]) > 0)
                        break;
                else
                        strcpy(irrname[i],irrname[i-1]);
        irrsend++;
        strcpy(irrname[i],str);
        return i;
}

int instset(char *str, char *t)
{
        int i;
        for(i=tsetend;i>1;i--)
                if(strcmp(str,tsetname[i-1]) > 0)
                        break;
                else
                {
                        strcpy(tsetname[i],tsetname[i-1]);
                        strcpy(tset[i],tset[i-1]);
                }
        tsetend++;
        strcpy(tsetname[i],str);
        strcpy(tset[i],t);
        return i;
}


char infname[256];
char outfname[256];
int main(int argc, char *argv[])
{
	FILE *infp;
	int tagfile;
	int sw=0;			/* sw for header processing. */
	int i=0;		/* i,j : general index */
	int st, newstate;
	int doctype=0;

	if(argc < 3)
	{
		fprintf(stderr,"%s <infile> <outfile>\n",argv[0]);
		fprintf(stderr,"\t<infile> : text source file\n");
		fprintf(stderr,"\t<outfile> : standard tag_data_type file\n");
		exit(0);
	}

	/* tag file open */
	strcpy(infname,argv[1]);
	strcpy(outfname,argv[2]);

	infp = fopen(infname,"r");
	if(infp == NULL)
	{
		fprintf(stderr,"infile open error : %s\n",infname);
		exit(0);
	}
	if((tagfile = open(outfname,O_CREAT|O_RDWR,0644)) == -1)
	{
		fprintf(stderr,"Error : can not open [%s] for tag out\n",outfname);
		exit(0);
	}

	tag_title[0]=0;
	tag_version[0]=0;
	tag_copyright[0]=0;
	tag_author[0]=0;
	tag_date[0]=0;
	tag_editor[0]=0;
/* ⿡ ó   Ѵ */

/*--------------------------------------------------------------------------* /
				body processing
/*--------------------------------------------------------------------------*/
{
	int tn, tsn, tsettmpidx;
	char tsettmp[256];

	int	linenum=0;
	char line[1024], cur[1024];
	char curtag[1024], curtset[1024];
	char *tmp;
	int j;
	unsigned char t;


	while(fgets(line,1024,infp)!=NULL)
	{
		linenum++;
		tmp=front_word(cur,line);
		// if (!tmp || *cur=='/' ) 
		 if (!tmp || *cur=='/' || *cur=='<') 
			continue;
		else
		{
			if (strcmp(cur,"TAG") == 0)
			{	/* TAG б */
				tmp=front_word(curtag,tmp);
				if (!tmp || *curtag=='/')
				{
					fprintf(stderr,"Error : tagname is needed - in the line %d\n",linenum);
					exit(1);
				}
				else instag(curtag); /* tag  */
			}

			else if (strcmp(cur,"TSET") == 0)
			{
				tsettmpidx=0;
				tmp=front_word(curtset,tmp);
				if (!tmp || *curtset=='/')
				{
					fprintf(stderr,"Error : tagsetname is needed - in the line %d\n",linenum);
					exit(1);
				}
				else
				{
					tsn = instset(curtset,""); 
					while((tmp=front_word(curtag,tmp))!=NULL )
					{ 
						if (*curtag=='/')
							if (tsettmpidx==0) {

							fprintf(stderr,"Error : tagname is needed - in the line %d\n",linenum);
							exit(1);
						}
							else break;
						if((tn = tsetnum(curtag))>0)
						{
							strcat(tsettmp,tset[tn]);
							tsettmpidx+=strlen(tset[tn]);
						}
						else if((tn = tagnum(curtag))>0)
						{
							tsettmp[tsettmpidx++]=tn;
							tsettmp[tsettmpidx]=0; 
						}
						else 
						{
							fprintf(stderr,"Error : '%s' tag was not defined - in line %d\n",curtag,linenum);
							exit(0);
						}
					} 
					if(tsettmpidx==0) 
					{
						fprintf(stderr,"Error :tset %s has no tag element - in line %d\n",tsetname[tsn],linenum);
						exit(0);
					}
				/* sort */ 
					for(i=0;i<tsettmpidx-1;i++)
						for(j=i+1;j<tsettmpidx;j++)
							if(tsettmp[i]>tsettmp[j])
							{ 
								t=tsettmp[i];
								tsettmp[i]=tsettmp[j];
								tsettmp[j]=t;
							} 
					/* merge */
					for(i=0;i<tsettmpidx-1;)
						if(tsettmp[i]==tsettmp[i+1])
						{
							for(j=i+1;j<tsettmpidx;j++)
								tsettmp[j]=tsettmp[j+1];
							tsettmpidx--;
						}
						else i++; 
					strcpy(tset[tsn], tsettmp);
				} 
			}
			else if(strcmp(cur,"IRR") == 0)
			{
				tmp=front_word(curtag,tmp);
				if (!tmp||*curtag=='/')
				{
					fprintf(stderr,"Error : irrname is needed - in the line %d\n",linenum);
					exit(1);
				}
				else insirr(curtag);
			}
			else
			{
				fprintf(stderr,"Error: unkwon keyword - in the line %d\n",linenum);
				exit(0);
			}
		}
	}
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------* /
	switch(state[state_idx])
	{
		case SOF	: break;
		case TITLE	: strcat(tag_title,string_buf);break;
		case VERSION	: strcat(tag_version,string_buf);break;
		case COPY	: strcat(tag_copyright,string_buf);break;
		case AUTHOR	: strcat(tag_author,string_buf);break;
		case DATE	: strcat(tag_date,string_buf);break;
		case EDITOR	: strcat(tag_editor,string_buf);break;
		case SDML	: if(strcmp("TAGS",string_buf) == 0)
					doctype++;
			  	else
			  	{
					yyerror("doctype error"); exit(0);
			  	}
			  	break;
		case BODY	: break;
		default		: yyerror("not a sring position"); exit(0);
	}
	break;
/*--------------------------------------------------------------------------*/

	/* -------------------------------
		writing 
	------------------------------- */
	write(tagfile,tag_title,256);
	write(tagfile,tag_version,256);
	write(tagfile,tag_copyright,256);
	write(tagfile,tag_author,256);
	write(tagfile,tag_date,256);
	write(tagfile,tag_editor,256);
	write(tagfile,&tagsend,sizeof(int));
	for(i=1;i<tagsend;i++)
		write(tagfile,tagname[i],TAGLEN);
	write(tagfile,&irrsend,sizeof(int));
	for(i=1;i<irrsend;i++)
		write(tagfile,irrname[i],IRRLEN);
	write(tagfile,&tsetend,sizeof(int));
	for(i=1;i<tsetend;i++)
		write(tagfile,tsetname[i],TAGLEN);
	for(i=1;i<tsetend;i++)
		write(tagfile,tset[i],TSETLEN);
/*
	fprintf(stdout,"%s\n",tsetname[i]);

	fprintf(stdout,"T %s\n",tag_title);
	fprintf(stdout,"V %s\n",tag_version);
	fprintf(stdout,"C %s\n",tag_copyright);
	fprintf(stdout,"A %s\n",tag_author);
	fprintf(stdout,"D %s\n",tag_date);
	fprintf(stdout,"E %s\n",tag_editor);
	for(i=1;i<tagsend;i++)
		fprintf(stdout,"t%d: %s\n",i,tagname[i]);
*/

	/* -------------------------------
		closing
	------------------------------- */
	fclose(infp);
	close(tagfile);
}
