#!/usr/local/bin/perl
use Getopt::Long;

##---------------------------------------------------------------------------
## Globals
##---------------------------------------------------------------------------
($PROG = $0) =~ s/.*\///;
$VERSION = "0.1";
#%tagnum = ( "bnk",0, "co",1, "ec",2, "ef",3, "ep",4, "etm",5, "etn",6, "f",7, "ii",8, "jc",9, "jj",10, "jm",11, "jx",12, "mag",13, "maj",14, "mm",15, "nb",16, "nc",17, "nn",18, "np",19, "pa",20, "pv",21, "px",22, "s",23, "xp",24, "xsm",25, "xsn",26, "xsv",27, "eos",28);

sub usage() {
	print STDOUT <<EndOfUsage;
$main::PROG -- 濬 ѱ Maximum Entropy °Դϴ.

METagger.pl	--help
			--debug

Version: $main::VERSION
	Copyright (C) 1999 濬. KAIST
EndOfUsage

	exit 0;
}

##---------------------------------------------------------------------------
## MAIN !
##---------------------------------------------------------------------------

# Option ó
GetOptions("help!", \$help, "debug!", \$debug);
if ($help) {
	usage();
}

# Taglist  оδ.
# TagNumHash ʱȭ - Tag̸ ָ ׿ شϴ ڸ Ѵ.
%tagnum = ();
$cnt = 0;
$TAGLIST = "/home/gykim/METagger/TAG_LIST.TXT";
open(IN, $TAGLIST) || die "Cant open $TAGLIST";
while($line = <IN>) {
	chomp $line;
	$tagnum{$line} = $cnt;
	$cnt++;
}
close(IN);
if($debug) {
print "--------------- Tag List Դϴ. ---------------\n";
print join("|", %tagnum), "\n";
}

# Maximum Entropy Ȯ Ķ͸ оδ.
if($debug) {
print "--------------- Maximum Entropy Ķ Դϴ. ---------------\n";
}
$cnt = 0;
$param_file = "/home/gykim/METagger/Param_TTT.txt"; 
open(IN, $param_file) or die "Can't open parameter file";
while($line = <IN>) {
	chomp $line;
	$param[$cnt] = $line; 

if($debug) {
print "$cnt - $param[$cnt]\n";
}
	$cnt++
}
close(IN);

# ¼/± Ȯ(P(W|T) оδ.)
# DBM ؾϳ ϴ .
$PWTFILE = "/home/gykim/METagger/PWT.txt";
open(IN, $PWTFILE) || die "Cant open $PWTFILE";
while($line = <IN>) {
	($wt, $prob) = split(' ', $line);
	$pwt_prob{$wt} = $prob;
}

# --------------------------------------------------------
# ¼ м  <STDIN> о鿩 ±Ѵ.
if($debug) {
print "------------- 2. ¼ м  Դϴ. --------------\n";
}
$cnt = 0;
while($line = <STDIN>) {
	chomp $line;

	if ($line =~ /test/) { next; }
	if ($line =~ /^EOS/) { next; } # angelove
	if ($line =~ /^$/) { next; }

	if (not $line =~ /^	/) {	#  
		if($debug) { print $line, "\n"; }
		push(@sent, $line);

		if ($cnt++ == 0) { next; }
		$wpcnt++;

		#   Ȯ ִ  .
		$prob_max = -1000000.0;
		@allkeys = keys(%wplist);
		foreach $key (@allkeys) {
			if ($wplist{$key} > $prob_max) { 
				$prob_max = $wplist{$key}; 
				$max_seq = $key;
			}
		}
#		$max_seq =~ s/EOS\/eos//g;
		$max_seq =~ s/^EOS\/eos//g; # angelove
		$max_seq =~ s/EOS\/eos/\n/g; # angelove
		$max_seq =~ s/BNK\/bnk//g;
		$max_seq =~ s/^\+//g;
		$max_seq =~ s/\+$//g;
if($debug) { print "Maximun Entropy Sequence - $max_seq\n"; }
		push(@tagged_sent, $max_seq);
		%wplist = ();

	} else {	# ¼ м  
		# տ ִ TAB 
		$line =~ s/	//g;

		# ù  
		if ($wpcnt == 1) { $line =~ s/^/EOS\/eos+/; }
		else { $line =~ s/^/BNK\/bnk+/; }

		#   
		if ($line =~ /.\/s/) { $line .= "+EOS/eos"; }
		else { $line .= "+BNK/bnk"; } 

		# unk  nc ٲ.
		$line =~ s/unk/nc/g;

		#    Ȯ Maximum Entropy Ѵ.
		$prob = &ComputeSeqProb($line);	
		$wplist{$line} = $prob;
		
		if($debug) { print $line, " [$wplist{$line}]", "\n"; }
	}
}

	#       .
	$prob_max = -1000000.0;
	@allkeys = keys(%wplist);
	foreach $key (@allkeys) {
		if ($wplist{$key} > $prob_max) { 
			$prob_max = $wplist{$key}; 
			$max_seq = $key;
		}
	}
	$max_seq =~ s/EOS\/eos//g;
	$max_seq =~ s/BNK\/bnk//g;
	$max_seq =~ s/^\+//g;
	$max_seq =~ s/\+$//g;
	push(@tagged_sent, $max_seq);
if($debug) { print "Maximun Entropy Sequence - $max_seq\n"; }
	%wplist = ();
# --------------------------------------------------------

# ±  ش.
if($debug) {
print "------------- 3. ± Դϴ. --------------\n";
}
	if ($#tagged_sent != $#sent) {
		print "!Էµ  ±   ġ ʽϴ.\n";
	}
	for ($i=0; $i<=$#tagged_sent; $i++) {
#		print $sent[$i], "\t", $tagged_sent[$i], "\n"; 
		print $tagged_sent[$i], "\n";  # angelove
	}
	print "\n";

#-----------------------------------------------------------------------
#  ƾ 
#-----------------------------------------------------------------------
sub ComputeSeqProb
{
	my($wp) = shift(@_);
	my($mor_tags, $i, $mor, $tag, $tags, $tag_tri, $probs, $ret);

	$ret = 0.0;
	@tags = ();
	@mor_tags = split(/\+/, $wp);

#print "ComputeSeqProb - mor_tag ", join("|", @mor_tags), "\n";

	for ($i=0; $i<=$#mor_tags; $i++) {
		($mor, $tag) = split(/\//, $mor_tags[$i]);
		push(@tags, $tag);  
	}
#print "ComputeSeqProb - tags ", join("|", @tags), "\n";
	for ($i=1; $i<$#mor_tags; $i++) {

		if ($i-1 < 0) { push(@tag_tri, $tags[$i]); } 
		else { push(@tag_tri, $tags[$i-1]); } 

		push(@tag_tri, $tags[$i]);  

		if ($i+1 > $#mor_tags) { push(@tag_tri, $tags[$i]); } 
		else { push(@tag_tri, $tags[$i+1]); } 

		$ret += log(&ComputeTrigramProb(@tag_tri)) 
			+ $pwt_prob{$mor_tags[$i]}; 
		@tag_tri = ();
	}
	return $ret; 
}

sub GetParamValue {
	my($feature_num) = shift(@_);
	return $param[$feature_num];
	#if ($param[$feature_num] < 0) {
	#	return $param[$feature_num];
	#} else {
	#	return 1.0;
	#}	
}

sub ComputeTrigramProb
{
	my($tag_tri) = shift(@_);
	my($i);
	my($main_prob) = 0.0;
	my($zb) = 0.0;

#print join("|", @tag_tri), "-$tagnum{$tag_tri[0]}, $tagnum{$tag_tri[1]}, $tagnum{$tag_tri[2]}\n";
	my(@allkeys) = keys(%tagnum);
#print "tagnum = ", %tagnum, $#allkeys,"\n";

	# Compute Z(b)
	for ($i=0; $i<=$#allkeys; $i++) { 
		$zb += exp(
			&GetParamValue($tagnum{$tag_tri[0]}) + 
			&GetParamValue($tagnum{$tag_tri[1]}+29) + 
			&GetParamValue($i+58) );
	}

	# Compute IIalpha^fj(a,b)
	$main_prob = exp(
			&GetParamValue($tagnum{$tag_tri[0]}) +
			&GetParamValue($tagnum{$tag_tri[1]}+29) +
			&GetParamValue($tagnum{$tag_tri[2]}+58) );

	return $main_prob / $zb;
}

