#include <stdio.h>
#include <string.h>

#include "global.h"
#include "trie.h"

#include "cnvtag.h"

static char tag_set[][10]={
"sf","b10000",
"sp","b10000",
"sl","b10000",
"sr","b10000",
"sd","b10000",
"se","b10000",
"su","b10000",
"sy","b10000",
"f","100000",
"ncpa","122022",
"ncps","122022",
"ncn","122022",
"ncr","122022",
"nqq","110000",
"nqpa","110000",
"nqpb","110000",
"nqpc","110000",
"nq","110000",
"nbu","211001",
"nbn","211001",
"nbs","211001",
"npp","220011",
"npd","220021",
"nnc","233011",
"nno","233021",
"pvd","600000",
"pvg","600000",
"pad","700000",
"paa","700000",
"px","600000",
"mmd","931210",
"mma","931210",
"mad","322100",
"maj","324200",
"mag","324100",
"ii","b20000",
"jcs","410110",
"jco","410122",
"jcc","430113",
"jcm","420131",
"jcv","410100",
"jca","410132",
"jcj","410100",
"jct","410100",
"jcr","441100",
"jxc","430100",
"jxf","430100",
"jp","520100",
"ep","800000",
"ecc","921001",
"ecs","922602",
"ecx","923000",
"etn","933132",
"etm","931210",
"ef","911000",
"xp","a10000",
"xsnu","a22100",
"xsnca","a22100",
"xsncc","a22100",
"xsna","a22100",
"xsns","a22100",
"xsnp","a22100",
"xsnx","a22100",
"xsvv","a20000",
"xsva","a20000",
"xsvn","a20000",
"xsms","a20000",
"xsmn","a20000",
"xsam","a20000",
"xsas","a20000",
"xsn","a22100",
"xsv","a20000",
"xsm","a20000",
"xsa","a20000"
"$$$","$$$"
};

char RES_replace[][128] = {
"ncpa+/xsva","/paa",
"ncpa+/xsvn","/paa",
"ncps+/xsms","/pvg",
"ncps+/xsmn","/pvg",
"ncpa+Ű/xsva","Ű/paa",
"ncps+Ű/xsms","Ű/pvg",
//"nbn+/jp","/pvg",
//"ncn+/jp","/pvg",
//"nnc+/jp","/pvg",
"$$$","$$$"
};

char RES_josa[][10] = {
"jc","","1_5",                                                            
"jc","","1_5",                                                            
"jc","μ","1_5",                                                            
"jc","鿡","1_5",                                                            
"jc","","1_A",
"jc","","1_B",
"jc","","1_2",
"jc","","1_2",
"jc","","1_1",
"jc","","1_1",
"jc","","1_1",
"jc","","1_1",
"jc","","1_1",
"jc","","1_E",
"jc","","1_3",
"jc","","1_3",
"jc","ϰ","1_3",
"jc","","1_6",
"jc","","1_7",
"jc","Լ","1_7",
"jc","κ","1_7",
"jc","","1_7",
"jc","","1_C",
"$$$","$$$","$$$"
};                    

int 
is_white_space(char ch)
{
	if (ch==' '||ch=='\t'||ch=='\r'||ch=='\n') 
		return TRUE;
	return FALSE;
}

void cnv_tag(char *buf)
{
	char *p;
	char tmp[8192],word[1024],data[1024];
	int i,j,l,s,x,flag;

	if (strstr(buf,"/pa")!=NULL||strstr(buf,"/pv")!=NULL) flag = 1;
	else flag =0;

// 	  ġȯ  ó
// 		RES_replace :   ȿ ٲ óؾ ϴ ͵ Ÿ
// 		
	for (i=0;strcmp(RES_replace[i],"$$$");i+=2) {
		if ((p=strstr(buf,RES_replace[i]))!=NULL) {
			strcpy(tmp,p+strlen(RES_replace[i]));
			*(p-1)='\0';
			strcat(buf,RES_replace[i+1]);
			strcat(buf,tmp);
		}
	}

	// tag set ȯ
	for (p=buf,s=0;*p!='\0';p++) {
		if (*p=='/') {
			tmp[s++]=*p++;
			for (i=0;strcmp(tag_set[i],"$$$");i+=2) {
				l=strlen(tag_set[i]);
				if (!strncmp(p,tag_set[i],l)&&
					(is_white_space(p[l])||p[l]=='+'||p[l]=='\0')) {

					for (j=0;j<strlen(tag_set[i+1]);j++) {
						tmp[s++]=tag_set[i+1][j];
					}
					for(j=0;strcmp(RES_josa[j],"$$$");j+=3) {
						int len1 = strlen(RES_josa[j]);
						int len2 = strlen(RES_josa[j+1]);

						if (!strncmp(tag_set[i],RES_josa[j],len1)
							&&!strncmp(p-1-len2,RES_josa[j+1],len2)) {
							tmp[s-RES_josa[j+2][0]+'0']=RES_josa[j+2][2];
						}
					}

					p+=l-1;
					break;
				}
			}
		} else {
			tmp[s++]=*p;
		}
	}
	tmp[s]='\0';

	strcpy(word,tmp);
	*(strstr(word,"/"))='\0';
	x = tdbm_fetch(casefrm,word,data);

// Ʋ ȣ ο 
	if (x>0&&flag ==1) {
//		printf("%s %s\n",word,data);
		p = strstr(tmp,"/");
		if (isdigit(data[2])&&isdigit(data[3])) {
			p[3]=data[2];
			p[4]=data[3];
		} else {
			p[3]='0';
			p[4]=data[2];
		}
	}

	strcpy(buf,tmp);
}

void rem_space(char *src)
{
	char tmp[8192];
	int s;
	char *p,prev;

	for (p=src+strlen(src);p>=src;p--)
		if (!(*p==' '||*p=='\t'||*p=='\n'||*p=='\r')) break;
		else *p='\0';
	
	prev = ' ';
	for (p=src,s=0;*p!='\0';p++) {
		if (prev!=*p) {
			tmp[s++]=*p;
		} else if (prev!=' ') {
			tmp[s++]=*p;
		}
	}
	tmp[s]='\0';
	strcpy(src,tmp);
}

int 
check_con(char *item,char *prev)
{
	char data[1024],tag[128],word[128];
	int x;
	char *p;

	if (tf_con == NULL) return 0;

	strcpy(data,item);

	p = strstr(data,"/");
	if (p!=NULL) { 
		*p = '\0';
		strcpy(word,data);
		strcpy(tag,p+1);
	} else {
		strcpy(tag,"");
		strcpy(word,"");
	}
	
	x = tdbm_fetch(tf_con,tag,data);

	if (x > 0) {

		return 1;
	}

	x = tdbm_fetch(tf_con,word,data);
	
	if (x > 0) {
		p = strstr(data,"\t");
		if (p==NULL) {
			if (!strcmp(tag,data)) return 1;
			else return 0;
		} else {
			*p = '\0';
			if (!strcmp(tag,data)) return 1;
			else return 0;
		}

		return 1;
	}

	return 0;
}

int 
cnv_input(char *sentence,FILE *in)
{
	char buf[1024];
	char prev[1024];
	char *p;
	int flag;

	flag = 0;
	sentence[0]='\0';
	while(fgets(buf,1024,in)!=NULL) {
		rem_space(buf);
		if (buf[0]=='\n'||buf[0]=='\r') {
			if (strstr(sentence," ./")!=NULL) {
				*(strstr(sentence," ./")) = '+';
				*(strstr(sentence,"+./")+9) = '\0';
			}

			return 1;
		} else {
			buf[strlen(buf)-1]='\0';
// ó... ----  buf,sentence ---
			if (strstr(buf,"jcr")!=NULL) {
				p = strstr(buf,"jcr");
				for (;p>=buf;p--) {
					if (*p=='+') {
						*p='+';
						break;
					}
				}
			}

			if (strstr(buf,"ecx")!=NULL) {
				flag = 1;
				strcpy(prev,buf);
			} else if (flag == 1) {
				flag = 0;
				if (strstr(buf,"px")!=NULL &&
					strstr(prev,"ecx")!=NULL) {
					cnv_tag(prev);
					strcat(sentence,prev);
					strcat(sentence,"+");
					cnv_tag(buf);
					strcat(sentence,buf);
					strcat(sentence," ");
				} else {
					cnv_tag(prev);
					strcat(sentence,prev);
					strcat(sentence," ");
					if (strstr(buf,"px")!=NULL) {
						char *p,tmp[1024];
						p = strstr(buf,"/px");
						*p = '\0';
						strcpy(tmp,buf);
						strcat(tmp,"/pvg");
						strcpy(tmp,p+3);
						strcpy(buf,tmp);
					}
					cnv_tag(buf);
					strcat(sentence,buf);
					strcat(sentence," ");
				}
			} else if (!check_con(buf,sentence)) {
				cnv_tag(buf);
				strcat(sentence,buf);
				strcat(sentence," ");
			} else {
				cnv_tag(buf);
				sentence[strlen(sentence)-1]='+';
				strcat(sentence,buf);
				strcat(sentence," ");
			}
		}
	}
	if (strstr(sentence," ./")!=NULL) {
		*(strstr(sentence," ./")) = '+';
		*(strstr(sentence,"+./")+9) = '\0';
	}
	return 0;
}

main()
{
	char    InputStr[512];
	int i;

	while(1) {
		i = cnv_input(InputStr,stdin);
		if (strlen(InputStr)>0) 
			printf("%s\n", InputStr);
		if (i==0) break;
	}
}


