/* KAIST tagger1999
 * 2000.12.5 last revised by yuntan
 * WP tagger v1.1
 * /
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "../share/trie.h"
#include "../share/global.h"

extern char *phtag(char *str);

#define MAXLINE 10000
#define TRUE	1
#define FALSE	0
#define SF	-4.60517018598809136803598290936873 /* log 0.01 */
#define EOS "eos"
#define BNK "bnk"


typedef struct MNode {
	// by jjaeh -  ̵Ͼ 
	//char mout_str[128];
	char mout_str[1024];
	char wp_tag[5];
	double prob_wt;
	double prob;
	int backptr;	/* for viterbi */
	int sibling;
} MNode;

typedef struct WPhead{
	char word[128];
	int mnode;
} WPhead;

WPhead wp[5000];
int wp_end=1;

MNode mn[10000];
int mn_end=1;

TDBM *pwt_tf, *ptt_tf, *pph_tf;
#include "node.h"

char  PWT_TDBM_FILE[256];	/* ¼   ܾ ߻Ȯ */
char  PTT_TDBM_FILE[256];	/* ¼Ұ  Ȯ */
char  PPH_TDBM_FILE[256];	/*   Ȯ */

int org_pos = 0;
char org_eojeol[5000][MAXLINE];

int new_wp(char *str)
{
	strcpy(wp[wp_end].word, str);
	wp[wp_end].mnode = 0;
	return wp_end++;
}

int new_mnode(char *str, char *wp_tag, double prob)
{
	strcpy(mn[mn_end].mout_str,str);
	strcpy(mn[mn_end].wp_tag, wp_tag);
	mn[mn_end].prob_wt=prob;
	mn[mn_end].backptr=0;
	mn[mn_end].sibling=0;
	return mn_end++;
}

void UpdateProbScore(int from, int to)
{
	static int cnt = 0;
	unsigned char data[256];
	unsigned char TTS[256];
	unsigned char wtS[256];
	double PTT, PWT;
	double P;
	int x;

	/*   Ȯ P(T_i,T_i-1)  
	*/
	sprintf(TTS,"----%s-%s",mn[from].wp_tag,mn[to].wp_tag);
	if (tdbm_fetch(pph_tf, TTS, data)>0) {
		PTT = atof((const char*)data);
	}
	else PTT = SF;
		/* 0.01 ڿα  	 Smoothing Factor */

	/*  Ȯ P(T_i) ش.  αװ̴ϱ 
	 * 	ִ  ٷ.*/
	if (tdbm_fetch(pph_tf, mn[to].wp_tag, data)>0) {
		PTT -= atof((const char*)data);
	}
	else {
	// jjaeh
	//fprintf(stderr, "̻ ... P(%s) ʴ´ٴ..", mn[from].wp_tag);
	}


	/*  Ȯ P(T_i-1) ش.  αװ̴ϱ 
	 * 	ִ  ٷ.*/
	if (tdbm_fetch(pph_tf, mn[from].wp_tag, data)>0) {
		PTT -= atof((const char*)data);
	}
	else {
	// jjaeh
	//fprintf(stderr, "̻ ... P(%s) ʴ´ٴ..", mn[from].wp_tag);
	}

	
	if (mn[from].backptr == 0) {
		mn[from].prob = mn[from].prob_wt;
	}
	P = mn[from].prob + PTT + mn[to].prob_wt;
#ifdef VIEW 	// ߰  Ȯ ְ 
	printf("%s(%d:%s) : %f -> %f -> %s(%d:%s) : %f\n", mn[from].mout_str, 
			from, mn[from].wp_tag, mn[from].prob, PTT, 
			mn[to].mout_str, to, mn[to].wp_tag, mn[to].prob_wt );
#endif
	/* տ Ȯ * Ȯ *  Ȯ
	 * PTT=P(T_i|T_i-1) / P(T_i)
	 * mn[to].prob_wt = P(T_i, W_i)
	 */
	if (mn[to].backptr == 0 || P > mn[to].prob) {
		mn[to].backptr = from;
		mn[to].prob = P; 
	}
//fprintf(stderr, "%d, %s\n", __LINE__, __FUNCTION__);
/*
	cout << cnt++ << " " << hmm.inf(from) << "->" << hmm.inf(to) << "\n"; 
*/
}

char *phrase_tag(char *str)
/* ܾ ִ  ¼Ҹ   ±
 *   θ.
 */
{
	char *p, *q;
	char words[2048];
	char morph[2048];
	char tag[2048];
	char tags[2048];
	static char wtag[5];
	char m[2048];


	p=front_word(words,str);
	if(p==NULL)
		fprintf(stderr, "ERROR! %s : pharase_tag\n", str);
	tags[0]=0;

	{
		int flag=0,i=0;
		for (p=words;*p!='\0';p++) {
			if (*p=='\\') p++;
			else if (*p=='+') {
				flag = 0;
				tags[i++]=' ';
			} else if (*p=='/') {
				flag = 1;
			} else if (flag != 0) {
				tags[i++]=*p;
				flag++;
				if (flag > 10) flag=0;
			}
		}
		tags[i]='\0';
	}

	/*
	for(p=front_token(morph,words,'+');p!=NULL;p=front_token(morph,p,'+')) {
		q=front_token(m,morph,'/');
		q=front_token(tag,q,'/');
		if(tags[0])
			strcat(tags," ");
		strcat(tags,tag);
	}
	*/
#ifdef DEBUG
	fprintf(stderr,"jj : %s %s %s\n",words,str, tags);
#endif
	strcpy(wtag,phtag(tags));
#ifdef DEBUG
	fprintf(stderr,"kk : %s %s\n",words,str);
	fflush(stderr);
#endif
	return(wtag);
}

const char sep[] = "+";
void end_sentence()
{
	char out_j_string[1024];
	char out_string[1024];
	char temp_string[MAXLINE];
	int i, j, k, t, a;
	char *p;
	char temp[1024];
	char data[1024];
	char data1[1024];
	char temp1[1024];

	// jjaeh
	char outStack[5000][1024];
	int pos = 0;
	int strNo = 0;

/*
	TDBM *tf;
	FILE *fpOut;
	fpOut = fopen("./test.txt","w");
	tf = tdbm_open("./KJDic",'r');
*/
	/*  带   Ѵ.*/
	i = new_wp(" ");
	wp[i].mnode = new_mnode(" ", "SF", 0);

	/*	ͺ .
	*/
	for(i=1;i<wp_end-1;i++)
	{
		for(j=wp[i].mnode;j!=0;j=mn[j].sibling)
		for(k=wp[i+1].mnode;k!=0;k=mn[k].sibling)
		{
			UpdateProbScore(j,k);
		}
	}
	
	//  Ѵ. 

	// by jjaeh - out_string   ϸ full .
/*
	out_string[0] = 0;
	for(k=wp[i].mnode;k!=0;k=mn[k].backptr)
	{
		strcpy(temp_string, out_string);
		printf(":%s\n", mn[k].mout_str);
		//sprintf(out_string, "%s\n%s", mn[k].mout_str, temp_string);
	}
	printf("%s", out_string);
*/

	// jjaeh -  迭 

	for(k=wp[i].mnode;k!=0;k=mn[k].backptr)
	{
		strcpy(outStack[pos++], mn[k].mout_str);
//printf("%d:%s\n",pos-1,outStack[pos-1]);
		//sprintf(outStack[pos++],"%s", mn[k].mout_str);
		//sprintf(out_string, "%s\n%s", mn[k].mout_str, temp_string);

	}

	
	pos-=2;	
	for(k=pos;pos>-1;pos--)
	{
		strNo = strlen(org_eojeol[k-pos]);
		
		if( org_eojeol[k-pos][strNo-1] == '\/') {
			org_eojeol[k-pos][strNo-1] = '\0';
		}
 
		printf("%s", org_eojeol[k-pos]);
		printf("%s\n",outStack[pos+1]);
	}
	printf("\n");

/*
	out_j_string[0] = 0;
	strcpy(data1, "");
	for(k=wp[i].mnode;k!=0;k=mn[k].backptr)
	{
	     strcpy(temp_string, out_j_string);
	     strcpy(temp1, mn[k].mout_str);

	     for(t=0;;t++){
	     	if( t == 0){
		   p = strtok(temp1, sep);
		   if(p == NULL) break;
		   strcpy(temp, p); 
		   p = strchr(temp, '//');

		   if(p == NULL){ printf("%s : error\n", temp); break;}

		   p[0] = '\0';
		   for(a = 0 ;;){
		      if(temp[a] == '\t')
		      	strcpy(temp, temp+1);
		      else break;
		      a++;
		   }
		  // printf("Code : %x\n", (int)temp[0]);
		  // printf("Word : %s\n", temp);
		   j = tdbm_fetch(tf, temp, data);
		   if(j > 0){
		 //  	printf("뿪 -> %s : %s\n", temp, data);
		  	strcat(data1, data); 
		   }
		   else {
		   	strcat(data1, temp);
		   }
		}
	     	else {
                   p = strtok(NULL, sep);
		   if(p == NULL) break;
		   strcpy(temp, p);
		   p = strchr(temp, '//');
		   if(p == NULL){ printf("%s : error\n", temp); break;}
		   p[0] = '\0';
		   for(a=0;;){
		   	if(temp[a] == '\t'){
			  strcpy(temp, temp+1);
			  printf("test");
			}
		  	else break;
			  a++;
		   }
		  // printf("Code : %x\n", (int)temp[0]);
		  // printf("Word : %s\n", temp);
		   j = tdbm_fetch(tf, temp, data);
	           if(j > 0){
		   //	printf("뿪 -> %s : %s\n", temp, data);
		   	strcat(data1, "+");
	                strcat(data1, data);
	           }
	           else {
		   	//printf("%s : %s\n", temp, data);
		   	strcat(data1, "+");
	                strcat(data1, temp);
	           }

		}
	     }

	     strcpy(temp1, data1);
	     printf(": %s\n뿪:%s", mn[k].mout_str, temp1);
	     sprintf(out_j_string, "%s\n%s", temp1, temp_string);
	}
	printf("%s", out_j_string);
	tdbm_close(tf);
	fclose(fpOut);
*/
}

get_dict()
{
	FILE *cfg;
	char _buf[1024],list[1024],fn[1024];
	int a=0;

	cfg=fopen("tagger.cfg","r");

	while(fgets(_buf,1024,cfg)!=NULL)
	{
		a++;
		sscanf(_buf,"%s %s",list,fn);
		if (*list=='#')	// remark
			continue;
		else
		{
			if (strcmp(list,"PWT")==0)
				strcpy(PWT_TDBM_FILE,fn);
			else if (strcmp(list,"PTT")==0)
				strcpy(PTT_TDBM_FILE,fn);
			else if (strcmp(list,"PPH")==0)
				strcpy(PPH_TDBM_FILE,fn);
			else fprintf(stderr,"error in line %d of tagger.cfg\n",a);
		}
	}
}
			

int main()
{
	char line[MAXLINE];
	char *flag_end;

	strcpy(PWT_TDBM_FILE,"../data/Stat/PWT_97.pos");
	strcpy(PTT_TDBM_FILE,"../data/Stat/PTT_97.pos");
	strcpy(PPH_TDBM_FILE,"../data/Stat/PTT.WP");
	//get_dict();	/*initialize dictionary file*/

	pwt_tf = tdbm_open(PWT_TDBM_FILE, 'r');
	pph_tf = tdbm_open(PPH_TDBM_FILE, 'r');
	ptt_tf = tdbm_open(PTT_TDBM_FILE, 'r');

	while((flag_end=gets(line))!=NULL)
	{


		/* int is_end_wp; */

		if(line[0]==0)
			continue;
/*
		else if (strncmp(line, "<num", 4) == 0) {
			// Ư .. ̹ õ   
			// * Ϲ ʿ  κ̴. 
			gets(line);
			printf("%s\n", line);
			gets(line); //  ϳ а
			while(gets(line) != NULL) {
				if (line[0] == 0) break;
				else printf("%s\n", line);
			}
			printf("\n");
			continue;
		}
*/
		else if (strcmp(line, "BOS") == 0)
			continue;
		else if (strcmp(line, "EOS") == 0) {
			end_sentence();
		
			/* ʱȭ ٽ  ش. */
			wp_end=1;
			mn_end=1;

			org_pos = 0;

			continue;
		}
//		else if(line[0]=='<' && line[strlen(line)-1] =='>')
		else if(line[0])
		{

			int v, w;
			char now_tag[5];
			int *sp;
			double probability;

			char* tmp_tok;

		// jjaeh
		strcpy(org_eojeol[org_pos++], &line[1]);
		//printf("line : [%d]=%s\n", org_pos-1, org_eojeol[org_pos-1]);


			/*⿡ head  */
			w=new_wp(line);
			/* is_end_wp = FALSE;
			 */
			sp=&wp[w].mnode;
			while(1)
			{
				if((flag_end = gets(line))==NULL)
					break;
				if(line[0]==0)
					break;
				
			/*	make sblings */
#ifdef DEBUG
				fprintf(stderr,"line%d : %s %d\n",__LINE__,line+1,mn_end);
				fflush(stderr);
#endif
				strcpy(now_tag, phrase_tag(line+1));
								// +1  ó tabڷ ϱ 
				/*
				if (strcmp(now_tag, "SF") == 0)
					is_end_wp = TRUE;
					  ΰ? */
				probability = compute_wt(line+1);
#ifdef DEBUG
				fprintf(stderr,"ss : %s %d\n",line+1,mn_end);
				fflush(stderr);
#endif
				v= new_mnode(line+1, now_tag, probability);
				*sp=v;
				sp=&mn[v].sibling;
#ifdef DEBUG
				printf("%s %d\n",line+1,mn_end);
				fflush(stdout);
#endif
			}
		}
	}

	tdbm_close(ptt_tf);
	tdbm_close(pwt_tf);
	tdbm_close(pph_tf);
}

