#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "trie.h"
#include "global.h"

extern char *phtag(char *str);

#define MAXLINE 2048
#define TRUE	1
#define FALSE	0
#define PWT_TDBM_FILE "../data/Stat/PWT_97.pos"
	/* ¼   ܾ ߻Ȯ */
#define PTT_TDBM_FILE "../data/Stat/PTT_97.pos"
	/* ¼Ұ  Ȯ */
#define PPH_TDBM_FILE "../data/Stat/PTT.WP"
	/*   Ȯ */

#define EOS "eos"
#define BNK "bnk"

typedef struct MNode {
	char mout_str[128];
	char wp_tag[5];
	double prob_wt;
	double prob;
	int backptr;	/* for viterbi */
	int sibling;
} MNode;

typedef struct WPhead{
	char word[128];
	int mnode;
} WPhead;

WPhead wp[1024];
int wp_end=1;

MNode mn[2048];
int mn_end=1;

TDBM *pwt_tf, *ptt_tf, *pph_tf;
#include "node.h"

int new_wp(char *str)
{
	strcpy(wp[wp_end].word, str);
	wp[wp_end].mnode = 0;
	return wp_end++;
}

int new_mnode(char *str, char *wp_tag, double prob)
{
	strcpy(mn[mn_end].mout_str,str);
	strcpy(mn[mn_end].wp_tag, wp_tag);
	mn[mn_end].prob_wt=prob;
	mn[mn_end].backptr=0;
	mn[mn_end].sibling=0;
	return mn_end++;
}

void UpdateProbScore(int from, int to)
{
	static int cnt = 0;
	unsigned char data[256];
	unsigned char TTS[256];
	unsigned char wtS[256];
	double PTT, PWT;
	double P;
	int x;

	/*   Ȯ P(T_i,T_i-1)  
	*/
	sprintf(TTS,"----%s-%s",mn[from].wp_tag,mn[to].wp_tag);
	if (tdbm_fetch(pph_tf, TTS, data)>0) {
		PTT = atof((const char*)data);
	}
	else PTT = -4.60517018598809136803598290936873;
		/* 0.01 ڿα  	 Smoothing Factor */

	/*  Ȯ P(T_i) ش.  αװ̴ϱ 
	 * 	ִ  ٷ.*/
	if (tdbm_fetch(pph_tf, mn[to].wp_tag, data)>0) {
		PTT -= atof((const char*)data);
	}
	else fprintf(stderr, "̻ ... P(%s) ʴ´ٴ..", mn[from].wp_tag);
	/*  Ȯ P(T_i-1) ش.  αװ̴ϱ 
	 * 	ִ  ٷ.*/
	if (tdbm_fetch(pph_tf, mn[from].wp_tag, data)>0) {
		PTT -= atof((const char*)data);
	}
	else fprintf(stderr, "̻ ... P(%s) ʴ´ٴ..", mn[from].wp_tag);

	
	if (mn[from].backptr == 0) {
		mn[from].prob = mn[from].prob_wt;
	}
	P = mn[from].prob + PTT + mn[to].prob_wt;
	printf("%s(%d:%s) : %f -> %f -> %s(%d:%s) : %f\n", mn[from].mout_str, 
			from, mn[from].wp_tag, mn[from].prob, PTT, 
			mn[to].mout_str, to, mn[to].wp_tag, mn[to].prob_wt );
	/* տ Ȯ * Ȯ *  Ȯ
	 * PTT=P(T_i|T_i-1) / P(T_i)
	 * mn[to].prob_wt = P(T_i, W_i)
	 */
	if (mn[to].backptr == 0 || P > mn[to].prob) {
		mn[to].backptr = from;
		mn[to].prob = P; 
	}
//fprintf(stderr, "%d, %s\n", __LINE__, __FUNCTION__);
/*
	cout << cnt++ << " " << hmm.inf(from) << "->" << hmm.inf(to) << "\n"; 
*/
}

char *phrase_tag(char *str)
/* ܾ ִ  ¼Ҹ   ±
 *   θ.
 */
{
	char *p, *q;
	char words[2048];
	char morph[2048];
	char tag[2048];
	char tags[2048];
	static char wtag[5];
	char m[2048];

	p=front_word(words,str);
	if(p==NULL)
		fprintf(stderr, "ERROR! %s : pharase_tag\n", str);
	tags[0]=0;
	for(p=front_token(morph,words,'+');p!=NULL;p=front_token(morph,p,'+')) {
		q=front_token(m,morph,'/');
		q=front_token(tag,q,'/');
		if(tags[0])
			strcat(tags," ");
		strcat(tags,tag);
	}
	strcpy(wtag,phtag(tags));
	return(wtag);
}

void end_sentence()
{
	char out_string[9999];
	char temp_string[9999];
	int i, j, k;

	/*  带   Ѵ.*/
	i = new_wp(" ");
	wp[i].mnode = new_mnode(" ", "SF", 0);

	/*	ͺ .
	*/
	for(i=1;i<wp_end-1;i++)
	{
		for(j=wp[i].mnode;j!=0;j=mn[j].sibling)
		for(k=wp[i+1].mnode;k!=0;k=mn[k].sibling)
		{
			UpdateProbScore(j,k);
		}
	}
	
	/*  Ѵ. */
	out_string[0] = 0;
	for(k=wp[i].mnode;k!=0;k=mn[k].backptr)
	{
		strcpy(temp_string, out_string);
		sprintf(out_string, "%s\n%s", mn[k].mout_str, temp_string);
	}
	printf("%s", out_string);
		/*  Ǿ ִ   ϱ ؼ */
}

int main()
{
	char line[MAXLINE];
	char *flag_end;

	pwt_tf = tdbm_open(PWT_TDBM_FILE, 'r');
	pph_tf = tdbm_open(PPH_TDBM_FILE, 'r');
	ptt_tf = tdbm_open(PTT_TDBM_FILE, 'r');

	while((flag_end=gets(line))!=NULL)
	{
		/* int is_end_wp; */

		if(line[0]==0)
			continue;
/*
		else if (strncmp(line, "<num", 4) == 0) {
			// Ư .. ̹ õ   
			// * Ϲ ʿ  κ̴. 
			gets(line);
			printf("%s\n", line);
			gets(line); //  ϳ а
			while(gets(line) != NULL) {
				if (line[0] == 0) break;
				else printf("%s\n", line);
			}
			printf("\n");
			continue;
		}
*/
		else if (strcmp(line, "BOS") == 0)
			continue;
		else if (strcmp(line, "EOS") == 0) {
			end_sentence();
			/* ʱȭ ٽ  ش. */
			wp_end=1;
			mn_end=1;
			continue;
		}
//		else if(line[0]=='<' && line[strlen(line)-1] =='>')
		else if(line[0])
		{
			int v, w;
			char now_tag[5];
			int *sp;
			double probability;

			char* tmp_tok;
			/*⿡ head  */
			w=new_wp(line);
			/* is_end_wp = FALSE;
			 */
			sp=&wp[w].mnode;
			while(1)
			{
				if((flag_end = gets(line))==NULL)
					break;
				if(line[0]==0)
					break;
				
			/*	make sblings */
				strcpy(now_tag, phrase_tag(line+1));
								// +1  ó tabڷ ϱ 
				/*
				if (strcmp(now_tag, "SF") == 0)
					is_end_wp = TRUE;
					  ΰ? */
				probability = compute_wt(line+1);
				v= new_mnode(line+1, now_tag, probability);
				*sp=v;
				sp=&mn[v].sibling;
			}
		}
	}

	tdbm_close(ptt_tf);
	tdbm_close(pwt_tf);
	tdbm_close(pph_tf);
}

