#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <string.h>
#include "HMM.h"

char rule_str[NUM_OF_RULE][4][32]={
{"pneu","RCr","0","Cr"}, //->
{"ation","aJg2","1","fuJg2"}, //Ƽ->̼
{"ate","aQ","1","fuQ"}, //Ʈ->Ʈ
{"bio","Hui","0","Haui"}, //->̿
{"ment","Gf2Qs","1","Ge2Qs"}, //Ʈ->Ʈ
{"ating","aQu7","1","fuQu7"}, // ->
{"ator","aQe","1","fuQe"}, //->
{"tatio","QaQui","1","QfuJg"}, //ŸƼ->̼
{"phore","RiF","1","Rie"}, // ->
{"fying","Pu7","1","Pau7"}, // ->
{"fied","Puf","1","PauD"}, // ǿ -> ̵
{"chon","Oi2","0","Pi2"}, //->
{"ed","fD","1","uD"}, // -> ̵
{"ated","fQfD","1","fuQuD"}, //׵ -> Ƽ
{"ness","CfJ","1","CuJ"} // ׽ -> Ͻ
};

/*
rule_str[0] = {"pneu","RCr","0","Cr"}; //->
rule_str[1] = {"ation","aJg2","1","fuJg2"}; //Ƽ->̼
rule_str[2] = {"ate","aQ","1","fuQ"}; //Ʈ->Ʈ
rule_str[3] = {"bio","Hui","0","Haui"}; //->̿
rule_str[4] = {"ment","Gf2Qs","1","Ge2Qs"}; //Ʈ->Ʈ
rule_str[5] = {"ating","aQu7","1","fuQu7"}; // ->
rule_str[6] = {"ator","aQe","1","fuQe"}; //->
rule_str[7] = {"tatio","QaQui","1","QfuJg"}; //ŸƼ->̼
rule_str[8] = {"phore","RiF","1","Rie"}; // -> 
rule_str[9] = {"fying","Pu7","1","Pau7"}; // ->
rule_str[10] = {"fied","Puf","1","PauD"}; // ǿ -> ̵
rule_str[11] = {"chon","Oi2","0","Pi2"}; //->
rule_str[12] = {"ed","fD","1","uD"}; // -> ̵
rule_str[13] = {"ated","fQfD","1","fuQuD"}; //׵ -> Ƽ
rule_str[14] = {"ness","CfJ","1","CuJ"}; // ׽ -> Ͻ
*/


void Init_Rule(){
	int i;
	for(i = 0; i < NUM_OF_RULE; i++){
		strcpy(rules[i].eng,rule_str[i][0]);
		strcpy(rules[i].kor,rule_str[i][1]);
		sscanf(rule_str[i][2],"%d",&rules[i].flag);
		strcpy(rules[i].target,rule_str[i][3]);
	}
}

float calculate_ca(char s[], char t[]){
	char syllable[128][8], syllable2[128][8];
	int Ls, Lt;
	int i,j;
	int match,in,del,sub;
	float ca;
	for(i = 0,j =0; i < strlen(s); i+=2){
		syllable[j][0]= s[i];
		syllable[j][1]= s[i+1];
		syllable[j][2]= '\0';
		j++;
	}
	Ls = j;

	for(i = 0,j =0; i < strlen(t); i+=2){
		syllable2[j][0]= s[i];
		syllable2[j][1]= s[i+1]; 
		syllable2[j][2]= '\0'; 
		j++; 
	} 
	Lt = j;

	if(Lt == Ls){
		in = 0;
	}
	else{
		if(Lt > Ls)
			in = Lt-Ls;
		else
			in = Ls-Lt;
	}

	match = 0;
	for(i = 0 ; i < Ls ; i++){
		for(j = 0; j < Lt; j++){
			if(!strcmp(syllable[i],syllable2[j])){
				j = Lt;
				match ++;
			}
		}
	}


	ca = (float)(Ls -(in+(Ls-match)));
	if(ca <0)
		return 0;
	else{
		ca /= Ls;
		return ca;
	}
}

float Evaluation(char res[], char sol[]){
	float ca;
	if(!strcmp(res,sol)){
		correct++;		  
		return 1;
	}
	else{
		ca = calculate_ca(res,sol);
		return ca;
	}
}

int Fetch_value(TDBM *tf, char word[]){
	 int z, num;
	 char data[256];
	
	 z = tdbm_fetch(tf,word,data);
	 if(z>0){
		sscanf(data,"%d",&num);
		return num;
	 }
	 else{
		return 0;
	 }
}

float Calc_Prob(TDBM *tf, char w1[], char w2[]){
	int prior, posterior;

	prior = Fetch_value(tf,w1);
	posterior = Fetch_value(tf,w2);
	if(prior == 0 || posterior == 0){
		return (float)SMOOTH;
	}
	else{
		return (float)posterior/(float)prior;
	}
}

float Calc_Lex_Prob(Node n1, Node n2, Node n3){
	char word1[256],word2[256];
	int  prior,poterior;
	float lex_prob, glex_prob,prob;
	// ei-1 ki-1 ki ei+1, ei-1 ki-1 ki ei ei+1
	sprintf(word1,"%s_%s#%s__%s",n1.kor,n2.kor,n1.eng, n3.eng);
	sprintf(word2,"%s_%s#%s_%s_%s",n1.kor,n2.kor,n1.eng,n2.eng,n3.eng);
	lex_prob = Calc_Prob(lex_tdb,word1,word2);
	// Genernlized Pnttern
	sprintf(word1,"%s_%s#%s__%s",n1.gen_kor,n2.kor,n1.gen_eng, n3.gen_eng);
	sprintf(word2,"%s_%s#%s_%s_%s",n1.gen_kor,n2.kor,n1.gen_eng,n2.eng,n3.gen_eng);
	glex_prob = Calc_Prob(lex_tdb,word1,word2);

	prob = (float)(LAMBDA*lex_prob+(1-LAMBDA)*glex_prob);
	return prob;
}

float Calc_Trans_Prob(Node n1, Node n2){
	char word1[256],word2[256];
	float trans_prob, gtrans_prob;

	sprintf(word1,"_%s",n1.kor);
	sprintf(word2,"_%s_%s",n1.kor,n2.kor);
	trans_prob = Calc_Prob(trans_tdb,word1,word2);
	/*
	sprintf(word1,"_%s",n1.gen_kor);
	sprintf(word2,"_%s_%s",n1.gen_kor,n2.kor);
	gtrans_prob = Calc_Prob(trans_tdb,word1,word2);
	trans_prob = LAMBDA*trans_prob + (1-LAMBDA)*gtrans_prob;
	*/
	return trans_prob;
}

void HMM(Node (*n)[128], int n_num, char kor_code[], char tag_code[]){
	int i,j,k;
	int idx, temp_idx, node_idx;
	float max;
	float temp_prob, temp_trans_prob, temp_lex_prob;
	int post_idx, post_node_idx;
	char result[256], temp[256], temp_tag[512], tag_result[512];
	

	for(i = 1; i < n_num; i++){
		for(k = 1; k < n[i][0].num; k++){
			idx = n[i][k].pre_idx;
			temp_idx = 0;
			max = (-1)*FLT_MAX;
			for(j = 1; j < n[idx][0].num; j++){
				//
				temp_trans_prob = Calc_Trans_Prob(n[idx][j],n[i][k]);
				if(i == n_num -1){
					temp_lex_prob = Calc_Lex_Prob(n[idx][j],n[i][k],n[i][k]);
				}
				else{
					temp_lex_prob = Calc_Lex_Prob(n[idx][j],n[i][k],n[i+1][1]);
				}
				temp_prob = (float)(log(temp_lex_prob)+log(temp_trans_prob));
				//if(i == n_num-1){
				//printf("%f\t%s:%s->%s:%s\tL:%f,T:%f,P:%f\n",n[idx][j].prob,n[idx][j].eng,n[idx][j].kor,n[i][k].eng,n[i][k].kor,log(temp_lex_prob),log(temp_trans_prob),temp_prob);
				//}
				// 
				//printf("%d,%d,%d:prob:%2.2f,max:%2.2f\n",i,j,k,temp_prob,max);
				temp_prob = n[idx][j].prob + temp_prob;
				//printf("%d,%d,%d:prob:%2.2f,[%d,%d],node_prob:%f max:%2.2f\n",i,j,k,temp_prob,idx,j,n[idx][j].prob,max);
				if(temp_prob > max){
				//	printf("Bingo\n");	
					temp_idx = j;
					max = temp_prob;
				}
			}
			//printf("[%d,%d][%s:%s]->[%d,%d][%s:%s]:%f\n",idx,temp_idx,n[idx][temp_idx].eng,n[idx][temp_idx].kor,i,k,n[i][k].eng,n[i][k].kor,max);
			n[i][k].prob = max;
			n[i][k].pre_node_idx = temp_idx;
		}
	}
	
	node_idx = n[n_num-1][1].pre_node_idx;
	idx = n_num-2; 
	strcpy(result,"");
	strcpy(tag_result,"");
	for(i = n_num-2; i > 0 ;){ // Viterbi Search
	//	printf("%d,%d:[%s/%s]\n",idx,node_idx,n[idx][node_idx].eng,n[idx][node_idx].kor);	
		// TAG Part
		sprintf(temp_tag,"[%s/%s]",n[idx][node_idx].eng,n[idx][node_idx].kor);	
		strcat(temp_tag," ");
		strcat(temp_tag,tag_result);
		strcpy(tag_result,temp_tag);
		// R Part
		strcpy(temp,n[idx][node_idx].kor);	
		if(!!strcmp(temp,"(")){
			strcat(temp,result);
			strcpy(result,temp);
		}
		temp_idx = n[idx][node_idx].pre_idx;
		node_idx = n[idx][node_idx].pre_node_idx;
		idx = temp_idx;
		i = idx;
	}
	strcpy(kor_code,result);
	strcpy(tag_code,tag_result);
}

void Generalize_ENG(char w[], char r[]){
		if(w[0] == 'a' || w[0] == 'e' || w[0] == 'i' ||
							 w[0] == 'o' || w[0] == 'u'){
				strcpy(r,"EV");
		}
		else if(w[0] == 'y' || w[0] == 'w' || w[0] == 'j'){
				strcpy(r,"ESV");
		}
		else if(w[0] == '$'){
				strcpy(r,"$");
		}
		else {
				strcpy(r,"EC");
		}
}

void Generalize_KOR(char w[], char r[]){
	if((isalpha(w[0]) && isupper(w[0])) || isdigit(w[0])){
		strcpy(r,"KC");
	}
	else if(w[0] == '$'){
			strcpy(r,"$");
	}
	else if(w[0] == '('){
			strcpy(r,"KN");
	}
	else{
		strcpy(r,"KV");
	}
}

int Assign_Node(char w[], Node n[], int k, int pre_idx){
	char data[256], temp[256];
	int  z;
	int  i,j;
	int  len;
	int  len2;
	z = tdbm_fetch(map,w,data);
	if(z>0){
		len = strlen(data);
		for(i = 0,j =0 ; i <= len ; i++){
			temp[j++] = data[i];
			if(data[i] == '|' || data[i] == '\0'){
				temp[j-1] = '\0';
				j = 0;
				strcpy(n[k].eng,w);
				strcpy(n[k].kor,temp);
//				len2 = strlen(n[i].eng);
//				if(len2 > 0)
				Generalize_ENG(n[i].eng,n[i].gen_eng);
				Generalize_KOR(n[i].kor,n[i].gen_kor);

				n[k].pre_idx = pre_idx;
				k++;
			}
		}
	}
	return k;
}

//int Put_Node(char w[], Node n[128][64]){
int Put_Node(char w[], Node (*n)[128]){
	int i,j,k;
	char temp[256], temp2[256], temp3[256];
	
	for(i = 0,j = 0; i <= strlen(w); i++){
		sprintf(temp,"%c",w[i]);
		if(i == 0){
			n[0][0].num = 2;
			for(k = 0 ; k < 2 ; k++){
				strcpy(n[j][k].eng,"$");
				strcpy(n[j][k].kor,"$");
				strcpy(n[j][k].gen_eng,"$");
				strcpy(n[j][k].gen_kor,"$");
				n[j][k].prob = 0;
			}
			j++;
			k = 1;
			strcpy(n[j][0].eng,temp);
			k = Assign_Node(temp,n[j],k,j-1);
			n[j][0].num = k;
			
		}
		else if(i == 1){
			k = 1;
			strcpy(n[j][0].eng,temp);
			k = Assign_Node(temp,n[j],k,j-1);
			sprintf(temp2,"%c%c",w[i-1],w[i]);
			k = Assign_Node(temp2,n[j],k,j-2);
			n[j][0].num = k;
		}
		else if(i == strlen(w)){
			n[j][0].num = 2;
			for(k = 0 ; k < 2 ; k++){
				strcpy(n[j][k].eng,"$");
				strcpy(n[j][k].kor,"$");
				strcpy(n[j][k].gen_eng,"$");
				strcpy(n[j][k].gen_kor,"$");
				n[j][k].pre_idx = j-1;
			}
		}
		else{
			k = 1;
			strcpy(n[j][0].eng,temp);
			k = Assign_Node(temp,n[j],k,j-1);
			sprintf(temp2,"%c%c",w[i-1],w[i]);
			k = Assign_Node(temp2,n[j],k,j-2);
			sprintf(temp3,"%c%c%c",w[i-2],w[i-1],w[i]);
			k = Assign_Node(temp3,n[j],k,j-3);
			n[j][0].num = k;
		}
		j++;
	}
	return j;
}

int Prefix(char eng[], char kor[], int rn){
	int len_eng, len_kor;
	char temp_kor[256], temp[256];
	int i,j;

	len_eng = strlen(eng);
	len_kor = strlen(kor);
	if(!strncmp(eng,rules[rn].eng,strlen(rules[rn].eng)) 
		&& !strncmp(kor,rules[rn].kor,strlen(rules[rn].kor))){

		strcpy(temp_kor,rules[rn].target);
		for(i = strlen(rules[rn].kor),j=0; i <= strlen(kor); i++){
			temp[j++] = kor[i];
		}
		strcat(temp_kor,temp);
		strcpy(kor,temp_kor);
		return 1;			
	}
	return 0;
}

int Postfix(char eng[], char kor[], int rn){
	int len_eng, len_kor;
	char eng_post[32], kor_post[32];
	int flag1, flag2;
	int i,j;
	char *loc, *loc2;
	if((loc = (char*)strstr(eng,rules[rn].eng)) != NULL &&
	   (loc2 = (char*)strstr(kor,rules[rn].kor)) != NULL){
		len_eng = strlen(rules[rn].eng);
		len_kor = strlen(rules[rn].kor);
		for(i = strlen(eng)-len_eng, j =0,flag1= 0; i <= strlen(eng); i++){
			if(eng[i] != rules[rn].eng[j++]){
				flag1 = 1;
			}
		} 

		for(i = strlen(kor)-len_kor, j =0, flag2=0; i <= strlen(kor); i++){
			if(kor[i] != rules[rn].kor[j++])
				flag2 = 1;
		}

		if(flag1 == 0 && flag2 == 0){
			for(j = 0,i = strlen(kor)-len_kor ; j <= strlen(rules[rn].target); j++){
				kor[i++]= rules[rn].target[j];
			}
			return 1;
		}
	}
	return 0;
}

int PostProcessing(char eng[], char kor[]){
	int i;	
	int flag;
	for(i = 0 ; i < NUM_OF_RULE; i++){
		if(rules[i].flag ==  1){
			flag = Postfix(eng,kor,i);
		}
		else{
			flag = Prefix(eng,kor,i);
		}
		if(flag == 1){
			//printf("Rule is Activated\t%d\n",i);
			return 1;
		}
	}
	return 0;
}

void Init_TDB(){
	lex_tdb = tdbm_open("./HMMResrc/lex_prob",'r');
	trans_tdb = tdbm_open("./HMMResrc/trans_prob",'r');
	map = tdbm_open("./HMMResrc/map",'r');
}

void Finalize_TDB(){
	tdbm_close(lex_tdb);
	tdbm_close(trans_tdb);
	tdbm_close(map);
}

void EK_Transliteration(char eng[], char kor[], char tag_code[]){
	char  kor_code[256];
	char  buff[256];
//	Node  HMM_Node[128][64];
	Node  (*HMM_Node)[128];
	int   node_num,sol_num, num;
	int i,j;
	HMM_Node = (Node*)malloc(sizeof(Node)*128*128);

	for(i = 0; i < 128; i++){
//		memset(HMM_Node[i], 0, sizeof(Node)*64);
		for(j = 0; j< 128; j++){
			strcpy(HMM_Node[i][j].eng, "");
			strcpy(HMM_Node[i][j].gen_eng, "");
			strcpy(HMM_Node[i][j].gen_kor, "");
			strcpy(HMM_Node[i][j].kor, "");
			HMM_Node[i][j].num = 0;
			HMM_Node[i][j].pre_idx = 0;
			HMM_Node[i][j].pre_node_idx =0;
			HMM_Node[i][j].prob =0;
		}
	}

	node_num = Put_Node(eng,HMM_Node);
	HMM(HMM_Node, node_num, kor_code, tag_code);
	PostProcessing(eng,kor_code);
	SB2K(kor_code,kor);
	free(HMM_Node);
}

static void DeleteSpace(char *line)
{
	char *p;
	int i, len;
	p = strchr(line, '\r');
	if(p != NULL) p[0] = '\0';
	p = strchr(line, '\n');
	if(p != NULL) p[0] = '\0';

	for(;;){
		if(line[0] == ' ' || line[0] == '\t')
			strcpy(line, line+1);
		else break;
	}
	len = strlen(line);
	for(i=len-1;i>=0;i--){
		if(line[i] == ' ' || line[i] == '\t')
			line[i] = '\0';
		else break;
	}
}

void INIT_HMM()
{
	Init_TDB();
	Init_Rule();
}

void END_HMM()
{
	Finalize_TDB();
}

void ek_trans_hmm_as_string(char *input, char *out)
{
	char  kor[256];
	char  buff[256],tag_code[512];
	int   node_num,sol_num, num;
	int i, len, j;
	int count;
	char data[1024*10];
	char lineBak[1024*10];
	char column[7][1024];
	char column1[7][1024];
	char value[1024*10];
	char  *p;
	int lineCount=0;
	//Init_TDB();
	//Init_Rule();

		strcpy(data, input);

		DeleteSpace(data);
		strcpy(lineBak, data);
		strcat(data, "\t");
		for(i = 0; i < 2;){
			len = strlen(data);
			for(j = 0; j < len; j++){
				if(data[j] == '\t'){
					data[j] = '\0';
					strcpy(value, data);
					strcpy(data, &data[j+1]);
					break;
				}
			}
			strcpy(column[i], value);
			i++;
		}
		strcpy(lineBak,  column[0]);
		len = strlen(column[0]);
		for(i = 0; i< len; i++){
			if(isupper(column[0][i]))
				column[0][i] = tolower(column[0][i]);
		}
		count =0;
		for(i=0;;i++){
			if(i==0){
				p = strtok(column[0], " ");
				if(p == NULL) break;
				strcpy(column1[count], p);
				count++;
			}
			else {
				p = strtok(NULL, " ");
				if(p == NULL) break;
				strcpy(column1[count], p);
				count++;

			}
		}
		strcpy(value, "");
		for(i=0; i  < count; i++){
			if(i == count-1){
				EK_Transliteration(column1[i],kor,tag_code);
				strcat(value, kor);
			}
			else {
				EK_Transliteration(column1[i],kor,tag_code);
				strcat(value, kor);
				strcat(value, " ");
			}
		}
		sprintf(out, "%s", value);
//		printf("%d\n", ++lineCount);
}

