/*----------------------------------------------------------------------
	global.c
	Ϲ Լ data 
----------------------------------------------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include "global.h"

/* for debug.. ( malloc, free )*/
void *_wp;
void *_wp_stack[MAX_MALLOC_STACK];
int _wp_sp=0;

void _wp_in(void *_wp)
{
	_wp_stack[_wp_sp++]=_wp;
	if(_wp_sp >= MAX_MALLOC_STACK)
	{
	    fprintf(stderr,"malloc trace stack overflow: %d\n",_wp_sp);
	    exit(1);
	}
}
void _wp_out(void *_wp)
{
	int i,j;

	for(i=_wp_sp;i>0;i--)
	{
		if(_wp_stack[i-1]==_wp)
		{
			for(j=i-1;j<_wp_sp-1;j++)
				_wp_stack[j]=_wp_stack[j+1];
			_wp_sp--;
			return;
		}
	}
	fprintf(stderr,"** not allocated : %d\n",_wp);
	exit(1);
}

/*----------------------------------------------
get a front word 

	ڿ space еǴ ܾ ϳ ãƳ.

	str:Է ڿ
	word:ڿ   ܾ
	return: ܾ  NULL
		ƴϸ  ܾ   ù° ܾ ġ
	 Լ : strtok, strstr, strchar
----------------------------------------------*/
char *front_word(word,str)
char *word,*str;
{
	*word=0;
	if(str == NULL)  return NULL;
	while(*str && __isspace(*str)) str++;
	if(*str == 0) return NULL;
 
	while(*str && !__isspace(*str))
		*word++ = *str++;
	*word=0;
	return str;                 

}
char *front_field(word,str)
char *word,*str;
{
    *word=0;
    if(str == NULL)  return NULL;
    if(*str == 0) return NULL;

    while(*str && *str != '\001')
	*word++ = *str++;
    *word=0;
    if(*str) str++;
    return str;

}

/*----------------------------------------------
is_in_list : Is item in the list ?
	list:ڿ
	item:
	return:item ġ (1,2,3,...n)
		 0;
in_list : Insert item to the list
	̹ item   ʴ° ġ
	returnѴ.
out_list : Delete item from the list
	return:ƹ͵ return  ʴ´.
----------------------------------------------*/
int is_in_list(unsigned char *list, unsigned char item)
{
        int i;
        for(i=0;list[i];i++)
                if(list[i]==item)
                        return i+1;
        return 0;
}
int in_list(unsigned char *list, unsigned char item)
{
        int i;
        for(i=0;list[i];i++) 
                if(list[i]==item)
                        return i+1;
        list[i]=item;
        list[i+1]=0;
        return i+1;
}
void out_list(unsigned char *list, unsigned char item)
{
        int i;
        for(i=0;list[i];i++)
                if(list[i]==item)
                        break;
        for(;list[i];i++)
                list[i]=list[i+1];
}

/*----------------------------------------------
  unsigned short type is, in, out
----------------------------------------------*/
int Sis_in_list(unsigned short *list, unsigned short item)
{
        int i;
        for(i=0;list[i];i++)
                if(list[i]==item)
                        return i+1;
        return 0;
}
int Sin_list(unsigned short *list, unsigned short item)
{
        int i;
        for(i=0;list[i];i++) 
                if(list[i]==item)
                        return i+1;
        list[i]=item;
        list[i+1]=0;
        return i+1;
}
void Sout_list(unsigned short *list, unsigned short item)
{
        int i;
        for(i=0;list[i];i++)
                if(list[i]==item)
                        break;
        for(;list[i];i++)
                list[i]=list[i+1];
}


/*----------------------------------------------------------------------
strp_cmp() function
	compare two strings with char **
----------------------------------------------------------------------*/
int strp_cmp(char **str1, char **str2)
{
	return strcmp(*str1,*str2);
}

int ustr_cmp(unsigned char *str1, unsigned char *str2)
{
    while(*str1 && *str2 && *str1==*str2)
    {
	str1++;
	str2++;
    }
    return (int) *str1 - (int) *str2;
}


/*---------------------------------------------------------------------- 
	general set functions
	Ϲ set ϴ 
	set_type global.h 

----------------------------------------------------------------------*/
int initset(set_type *set)
{
	return set->count=1;
}
int inset(set_type *set, char *name, char *data)
{
	int i,j,r,len;
	unsigned char *p;
/*
	for(i=set->count;i>1;i--)
		if(strcmp(name,set->name[i-1]) > 0)
			break;
		else
		{
			set->name[i]=set->name[i-1];
			set->data[i]=set->data[i-1];
		}
*/
	i=set->count;
	set->count++;
	set->name[i] = (char *)malloc(strlen(name)+1);
	strcpy(set->name[i],name);
	set->data[i] = (char *)malloc(strlen(data)+1);
	strcpy(set->data[i],data);
	r=i;

/* sort */
	p=set->data[i];
	len=strlen(p);
	for(i=0;i<len-1;i++)
	for(j=i+1;j<len;j++)
		if(p[i]>p[j])
		{
			unsigned char t;
			t=p[i];
			p[i]=p[j];
			p[j]=t;
		}

/* merge */
	for(i=0;i<len-1;)
	if(p[i]==p[i+1])
	{
		for(j=i+1;j<len;j++)
			p[j]=p[j+1];
		len--;
	}
	else i++;

	return r;
}

int freeset(set_type *set)
{
	int i;
	for(i=1;i<set->count;i++)
	{
		free(set->name[i]);
		free(set->data[i]);
	}
	set->count=1;
	return 1;
}

int setnum(set_type *set, char *name)
{
	int i;
	for(i=1;i<set->count;i++)
		if(strcmp(set->name[i],name)==0)
			break;
	if(i<set->count)
		return i;
	else
		return -1;
}

int setnum2(set_type *set, char *name)
{
	char **pos;
	pos = (char **)bsearch(&name, set->name+1, set->count-1,
		sizeof(char *) ,(int (*)(const void *,const void *))strp_cmp);
	if(pos == NULL)
		return -1;
	else
		return (int)(pos - (char**)set->name);
}

char *setdata(set_type *set, int num)
{
	return set->data[num];
}

/*---------------------------------------------------------------------- 
	character set functions
	andcset   set operation Ѵ.

	C=A&B;
	nA=A-B;
	nB=B-A;

	A={abcd},B={cdef}
	C={cd}
	nA={ab}
	nB={ef}
----------------------------------------------------------------------*/
void set_AND_SUB(unsigned char *A, unsigned char *B, 
	unsigned char *C, unsigned char *nA, unsigned char *nB)
{
        while(*A && *B)
                if(*A == *B)
                {
                        *C++ = *A++;
                        B++;
                }
                else if(*A < *B) *nA++ = *A++;
                else *nB++ = *B++;
        *C=0;
        while(*A) *nA++ = *A++; *nA=0;
        while(*B) *nB++ = *B++; *nB=0;
}

void set_OR(unsigned char *A, unsigned char *B, unsigned char *C)
{
        while(*A && *B)
                if(*A == *B)
                {
                        *C++ = *A++;
                        B++;
                }
                else if(*A < *B) *C++ = *A++;
                else *C++ = *B++;
        while(*A) *C++ = *A++;
        while(*B) *C++ = *B++;
	*C=0;
}

void set_AND(unsigned char *A, unsigned char *B, unsigned char *C)
{
        while(*A && *B)
                if(*A == *B)
                {
                        *C++ = *A++;
                        B++;
                }
                else if(*A < *B) A++;
                else B++;
	*C=0;
}
void set_SUB(unsigned char *A, unsigned char *B, unsigned char *C)
{
        while(*A && *B)
                if(*A == *B)
                {
                        A++;
                        B++;
                }
                else if(*A < *B) *C++ = *A++;
                else B++;
        while(*A) *C++ = *A++;
	*C=0;
}

int shortcmp(unsigned short *p, unsigned short *q)
{
	assert(p!=NULL && q!=NULL);
	while(*p == *q)
	{
		p++;
		q++;
	}
	return (int)*p - (int)*q;
}
int shortlen(unsigned short *p)
{
	unsigned short *q;
	assert(p!=NULL);
	q=p;
	while(*p)p++;
	return p-q;
}
unsigned short * shortcpy(unsigned short *p, unsigned short *q)
{
	unsigned short *r;
	assert(p!=NULL && q!=NULL);
	r=p;
	while(*q) *p++= *q++;
	*p=0;
	return r;
}
unsigned short * shortcat(unsigned short *p, unsigned short *q)
{
	unsigned short *r;
	assert(p!=NULL && q!=NULL);
	r=p;
	while(*p) p++;
	while(*q) *p++= *q++;
	*p=0;
	return r;
}
