#include <stdio.h>
#include "detect.h"
#include "HMM.h"

/*
extern void INIT_HMM();
extern void ek_trans_hmm_as_string(char*, char*);
extern void END_HMM();
*/

char *process_chi_eng(char *str);


void testTrans( char* inputS ) {
	char resultS[1024];
	ek_trans_hmm_as_string( inputS, resultS );
	printf( "%s -> %s\n", inputS, resultS );
}

int main() {
	char inputS[1024];
	char* inputSentence = " tennis ġ computer ϰ ʹ.";

	printf( "Transliteration: HMM Loading..\n" );
	INIT_HMM();
	printf( "Transliteration: HMM Loaded..\n" );

	testTrans( "sylvanite" );
	testTrans( "computer" );
	testTrans( "million" );
	testTrans( "company" );
	testTrans( "tennis" );
	testTrans( "copy" );
	testTrans( "ontology" );
	testTrans( "source" );
	testTrans( "art of illusion" );
	testTrans( "XML" );
	testTrans( "adobe" );
	testTrans( "photoshop" );
	testTrans( "Mr. Smith" );


	printf( "Before: %s\n", inputSentence );
	char* translated = process_chi_eng(inputSentence);
	printf( "After: %s\n", translated );

	END_HMM();
	printf( "Transliteration: HMM Unloaded..\n" );


	return 0;
}


//
/**
  *  м ռ ڿ   "HHHHH" "AAAAA" ġȯϴ óԼ
  * @param str[]  ġȯ  Ǵ 
  * return result ġȯ  ִ ڿ
 */
char *process_chi_eng(char *str)
{
	
	int i, j, h;
	char *result;
	char temp[100];
	char *gar;
	int flag, flag1;
	char each[100][4];
	int num;
	int hanja[100];
	char eng_word[255];
	char transResult[255];

	eng_word[0] = 0;
	i=j=0;
	flag=flag1=0;
	temp[0]=0;
	
	while (i<strlen(str))
	{
		h=han_type(str+i, gar);
		if (h==0) {
			strcpy(each[j], str+i);
			each[j][1]=0;
			j++;
			i++;
		}
		else { 
			strcpy(each[j], str+i);
			each[j][2]=0;
			j++;
			i=i+2;
		}
	}
	num=j;
	for (i=0;i<j; i++)
	{
		hanja[i]=han_type(each[i], gar);
		if (hanja[i]==-2) {
			if (flag!=1) {
				strcat(temp, "HHHHH");
				flag=1;
				flag1=0;
			}
		}
		else if (hanja[i]==0) {
			if (isalpha(each[i][0])) {
				hanja[i]=3;
				if (flag1!=1) {
					//strcat(temp, "AAAAA");
					flag1=1;
					flag=0;
					//printf( "each: %s\n", each[i] );
				}
				strcat( eng_word, each[i] );
			}
			else {
				
				strcat(temp, each[i]);
				
				flag=0;
				flag1=0;
			}
		}
		else {
			if( eng_word[0] != 0 ) {
				strcat( eng_word, "\n" );
				//printf( "eng_word: %s\n", eng_word );
				ek_trans_hmm_as_string( eng_word, transResult );
				strcat( temp, transResult  );
				eng_word[0] = 0;
			}	
			strcat(temp, each[i]);
			flag=0;
			flag1=0;
		}
	}
	result=temp;

//	printf( "\n ((%s)) \n", result );
	return result;

}
