#include <stdio.h>
#include <stdlib.h>
#include "./SRC/global.h"
#include "./SRC/trie.h"

typedef struct{
	char eng[16];	
	char kor[16];
	char gen_kor[16];
	char gen_eng[16];
	int  gh_flag;
}Align;

int split_gh_left(char data[], char l[], char r[]){
	int i,j,k;
	int idx;
	char temp[256];
	int  flag;

	flag = 0;
	for(i =0,j=0 ; i <= strlen(data); i++){
			temp[j++] = data[i];
			if(isupper(data[i])){
				temp[j-1] = '\0';
				j = 0;
				idx = i;
				flag = 1;
				break;
			}
	}

	if(flag == 1){
		strcpy(l,temp);
		for(i = idx,j=0; i <= strlen(data); i++){
			temp[j++] = data[i];
		}
		strcpy(r,temp);
	}
	return flag;

}

split(char data[], char l[], char r[]){
	int i,j, idx;
	int flag;
	char temp[256];
	if(strlen(data) == 2){
		sprintf(l,"%c",data[0]);
		sprintf(r,"%c",data[1]);
		return ;
	}
	else{
		flag = 0;	
		for(i =0,j=0 ; i <= strlen(data); i++){
			temp[j++] = data[i];
			if(isupper(data[i])){
				temp[j-1] = '\0';
				j = 0;
				idx = i;
				flag = 1;
				break;
			}
		}
		
		if(flag == 0){
			idx = 2;
			sprintf(temp,"%c%c",data[0],data[1]);
		}

		strcpy(l,temp);
		for(i = idx,j=0; i <= strlen(data); i++){
			temp[j++] = data[i];
		}
		strcpy(r,temp);
	}
	return;
}

int GH_Dectection(Align a[], int a_num, Align result[]){
	int i,j,k,l,m;
	int flag, s_flag;
	char temp[256];
	char left[32], right[32];
	char l_ph[32], r_ph[32];

	flag = 0;
	for(i = 2,j =1; i < a_num ; i++){
		if(a[i].gh_flag == 1){
			flag = 1;
			for(k = 0,l= 0; k<= strlen(a[i].eng); k++){
				temp[l++] = a[i].eng[k];	
				if(a[i].eng[k] == 'g' && a[i].eng[k+1] == 'h'){
					temp[l-1] = '\0';
					l = 0;
					strcpy(left,temp);
					k++;
				}
				else if(a[i].eng[k] == '\0'){
					temp[l-1] = '\0';
					l = 0;
					strcpy(right,temp);
				}
			}

			if(!strcmp(right,"")){ //  
				s_flag = split_gh_left(a[i].kor,l_ph,r_ph);
				if(s_flag == 1){
					strcpy(result[j].eng,left);
					strcpy(result[j].kor,l_ph);
					result[j].gh_flag= 0;
					j++;
					strcpy(result[j].eng,"gh");
					strcpy(result[j].kor,r_ph);
					result[j].gh_flag= 0;
					j++;
				}
				else{
					strcpy(result[j].eng,left);
					strcpy(result[j].kor,a[i].kor);
					result[j].gh_flag= 0;
					j++;
					strcpy(result[j].eng,"gh");
					strcpy(result[j].kor,"(");
					result[j].gh_flag= 0;
					j++;
				}
			}
			else if(!strcmp(left,"")){ //  
				strcpy(result[j].eng,right);
				strcpy(result[j].kor,a[i].kor);
				result[j].gh_flag= 0;
				j++;
				strcpy(result[j].eng,"gh");
				strcpy(result[j].kor,"(");
				result[j].gh_flag= 0;
				j++;
			}
			else{ // Ѵ 
				split(a[i].kor,l_ph, r_ph);
				strcpy(result[j].eng,left);
				strcpy(result[j].kor,l_ph);
				result[j].gh_flag= 0;
				j++;
				strcpy(result[j].eng,"gh");
				strcpy(result[j].kor,"(");
				result[j].gh_flag= 0;
				j++;
				strcpy(result[j].eng,right);
				strcpy(result[j].kor,r_ph);
				result[j].gh_flag= 0;
				j++;
			}
		}
		else{
			strcpy(result[j].eng,a[i].eng);
			strcpy(result[j].kor,a[i].kor);
			result[j].gh_flag=a[i].gh_flag;
			j++;
		}
	}

	/*
	if(flag == 1){
		for(i = 0; i < j ; i++){
			printf("%s",result[i].eng);
		}
		printf("\n");
		for(i = 0 ; i < j ; i++){
			printf("[%s/%s] ",result[i].eng,result[i].kor);
		}
		printf("\n");
	}
	*/
	strcpy(result[0].eng,"$");
	strcpy(result[0].kor,"$");
	strcpy(result[j].eng,"$");
	strcpy(result[j].kor,"$");
	j++;
	return j;
}

Insert_TDBM(TDBM *tf,char word[]){
	int i,z;
	int num;
	char data[256];

	z = tdbm_fetch(tf,word,data);
	if(z>0){
		sscanf(data,"%d",&num);
		num++;
		sprintf(data,"%d",num);
		tdbm_store(tf,word,data,TDBM_REPLACE);
	}
	else{
		sprintf(data,"1");
		tdbm_store(tf,word,data,TDBM_INSERT);
	}
}

int Check_Duplicate(char data[], char k[]){
	int i,j;
	char temp[256];
	for(i = 0, j = 0 ;i <= strlen(data); i++){
		temp[j++] = data[i];
		if(data[i] == '|' || data[i] == '\0'){
			temp[j-1] = '\0';	
			j = 0;
			if(!strcmp(temp,k)){
				return 1;
			}
		}
	}
	return 0;
}

Insert_Map(TDBM *map,char e[], char k[]){
	char data[512], data2[512];
	int  z;
	z= tdbm_fetch(map,e,data);
	if(z>0){
		if(!Check_Duplicate(data,k)){
			sprintf(data2,"%s|%s",data,k);
			tdbm_store(map,e,data2,TDBM_REPLACE);
		}
	}
	else{
		tdbm_store(map,e,k,TDBM_INSERT);
	}
}

Make_Transition(TDBM *trans, Align a1, Align a2, Align a3){
	char word[256];

	// Bigram Transition
	sprintf(word,"_%s",a2.kor);
	Insert_TDBM(trans,word);
	sprintf(word,"_%s_%s",a2.kor,a3.kor);
	Insert_TDBM(trans,word);
	//Trigram Transition
	sprintf(word,"%s_%s",a1.kor,a2.kor);
	Insert_TDBM(trans,word);
	sprintf(word,"%s_%s_%s",a1.kor,a2.kor,a3.kor);
	Insert_TDBM(trans,word);
	// Gen bigram
	sprintf(word,"_%s",a2.gen_kor);
	Insert_TDBM(trans,word);
	sprintf(word,"_%s_%s",a2.gen_kor,a3.kor);
	Insert_TDBM(trans,word);
	// Gen Trigram Transition
	sprintf(word,"%s_%s",a1.gen_kor,a2.gen_kor);
	Insert_TDBM(trans,word);
	sprintf(word,"%s_%s_%s",a1.gen_kor,a2.gen_kor,a3.kor);
	Insert_TDBM(trans,word);
}

Make_Lexical(TDBM *lex, Align a1, Align a2, Align a3){
	char word[256];
	// Bigram 1
	// ei-1 ki-1 ki, ei-1 ki-1 ki ei
	sprintf(word,"%s_%s#%s",a1.kor,a2.kor,a1.eng);
	Insert_TDBM(lex,word);
	sprintf(word,"%s_%s#%s_%s",a1.kor,a2.kor,a1.eng,a2.eng);
	Insert_TDBM(lex,word);
	// Generlized Pattern
	sprintf(word,"%s_%s#%s",a1.gen_kor,a2.kor,a1.gen_eng);
	Insert_TDBM(lex,word);
	sprintf(word,"%s_%s#%s_%s",a1.gen_kor,a2.kor,a1.gen_eng,a2.eng);
	Insert_TDBM(lex,word);
	// Bigram 2
	// ei-1 ki-1 ki ei+1, ei-1 ki-1 ki ei ei+1
	sprintf(word,"%s_%s#%s__%s",a1.kor,a2.kor,a1.eng, a3.eng);
	Insert_TDBM(lex,word);
	sprintf(word,"%s_%s#%s_%s_%s",a1.kor,a2.kor,a1.eng,a2.eng,a3.eng);
	Insert_TDBM(lex,word);
	// Generalized Pattern
	sprintf(word,"%s_%s#%s__%s",a1.gen_kor,a2.kor,a1.gen_eng,a3.gen_eng);
	Insert_TDBM(lex,word);
	sprintf(word,"%s_%s#%s_%s_%s",a1.gen_kor,a2.kor,a1.gen_eng,a2.eng,a3.gen_eng);
	Insert_TDBM(lex,word);

}

Make_TDBM(Align pair[], int a_num, TDBM *trans, TDBM *lex, TDBM *map){
	int i;
	for(i = 1; i< a_num; i++){
		// Transition Probability
		if(i == 1){
			Make_Transition(trans,pair[i-1],pair[i-1],pair[i]);
		}
		else{
			Make_Transition(trans,pair[i-2],pair[i-1],pair[i]);
		}

		// Lexical Probability
		if(i == a_num-1){
			Make_Lexical(lex,pair[i-1],pair[i],pair[i]);
		}
		else{
			Make_Lexical(lex,pair[i-1],pair[i],pair[i+1]);
		}
		// Mapping Result
		Insert_Map(map,pair[i].eng,pair[i].kor);
	}
}

/*
Generalize_ENG(char w[], char r[]){
	if(w[0] == 'a' || w[0] == 'e' || w[0] == 'i' ||
						 w[0] == 'o' || w[0] == 'u'){
			strcpy(r,"EV");
	}
	else if(w[0] == 'y' || w[0] == 'w' || w[0] == 'j'){
			strcpy(r,"ESV");
	}
	else if(w[0] == '$'){
			strcpy(r,"$");
	}
	else {
			strcpy(r,"EC");
	}
}
*/
/*
Generalize_KOR(char w[], char r[]){
	if((isalpha(w[0]) && isupper(w[0])) || isdigit(w[0])){
		strcpy(r,"KC");
	}
	else if(w[0] == '$'){
		strcpy(r,"$");
	}
	else if(w[0] == '('){
		strcpy(r,"KN");
	}
	else{
		strcpy(r,"KV");
	}
}
*/

Generalize_Feature(Align a[], int a_num){
	int i;
	for(i = 0 ; i < a_num ; i++){
		Generalize_ENG(a[i].eng,a[i].gen_eng);			
		Generalize_KOR(a[i].kor,a[i].gen_kor);			
	}
}

/*
main(){
	FILE *fp;
	int  i,j,k;
	char buff[256];
	int flag, t_flag;
	char temp[256];
	char eng[256], kor[256], eng_str[256];
	char *loc;
	char data[256];
	int   z;
	Align pair[512], eng_pair[256], kor_pair[256], temp_pair[256];
	int  pair_num, eng_pair_num, kor_pair_num;
	TDBM *trans, *lex, *map, *testdata;

	trans = tdbm_open("trans_prob",'w');
	lex = tdbm_open("lex_prob",'w');
	map  = tdbm_open("map",'w');
	testdata = tdbm_open("test",'w');
	fp = fopen("testdata.txt","r");
	if(fp == NULL){
		printf("Can't open the testdata\n");
		exit(0);
	}

	while(fgets(buff,256,fp) != NULL){
		buff[strlen(buff)-1] = '\0';
		z = tdbm_fetch(testdata,buff,data);
		if(z>0){
		}
		else{
			sprintf(data,"1");
			tdbm_store(testdata,buff,data,TDBM_INSERT);
		}
	}

	fclose(fp);

	//fp = fopen("monofilter.out","r");
	fp = fopen("bifilter.out","r");
	if(fp == NULL){
		printf("Can't open the file\n");
		exit(0);
	}

	flag = 0;
	while(fgets(buff,256,fp) != NULL){
		buff[strlen(buff)-1] = '\0';
		if(isdigit(buff[0])){
			flag++;
			if(flag == 1){
				strcpy(eng,buff);
				strcpy(eng_str,"");
				for(i = 0,j =0; i <= strlen(buff); i++){
					temp[j++] = buff[i];
					if(buff[i] == '\0' || buff[i] == ' '){
						temp[j-1] = '\0';
						j =0;
						if(isalpha(temp[0])){
							strcat(eng_str,temp);	  
						}
					}
				}
				z = tdbm_fetch(testdata,eng_str,data);
				if(z>0){
					t_flag = 1;
					//printf("%s\n",eng_str);
				}
				else{
					t_flag = 0;
				}
			}
			else if(flag == 2){
				if(t_flag == 0){
					for(i = 0,j=0,k =0 ; i <= strlen(eng); i++){ // eng_part;
						temp[j++] = eng[i];
						if(eng[i] == ' ' || eng[i] == '\0'){
							temp[j-1] ='\0';	
							j = 0;
							if(!!strcmp(temp,"")){
								if((loc = (char *)strstr(temp,"gh"))){
									if(!!strcmp(temp,"gh")){
										temp_pair[k].gh_flag = 1;
									}
								}
								else{
									temp_pair[k].gh_flag = 0;
								}
								strcpy(temp_pair[k++].eng,temp);
							}
						}
					}
					eng_pair_num = k;
	
					for(i = 0,j=0,k =0 ; i <= strlen(buff); i++){ //kor_part;
						temp[j++] = buff[i];
						if(buff[i] == ' ' || buff[i] == '\0'){
							temp[j-1] ='\0';	
							j = 0;
							if(!!strcmp(temp,"")){
								if(temp_pair[k].gh_flag == 1 && !strcmp(temp,"A"))
									temp_pair[k].gh_flag = 0;
								strcpy(temp_pair[k++].kor,temp);
							}
						}
					}
					pair_num = k;
					if(eng_pair_num == pair_num){
						pair_num = GH_Dectection(temp_pair,pair_num,pair);
						Generalize_Feature(pair,pair_num);
						Make_TDBM(pair,pair_num,trans,lex,map);
					}
				}
				flag = 0;
			}
		}
	}
	tdbm_close(trans);
	tdbm_close(lex);
	tdbm_close(map);
	tdbm_close(testdata);
	fclose(fp);
}
*/