#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "hantbl.h"


/*
int K2SB(char kor[],char kor_code[]){
	int i,j,m,len;
	int flag;
	char temp_k[32],temp_k2[32];
	unsigned char k[32], k_code[32]; 
	strcpy(kor_code,"");
	j = strlen(kor);
	for(i = 0 ; i < j; i += 2){
		temp_k[0] = (char)kor[i];
		temp_k[1] = (char)kor[i+1];
		temp_k[2] = '\0';
		k[0] = kor[i];
		k[1] = kor[i+1];
		k[2] = '\0';
		flag = kstobipron(k,k_code);
		if(flag == -1){
			printf("Can't convert [%s] [%s] in [%s]\n",temp_k,k,kor);
			return -1;
	   	}
		if(k_code[2] == '~'){
			k_code[2] = '\0';
		}
		len = strlen((char*)k_code);
		for(m = 0 ; m < len; m++){
			temp_k2[m] = (char)k_code[m];
		}
		temp_k2[m] = '\0';
		strcat(kor_code,temp_k2);
	}
	return 0;
}
*/

int is_jong(int c){
	if(ispunct(c) || isdigit(c))
		return 1;
	return 0;
}

int is_cho(int c){
	if(isupper(c))
		return 1;
	return 0;
}

int is_joong(int c){
	if(islower(c))
		return 1;
	return 0;
}


int jong_cmp(char s, char t){
	char jong_code[64];
	int  i,j;
	int  s_idx, t_idx;
    strcpy(jong_code,"~1()2[]{}3!@#$%^&45*<6>>78?90/|=");
	for(i = 0 ; i < strlen(jong_code); i++){
		if(s == jong_code[i])
			s_idx = i;
		if(t == jong_code[i])
			t_idx = i;
	}	
	return (s_idx-t_idx);
}

int bipron_cmp(char s[], char t[]){
	int i;
	for(i = 0; i < strlen(s); i++){
		if(i == 0 || i == 1){
			if(s[i] != t[i]){
				return (s[i] - t[i]);
			}		
		}
		else{
			if(s[i] != t[i]){
				return jong_cmp(s[i],t[i]);
			}
		}
	}
	return 0;
}

int binsearch4SB2K(char key[]){
		            
	int lower = 0;
	int upper = 2350;
	int mid;
	while (lower <= upper) {
		mid = (lower + upper) >> 1;
		//printf("%d:%s,%s,%d\n",mid,key,KS2BI[mid],bipron_cmp(key,KS2BI[mid]));
		if ( bipron_cmp(key,KS2BI[mid]) > 0)
			lower = mid + 1;
		else if (bipron_cmp(key,KS2BI[mid]) < 0)
			upper = mid - 1;
		else if (bipron_cmp(key,KS2BI[mid]) == 0)
			return mid;
	}
	return -1;
}

void Generalize_SB(char s[], char t[]){
	char joong_code[64], jong_code[64];	
	char temp_s[64];
	int  joong_idx, jong_idx;
	int  i;
	strcpy(temp_s,s);
    strcpy(jong_code,"~1()2[]{}3!@#$%^&45*<6>>78?90/-=");
    strcpy(joong_code,"abcdefghijklmnopqrstu");

	for(i = 0 ; i < strlen(jong_code); i++){
		if(s[2] == jong_code[i])
			jong_idx = i;
	}


	for(i = 0 ; i < strlen(joong_code); i++){
		if(s[1] == joong_code[i])
			joong_idx = i;
	}

	if(joong_idx < 4){
		temp_s[1] = 'a';	
	}
	else if(joong_idx < 8){
		temp_s[1] = 'e';	
	}
	else if(joong_idx < 13){
		temp_s[1] = 'i';	
	}
	else if(joong_idx < 18){
		temp_s[1] = 'n';	
	}

	if(jong_idx == 0){
		temp_s[2] = '~';
	}
	else if(jong_idx < 4){
		temp_s[2] = '1';	
	}
	else if(jong_idx < 7){
		temp_s[2] = '2';	
	}
	else if(jong_idx == 8 || jong_idx == 7){
		temp_s[2] == '{';
	}
	else if(jong_idx < 17){
		temp_s[2] = '3';	
	}
	else if(jong_idx == 19 || jong_idx == 20){
		temp_s[2] = '5';	
	}
	else if(jong_idx == 22){
		temp_s[2] = '6';	
	}
	else if(jong_idx == 25 || jong_idx == 26){
		temp_s[2] = '8';	
	}
	else if(jong_idx == 27){ // ''
		temp_s[2] = '1';	
	}
	else if(jong_idx == 28){ // ''
		temp_s[2] = '{';	
	}
	else if(jong_idx == 29){ // ''
		temp_s[2] = '5';	
	}
	else if(jong_idx == 30){ // ''
		temp_s[2] = '~';	
	}

	strcpy(t,temp_s);
}

void SB2KorStr(char s[], char t[]){
	int i;
	int idx;
	char gen_s[32];
	unsigned char kor_code[32];
	unsigned int  code, code2;
	idx = binsearch4SB2K(s);
	if(idx == -1){
		Generalize_SB(s,gen_s);
		idx = binsearch4SB2K(gen_s);
		if(idx == -1){
			printf("Can't find Gen Kor for [%s]\n",s);
			exit(0);
		}
	}
	code = KSC2CS[idx][1];
	code2 = code;
	code >>= 8;
	code2 <<= 8;
	code2 >>= 8;
	kor_code[0] = (unsigned char) code;
	kor_code[1] = (unsigned char) code2;
	kor_code[2] = '\0';

	t[0] = (char)kor_code[0];
	t[1] = (char)kor_code[1];
	t[2] = '\0';
	//printf("Conv:[%s],[%s],[%s]\n",s,t,kor_code);
}

void Generate_Normalize_SB(char s[], char t[]){
	int i,j,idx;
	idx = 0;

	//printf("%c, %d\n",s[idx],is_cho(s[idx]));

	if(is_cho(s[idx])){
		t[0] = s[idx];
		idx++;
	}
	else{
		t[0] = 'L';
	}	

//	printf("%c, %d\n",s[idx],is_joong(s[idx]));
	if(is_joong(s[idx])){
		t[1] = s[idx];
		idx++;
	}
	else{
		t[1] = 's';
	}

//	printf("%c, %d\n",s[idx],is_jong(s[idx]));
	if(is_jong(s[idx]) && s[idx] != '\0'){
		t[2] = s[idx];
		idx++;
	}
	else{
		t[2] = '~';
	}
	t[3] ='\0';
//	printf("Boundary:%s,%s\n",s,t);
}

void SB2K(char s[], char t[]){
	int i,j;
	char temp[256], nor_sb[16], kor_str[16];
	char temp_kor[256];
	strcpy(t,"");
	strcpy(temp_kor,"");
//	printf("Word:%s\n",s);
	for(i =0, j =0; i < strlen(s); i++){
		temp[j++] = s[i];
		if(i != 0){
			if(is_jong(s[i-1])){
				temp[j-1] = '\0';
				j = 0;
				Generate_Normalize_SB(temp,nor_sb);				
				SB2KorStr(nor_sb,kor_str);
				strcat(temp_kor,kor_str);
				strcat(t,nor_sb);
				temp[j++] = s[i];
			}
			else if(is_joong(s[i-1])){
				if(!is_jong(s[i])){
					temp[j-1] = '\0';
					j =0;
					Generate_Normalize_SB(temp,nor_sb);				
					SB2KorStr(nor_sb,kor_str);
					strcat(t,nor_sb);
					strcat(temp_kor,kor_str);
					temp[j++] = s[i];
				}
			}
			else if(is_cho(s[i-1])){
				if(is_cho(s[i])){
					temp[j-1] = '\0';
					j =0;
					Generate_Normalize_SB(temp,nor_sb);				
					SB2KorStr(nor_sb,kor_str);
					strcat(temp_kor,kor_str);
					strcat(t,nor_sb);
					temp[j++] = s[i];
				}
			}
		}
	}
	temp[j] = '\0';
	Generate_Normalize_SB(temp,nor_sb);				
	SB2KorStr(nor_sb,kor_str);
	strcat(temp_kor,kor_str);
	strcat(t,nor_sb);
	strcpy(t,temp_kor);
}


/*
main(){
	FILE *fp;
	char buff[256];
	char eng[256], gk[256], kor[256];
	int  flag;
	int  i,j;
	char temp[256], kor_kor[256], gk_kor[256];

	fp = fopen("bbb","r");
	if(fp == NULL){
		printf("Can't open the file\n");
		exit(0);
	}

	while(fgets(buff,256,fp) != NULL){
		buff[strlen(buff)-1] = '\0';
		printf("%% %s\n",buff);
		flag = 0;
		for(i = 0, j =0; i <= strlen(buff) ; i++){
			temp[j++] = buff[i];
			if(buff[i] == '\t' || buff[i] == '\0'){
				temp[j-1] = '\0';
				j = 0;
				if(flag == 0){
					strcpy(eng,temp);
				}
				else if(flag == 1){
					strcpy(gk,temp);
				}
				else{
					strcpy(kor,temp);
				}
				flag++;
			}
		}
		SB2K(gk,gk_kor);
		SB2K(kor,kor_kor);
		printf("%s,gk[%s,%s],k[%s,%s]\n",eng,gk,gk_kor,kor,kor_kor);
	}
}
*/
