#include <stdio.h>
#include "../src/share/dcache.h"
#include "../src/share/trie.h"
#include "../src/share/global.h"

TDBM *tf;

char line[1024];
char processing[1000][1024];
int p_end=0;

action()
{
    int i;

    if(p_end==0)
		return;

    puts(processing[0]);
    for(i=1;i<p_end;i++)
		printf("\t%s\n",processing[i]);
    puts("");
    p_end=0;
}

int ischange(char *s1, char *s2)
{
    int y;
    y=tdbm_fetch(tf,s1,s2);
    if(y>0)
		return 1;
    else
		return 0;
}

char tmpword[1024];
char tmptag[1024];
char tmpstr[1024];
char nextmorph[1024];
char twomorph[1024];
char tmpmorph[1024];
char buff[1024];

morph_in(char *str)
{
    char *p, *q, *r;
    int i=0;

	if(*str=='\t')
		str++;

    tmpstr[0]=0;
	
	// ¼ м  1   ¼ҿ Ͽ
    for( p=front_morph(tmpmorph,str); p!=NULL;p=front_morph(tmpmorph,p))
    {
		r=front_morph(nextmorph,p);
		if(r!=NULL)
		{
			strcpy(twomorph,tmpmorph);
			strcat(twomorph,"+");
			strcat(twomorph,nextmorph);
			if(ischange(twomorph,buff))
			{
				strcpy(tmpstr+i,buff); i+=strlen(buff);
				strcpy(tmpstr+i,"+"); i++;
				p=r;
				continue;
			}
		}
		if(ischange(tmpmorph,buff))
		{
			strcpy(tmpstr+i,buff); i+=strlen(buff);
		}
		else
		{
			q=front_wt(tmpword,tmpmorph);
			strcpy(tmptag,q);

			if(ischange(tmpword,buff))
			{
				strcpy(tmpstr+i,buff); i+=strlen(buff);
			}
			else
			{
				strcpy(tmpstr+i,tmpword); i+=strlen(tmpword);
			}
			strcpy(tmpstr+i,"/"); i++;
			if(ischange(tmptag,buff))
			{
				strcpy(tmpstr+i,buff); i+=strlen(buff);
			}
			else
			{
				strcpy(tmpstr+i,tmptag); i+=strlen(tmptag);
			}
		}
		strcpy(tmpstr+i,"+"); i++;
    }
    tmpstr[i-1]=0;

    for(i=1;i<p_end;i++)
		if(strcmp(processing[i],tmpstr)==0)
			break;
    if(i<p_end)
		;
    else
    {
		strcpy(processing[p_end],tmpstr);
		p_end++;
    }
}

word_in(char *str)
{
    if(p_end)
		action();

    strcpy(processing[0],str);
    p_end=1;
}
    
main(int argc, char *argv[])
{

    p_end=0;

    if(argc == 2)
		tf= tdbm_open(argv[1],'r');
    else
    {
		fprintf(stderr,"usage: %s dictfile < testfile\n",argv[0]);
		return;
    }
    if(tf==NULL)
    {
		fprintf(stderr,"dictfile '%s' is not exist\n",argv[1]);
		return;
    }

	while(gets(line) != NULL)
    {
		if(line[0]==0)
			action();
		else if(isspace(line[0]))
			morph_in(line);
		else
			word_in(line);
    }
    action();
    tdbm_close(tf);
}

